#include  <windows.h>
#include "api.h"

HINSTANCE hDll = 0;

Init_type Init=0;
Done_type Done=0;
UpdateConfiguration_type UpdateConfiguration=0;
GetConfigSetting_type GetConfigSetting=0;
SetConfigSetting_type SetConfigSetting=0;
BackupConfig_type BackupConfig=0;
RestoreConfig_type RestoreConfig=0;
GetDomainCount_type GetDomainCount=0;
GetDomainList_type GetDomainList=0;
GetDomainName_type GetDomainName=0;
GetDomainIndex_type GetDomainIndex=0;
LoadDomain_type LoadDomain=0;
SaveDomain_type SaveDomain=0;
AddDomain_type AddDomain=0;
RenameDomain_type RenameDomain=0;
DeleteDomain_type DeleteDomain=0;
GetDomainSetting_type GetDomainSetting=0;
SetDomainSetting_type SetDomainSetting=0;
GetDomainIP_type GetDomainIP=0;
SetDomainIP_type SetDomainIP=0;
GetUserCount_type GetUserCount=0;
GetUserList_type GetUserList=0;
GetUserIndex_type GetUserIndex=0;
LoadUser_type LoadUser=0;
SaveUser_type SaveUser=0;
AddUser_type AddUser=0;
DeleteUser_type DeleteUser=0;
GetUserSetting_type GetUserSetting=0;
SetUserSetting_type SetUserSetting=0;
AuthenticateUser_type AuthenticateUser=0;
APIInitUsers_type APIInitUsers=0;
APINextUser_type APINextUser=0;
APIDoneUsers_type APIDoneUsers=0;

int DLLInit()
{
    hDll = LoadLibrary("API.dll");

    Init = (Init_type)GetProcAddress(hDll, "Init");
    Done = (Done_type)GetProcAddress(hDll, "Done");
    UpdateConfiguration = (UpdateConfiguration_type)GetProcAddress(hDll, "UpdateConfiguration");
    GetConfigSetting = (GetConfigSetting_type)GetProcAddress(hDll, "GetConfigSetting");
    SetConfigSetting = (SetConfigSetting_type)GetProcAddress(hDll, "SetConfigSetting");
    BackupConfig = (BackupConfig_type)GetProcAddress(hDll, "BackupConfig");
    RestoreConfig = (RestoreConfig_type)GetProcAddress(hDll, "RestoreConfig");
    GetDomainCount = (GetDomainCount_type)GetProcAddress(hDll, "GetDomainCount");
    GetDomainList = (GetDomainList_type)GetProcAddress(hDll, "GetDomainList");
    GetDomainName = (GetDomainName_type)GetProcAddress(hDll, "GetDomainName");
    GetDomainIndex = (GetDomainIndex_type)GetProcAddress(hDll, "GetDomainIndex");
    LoadDomain = (LoadDomain_type)GetProcAddress(hDll, "LoadDomain");
    SaveDomain = (SaveDomain_type)GetProcAddress(hDll, "SaveDomain");
    AddDomain = (AddDomain_type)GetProcAddress(hDll, "AddDomain");
    RenameDomain = (RenameDomain_type)GetProcAddress(hDll, "RenameDomain");
    DeleteDomain = (DeleteDomain_type)GetProcAddress(hDll, "DeleteDomain");
    GetDomainSetting = (GetDomainSetting_type)GetProcAddress(hDll, "GetDomainSetting");
    SetDomainSetting = (SetDomainSetting_type)GetProcAddress(hDll, "SetDomainSetting");
    GetDomainIP = (GetDomainIP_type)GetProcAddress(hDll, "GetDomainIP");
    GetDomainIP = (GetDomainIP_type)GetProcAddress(hDll, "GetDomainIP");
    GetUserCount = (GetUserCount_type)GetProcAddress(hDll, "GetUserCount");
    GetUserList = (GetUserList_type)GetProcAddress(hDll, "GetUserList");
    GetUserIndex = (GetUserIndex_type)GetProcAddress(hDll, "GetUserIndex");
    LoadUser = (LoadUser_type)GetProcAddress(hDll, "LoadUser");
    SaveUser = (SaveUser_type)GetProcAddress(hDll, "SaveUser");
    AddUser = (AddUser_type)GetProcAddress(hDll, "AddUser");
    DeleteUser = (DeleteUser_type)GetProcAddress(hDll, "DeleteUser");
    GetUserSetting = (GetUserSetting_type)GetProcAddress(hDll, "GetUserSetting");
    SetUserSetting = (SetUserSetting_type)GetProcAddress(hDll, "SetUserSetting");
    AuthenticateUser = (AuthenticateUser_type)GetProcAddress(hDll, "AuthenticateUser");
    APIInitUsers = (APIInitUsers_type)GetProcAddress(hDll, "APIInitUsers");
    APINextUser = (APINextUser_type)GetProcAddress(hDll, "APINextUser");
    APIDoneUsers = (APIDoneUsers_type)GetProcAddress(hDll, "APIDoneUsers");

	return (int)hDll;
}    

void DLLFree()
{
  if ((int)hDll) FreeLibrary(hDll);
  hDll = 0;
}
