<?php
  function authenticateuser($user, $pass)
  {
    global $mailserver;
    $result = false;

    list($fdomain, $username) = explode("/", $user);
    if ($username) $user = $username;

    $confighost = $mailserver;
    $protocol = "";
    list($host, $mailbox) = explode(",", $confighost);
    if (!$mailbox)
    {
      $mailbox = "INBOX";
      $protocol = "/pop3";
    }

    list($host, $port) = explode(":", $host);
    if ($port) $port = ":" . $port;
    $host = '{' . $host . $port . $protocol . '}' . $mailbox;

    if (@$imap = imap_open($host, $user, $pass))
    {
      @imap_close($imap);
      $result = true;
    }

    return $result;
  }

///////////////////////////////////////
// virtualhosts manager
  function vhostmanager($virtualhost,$vhadd="",$vhedit="",$vhdelet=""){
     global $currentvirtualhost;

     if ($vhadd || $vhedit) {
        $virtualhost = trim(strtolower($virtualhost));
        if(!ereg("^([a-z0-9\._\-])+$",$virtualhost)) return $currentvirtualhost;
     }

     $fhost = installpath . cfgdir . virtualsettingfile;
     $vfdata = array();
     if (file_exists($fhost)) {
        $vfdata = file($fhost);
        $vfdata = array_map('trim', $vfdata);
     }

     //delete VH
     if ($vhdelet) {
        foreach ($vfdata as $vfk => $vfv){
           $vfv = trim(strtolower($vfv));
           if ($vfv===$currentvirtualhost){
              unset($vfdata[$vfk]);
              @unlink(installpath . cfgdir . hostfile . $vfv . datext);
              $save = true;
              $currentvirtualhost = '';
              break;
           }
        }
     }
    //add VH
     elseif ($vhadd) {
        foreach ($vfdata as $vfk => $vfv){
           $vfv = trim(strtolower($vfv));
           if ($vfv===$virtualhost) return $currentvirtualhost;
        }
        $vfdata[]=$virtualhost;
        $save = true;
        $currentvirtualhost = $virtualhost;
     }
     //edit VH
     elseif($vhedit) {
        foreach ($vfdata as $vfk => $vfv){
           $vfv = trim(strtolower($vfv));
           if ($vfv===$currentvirtualhost) {
              $vfdata[$vfk] = $virtualhost;
              $save = true;
              $currentvirtualhost = $virtualhost;
              break;
           }
        }
     }

     if ($save) {
        if (!count($vfdata))
           @unlink($fhost);
        elseif (@$handle = fopen($fhost, 'wb')) {
           natsort($vfdata);
           @fputs($handle,implode("\r\n",$vfdata));
           @fclose($handle);
        }
     }

     return $currentvirtualhost;
  }
///////////////////////////////////////
// make category list for category.html
function getcategories($cal_events,$string="",$type="")
{
  if($string)
  {
    $string=explode(";",$string);
    array_map("trim",$string);
  }

  $i=0;
  foreach ($cal_events as $v)
  {
    $v=htmlspecialchars(trim($v));

    if($type=="option")
      $ret.='<option value="'.$v.'" '.(is_array($string) && in_array($v,$string)?'selected':'').'>'.$v."</option>\r\n";
    else
      $ret.='<div><input type="checkbox" name="item[]" onclick="add2categorylist(this)" value="'.$v.'" id="x_itm'.$i.'" '.(is_array($string) && in_array($v,$string)?'checked':'').'><label for="x_itm'.$i.'" '.$class.'>'.$v."</label></div>\r\n";
    $i++;
  }

  return $ret;
}
////////////////////////////////////////////
// makes Array from string divided by ; or , (categories)
function convertcategory($usercategory)
{
    $usercat= Array();

    $usercategory=str_replace(",",";",str_replace(",",";",$usercategory));
    $usercategory=ereg_replace("(;;+)",";",$usercategory);
    if(!trim($usercategory)) return $usercat;

    $usercat=explode(";",$usercategory);
    array_map("trim",$usercat);

    return $usercat;
}
///////////////////////////////////////////////////
//Search for all chosen Categories in element array
function getevncategory($items,$key='EVNTYPE')
{
  $categoryies= array();
  if(!is_array($items)) return $categoryies;

  foreach($items as $val)
  {
    if(trim($val[$key]))
    {
      $values=preg_split("/[,;]/",$val[$key]);
      foreach($values as $v) $categoryies[trim($v)]+=1;
    }
  }

  if(count($categoryies)) ksort($categoryies);
  return $categoryies;
}

///////////////////////////////////////

function getvirtualhostpath($filename)
{
  global $virtualhosts, $currentvirtualhost;
  $filename = installpath . cfgdir . $filename;
  if (count($virtualhosts)) if (isvirtualhost($currentvirtualhost)) $filename .= "." . trim($currentvirtualhost) . datext;
  return $filename;
}

function getcidstring($file, $encoding, $line, $folder, $messageid,$id)
  {
    $linenext = fgets($file, 1024);
    if (strtolower($encoding) == "base64") $linenext = base64_decode($linenext);
    else
    if (strtolower($encoding) == "quoted-printable") $linenext = convertquoted(rtrim($linenext));
    $line .= $linenext;

    $xpos = strpos(strtolower($line), cidtext);
    $linea = substr($line, 0, $xpos);
    $fl = strlen($line);
    for ($i=$xpos;$i<$fl;$i++)
    {
      if (($line[$i] == " ") || ($line[$i] == "\"") || ($line[$i] == ">") || ($i == $fl))
      {
        $cid = substr($line, $xpos + 4, $i - $xpos - 4);
        $lineb = substr($line, $i, strlen($line));
        break;
      }
    }
    return $linea . "attachment.html?id=" . $id . "&messageid=" . rawurlencode($messageid) . "&cid=" . rawurlencode($cid) . "&folder=" . rawurlencode($folder) . $lineb;
  }


  function saveconfiginfo($server, $port, $default, $iso, $selfcreate, $fbackgroundcolor, $integrate, $domain, $logox, $logoy, $dleavemessages, $headerfooter, $headerfile, $footerfile, $diskquota, $diskquotasize, $otherconfig )
  {
    global $currentvirtualhost, $globalsettingsfile;
    if (isvirtualhost($currentvirtualhost))
          $filename = installpath . cfgdir . hostfile . trim($currentvirtualhost) . datext;
        else
          $filename = $globalsettingsfile;
    if (@$file = fopen($filename, "wb"))
    {
      fputs($file, $server . "\r\n");
      fputs($file, $port . "\r\n");
      fputs($file, $default . "\r\n");
      fputs($file, $iso . "\r\n");
      fputs($file, "\r\n");
      fputs($file, $selfcreate . "\r\n");
      fputs($file, $fbackgroundcolor . "\r\n");
      fputs($file, $integrate . "\r\n");
      fputs($file, $domain . "\r\n");
      fputs($file, $logox . "\r\n");
      fputs($file, $logoy . "\r\n");
      fputs($file, $dleavemessages . "\r\n");
      fputs($file, $headerfooter . "\r\n");
      fputs($file, $headerfile . "\r\n");
      fputs($file, $footerfile . "\r\n");
      fputs($file, $diskquota . "\r\n");
      fputs($file, $diskquotasize . "\r\n");

      while(list($index,) = each($otherconfig)){
        fputs($file, $otherconfig[$index] . "\r\n");
      }

      fclose($file);
    }
    getconfiginfo($virtualhost);
  }


  function isabovechar($string)
  {
    for ($i = 0; $i < strlen($string); $i++) if (ord($string[$i]) > 127) { return true; }
    return false;
  }

  function uudecode($in)
  {
    $slen = (ord($in[0]) - 0x20) & 0x3f;
    $in = substr($in, 1, strlen($in) - 3);
    $xlen = strlen($in);
    for ($i = 0; $i < $xlen; $i++) $in[$i] = chr((ord($in[$i]) - 0x20) & 0x3f);

    $out = "";
    for ($i = 0; $i < $xlen / 4; $i++)
    {
      $out = $out . chr((ord($in[$i*4]) << 2) | (ord($in[$i*4+1]) >> 4))
         . chr((ord($in[$i*4+1]) << 4) | (ord($in[$i*4+2]) >> 2))
         . chr((ord($in[$i*4+2]) << 6) | (ord($in[$i*4+3])));
    }

    $out = substr($out, 0, $slen);

    return $out;
  }

	//edit 18.6.2008 15:23:08
	function converttoquoted($string){
		$converted = "";
		for ($i = 0; $i < strlen($string); $i++) {
			if ((ord($string[$i]) > 127) || ($string[$i] == "=") || (ord($string[$i]) < 32) || ($string[$i] == "_"))
				$converted .= "=" . fillstr(strtoupper(dechex(ord($string[$i]))), 2, "0");
			else
				$converted .= $string[$i];
		}
		return $converted;
	}


  function putheader($header,$mycharset="",$emails=false)
  {
    $out = $fheader = trim($header);
    $mycharset=$mycharset?$mycharset:mycharset;

    if (isabovechar($fheader))
    {
	  $i=1;
      if($emails && strpos($fheader,">"))
      {
         $arr = explode(">",$header);

         foreach($arr as $val)
         {
            if(!strlen($val)) continue;
            unset($val2);
            if(($spos = strpos($val,"<"))>-1) $val .='>';

            if (!eregi("(.*)(<.*[^>]*>)",$val,$val2))
				$val2[1]=$val;

            $val2[1]=ereg_replace("^[,;]","",trim($val2[1]));

            if(isabovechar($val2[1]))
              $out2 .= "=?" . strtoupper($mycharset) . "?Q?" . converttoquoted($val2[1]) . "?=";
            else
              $out2 .= $val2[1];

            if($val2[2]) $out2 .= ' '.$val2[2].";";
         }

         if(isset($out2)) $out = $val2[2]?substr($out2,0,-1):$out2;
      }
      else
         $out = "=?" . strtoupper($mycharset) . "?Q?" . converttoquoted($fheader) . "?=";
    }

    return $out;
  }


  function getfilename($read = false, $oldfile = "")
  {
    global $mailboximap;

    if ($oldfile){
       if (($pos = strpos($oldfile,"-")))
          $messageid = substr($oldfile,0,$pos);

       if (($pos = strpos($oldfile,"."))){
          $extension = substr($oldfile,$pos);
          if(!$messageid) $messageid = substr($oldfile,0,$pos);
       }
    }

    if (!$messageid) $messageid = eregi_replace("e","z",uniqid(""));

    $flags = fillstr(dechex($read?dreadflag:0), 8, "0");

    if (!$extension) $extension = ($mailboximap?imapmessageext:messageext);

    return $messageid .'-' . $flags . $extension;
  }

  function writesentcopy($id, $message, $folder, $flag, $messageid="")
  {
    if (!getusersession($id, $user, $config)) return false;
    if (!($xpath = getfolderpath($user, $folder))) return false;

    mkdirtree($xpath, 1);

    if(!$messageid) $messageid = getfilename(true);

    if(@file_exists($xpath.$messageid)) $nochangeindex=1;

    if (!(@$file = fopen($xpath.$messageid, "wb"))) return false;
    fwrite($file, $message, strlen($message));
    fclose($file);

    if ($flag)
       setmessageflag($id, $folder, $messageid, $flag);

    if (!$nochangeindex)
       changeindex($xpath,1,($flag && $flag==unreadflag?1:0),filesize($xpath.$messageid));

    return true;
  }


  function saveusersettings($id, $signature, $deletemove, $writesentcopy, $shownumber, $forwardtext, $otheruser)
  {
    global $otherconfig;
    getusersession($id, $user, $config);

    $fpath = getfolderpath($user);
    mkdirtree($fpath);
    $fpath .= settingsfile;

    if (!(@$file = fopen($fpath, "wb"))) return false;

    $shownumber=ceil($shownumber*1);
    $shownumber=$shownumber?$shownumber:'';

    $otheruser["SHOW2NUMBER"]=ceil($otheruser["SHOW2NUMBER"]*1);
    $otheruser["SHOW2NUMBER"]=$otheruser["SHOW2NUMBER"]?$otheruser["SHOW2NUMBER"]:'';
    
    fputs($file, rawurlencode($signature) . "\r\n");
    fputs($file, rawurlencode($deletemove) . "\r\n");
    fputs($file, rawurlencode($writesentcopy) . "\r\n");
    fputs($file, rawurlencode($shownumber) . "\r\n");
    fputs($file, rawurlencode($forwardtext) . "\r\n");

    fputs($file, rawurlencode($otheruser['PERSONALITIES']) . "\r\n");
    fputs($file, rawurlencode($otheruser['MENU']) . "\r\n\r\n");//+blank row
    fputs($file, rawurlencode($otheruser['LANG']) . "\r\n");
    fputs($file, rawurlencode(is_numeric($otheruser['REFRESH'])?$otheruser['REFRESH']:'0') . "\r\n");
    fputs($file, rawurlencode('utf8') . "\r\n"); //$otheruser['CHARSET']
    fputs($file, rawurlencode($otheruser['SENDPLAIN']) . "\r\n");
    fputs($file, rawurlencode($otheruser['SIGNATURETOP']) . "\r\n");
    fputs($file, rawurlencode($otheruser['SHOW2NUMBER']) . "\r\n");
    fputs($file, rawurlencode($otheruser['RULES']) . "\r\n");
    fputs($file, rawurlencode($otheruser['FOLDERS']) . "\r\n");
    fputs($file, rawurlencode($otheruser['DATEFORMAT']) . "\r\n");
    fputs($file, rawurlencode($otheruser['TDDATEFORMAT']) . "\r\n");

    fputs($file, rawurlencode($otheruser['TIMEZONE']) . "\r\n");

    fputs($file, rawurlencode($otheruser['JSHIDE']) . "\r\n");
    fputs($file, rawurlencode($otheruser['DEFAULTENCRYPT']) . "\r\n");
    fputs($file, rawurlencode($otheruser['DEFAULTSIGN']) . "\r\n");
    fputs($file, rawurlencode($otheruser['CONFIRMDIALOGS']) . "\r\n");
    fputs($file, rawurlencode($otheruser['REPLYSYMBOL']) . "\r\n");
    fputs($file, rawurlencode($otheruser['SHOWATTIMAGES']) . "\r\n");
    fputs($file, rawurlencode($otheruser['OLDSTYLEATTACH']) . "\r\n");
    fputs($file, rawurlencode($otheruser['DAYLIGHT']));
    fclose($file);
  }


  function getuserquota($id)
  {
    $quota = 0;
    $folders = getfolders($id);
    foreach ($folders as $folder) $quota += $folder['size'];

    return $quota / 1024;
  }

  function getnewaccountid($accounts, $accountid)
  {
    $value = true;

    $ca = count($accounts);
    for ($i = 0; $i < $ca; $i++)
    {
      if ($accounts[$i]["USER"] == $accountid)
      {
        $value = false;
        break;
      }
    }

    return $value;
  }


  function showpersonalities($personalities, $config,$default="")
  {
    $back = '';
    $list = emaillist($personalities);

    $default=$default?htmlspecialchars($default):'';
    for ($i = 0; $i < count($list); $i++)
    {
      $xitem = trim($list[$i]);
      if ($xitem)
      {
        $item["EMAIL"] = $xitem;
        $item["NAME"] = getmailname($xitem);
        if($item["EMAIL"]==$item["NAME"]) unset($item["NAME"]);
        $plist[] = $item;
      }
    }                                                                                                  //htmlspecialchars($config["FULLNAME"])

    $list = "<OPTION VALUE=\"" . str_replace('"',"&quot;",getemail($config["EMAIL"], $config["FULLNAME"], false, true)) . "\">" . getemail($config["EMAIL"], $config["FULLNAME"], false, true) . "</OPTION>\r\n";

    foreach ($plist as $val)
    {
      $listval = $val["NAME"]?getemail($val["EMAIL"], $val["NAME"], false, true):htmlspecialchars($val["EMAIL"]);
      $list .= "<OPTION VALUE=\"" . str_replace('"',"&quot;",$listval) . "\"".($default==$listval?' selected':'').">" .$listval . "</OPTION>\r\n";
    }
    return $list;
  }

  function showdomains()
  {
    global $domain;
    $back = '';
    $list = explode(";", $domain);
    for ($i = 0; $i < count($list); $i++)
    {
      $xitem = trim($list[$i]);
      if ($xitem)
      {
        if ($i) { $xxitem = $xitem; } else $xxitem = "";
        $back .= "<OPTION VALUE=\"" . $xxitem . "\">" . htmlspecialchars($xitem) . "</OPTION>\r\n";
      }
    }
    return $back;
  }


        function showhosts($item)
        {
            global $virtualhosts, $lang;

            $currentselected = (isvirtualhost($item))?"":" SELECTED";
            $result = "<OPTION VALUE=\"*\" " . $currentselected . ">" . $lang[MSG_MSG_DEFAULT] . "</OPTION>\r\n";
                                        //   ". $lang[MSG_MSG_DEFAULT] ."
            for ($i = 0; $i < count($virtualhosts); $i++)
            {
              $xitem = trim($virtualhosts[$i]);
              $currentselected = ($item == $xitem)?" SELECTED":"";
              if ($xitem) $result .= "<OPTION VALUE=\"" . $xitem . "\"" . $currentselected . ">" . htmlspecialchars($xitem) . "</OPTION>\r\n";
            }
            return $result;
        }

  function showlayouts($default = false)
  {
     global $layout_settings, $otheruser, $default_layout;
     $otheruser["MENU"]= $otheruser["MENU"]?$otheruser["MENU"]:$default_layout;

     while(list($index, $value) = each($layout_settings))
     {
       $layoutname = split(";", $layout_settings[$index]);
       if (!$default)
         $currentselected = ($index == $otheruser["MENU"])?" SELECTED":"";
       else
         $currentselected = ($index == $default_layout)?" SELECTED":"";

       $back .= '<OPTION VALUE="' . $index . '"' . $currentselected . '>' . htmlspecialchars($layoutname[0]) . "</OPTION>\r\n";
     }
  return $back;
  }

  function showlanguages($default = false)
  {
     global $lang_settings, $otheruser, $default_lang;

     if (!$default) $flang = $otheruser["LANG"];
     $flang =$flang?$flang:$default_lang;

     while(list($index, $value) = each($lang_settings))
     {
             $langname = split(";", $lang_settings[$index]);
             $currentselected = ($index == $flang)?" SELECTED":"";
             $back .= '<OPTION value="' . $index . '"' . $currentselected . '>' . htmlspecialchars($langname[0]) . "</OPTION>\r\n";
     }

  return $back;
  }

  function showcharset($default = false,$select="")
  {
          global $charset_settings, $otheruser, $otherconfig;

          foreach($charset_settings as $index => $value)
          {
             if($default && $index=="none") continue;
             $charsetname = split(";", $charset_settings[$index]);

             if($select && $select==$index)
                $currentselected= " SELECTED";
             elseif($select)
                $currentselected= "";
             else
             {
                if (!$default)
                   $currentselected = ($index == $otheruser["CHARSET"])?" SELECTED":"";
                else
                   $currentselected = ($index == $otherconfig["CHARSET"])?" SELECTED":"";
             }

             $back .= '<option value="' . $index . '"' . $currentselected . '>' . htmlspecialchars($charsetname[0]) . "</option>\r\n";
          }
  return $back;
  }

//****************************************************************

 ///////////////////////////////////////////
 // return uids with given prefix
 ///////////////////////////////////////////
 function filteruidbyprefix($uidl,$prefix="")
 {
   $fuid = array();
   if(!is_array($uidl) || !count($uidl)) return $fuid;

   reset ($uidl);
   while (list ($key, $val) = each ($uidl))
   {
       if(($prefix && ereg("^$prefix",$key)) || (!$prefix && !strpos($key,"+"))) $fuid[]=$key;
   }

   return $fuid;
 }

 ///////////////////////////////////////////
 // return all uids from user/uid.dat
 ///////////////////////////////////////////
 function getlocaluid()
 {
   global $user;
      $ret= array();

      if (!@$file = fopen(getfolderpath($user) . uidfile, "rb")) return $ret;

      while (!feof($file))
      {
        $data = fgetcsv($file, 1024,uiddelimiter);
        if(trim($data[0])) $ret[trim($data[0])] = trim($data[1]);
      }
      @fclose($file);

   return $ret;
 }

 ///////////////////////////////////////////
 // save all uids with values 1|0 from given array to user/uid.dat
 ///////////////////////////////////////////
 function setuidl($uidl,$deluidl="")
 {
   global $user,$otheraccounts;

   if(!is_array($deluidl)) $deluidl=array();

   $path= getfolderpath($user) . uidfile;

   if(is_array($uidl) && count($uidl))
   {
     if (!$file = fopen($path, "wb")) return false;

     if(is_array($otheraccounts) && count($otheraccounts)) $kotheraccounts=array_keys($otheraccounts);

     reset ($uidl);
     while (list ($key, $val) = each ($uidl))
     {
       if($dpos=strpos($key,"+") && is_array($kotheraccounts))
       {
          $keyid= substr($key,0,$dpos);
          if(!in_array($keyid,$kotheraccounts)) continue;
       }

       if($val!="" && !in_array($key,$deluidl)) fputs($file, $key.uiddelimiter.$val."\r\n");
     }

     @fclose($file);
   }
   else
     @unlink($path);
 }

 ///////////////////////////////////////////
 // Delete given uids from inboxfolder [for Delete messages when deleted on server]
 ///////////////////////////////////////////
 function uidsdelete($id, $uids)
 {
   if(!is_array($uids) || !count($uids)) return false;

   getusersession($id, $user, $config);
   $path = getfolderpath($user, inboxfolder);

   if (!@$dp = opendir($path)) return false;
   while (@$dir = readdir($dp))
   {
     if (is_file($path . "/" . $dir))
     {
       if (!(strcasecmp(substr($dir, strlen($dir) - strlen(messageext), strlen(messageext)), messageext)) && ($fmessage == "" || $fmessage == $dir))
       {
         $file = getfilemessageuid($dir);
         if(in_array($file,$uids)) @unlink($path . "/" . $dir);
       }
     }
   }
   @closedir($dp);

   return true;
 }

 ////////////////////////////////////////////
 // Add delete flag (1) for given uid in uid.dat
 ////////////////////////////////////////////
 function deleteuid($id, $uidfile)
 {
   global $otherconfig,$user;

   $uidfile=basename($uidfile);

   $uid = getfilemessageuid($uidfile);
   $uidl=getlocaluid();

   if($uidl[$uid]==="") return;
   else
   {
      if(!getaccountid($uidfile) && $otherconfig["FULLMERAK"] && directmerak) $uidl[$uid]=""; else $uidl[$uid]=1;

      setuidl($uidl);
   }
 }


 function getfilemessageuid($uidfile)
 {
   if (strpos($uidfile, "-"))
     $uid = substr($uidfile, 0, strpos($uidfile, "-"));
   else
     $uid = substr($uidfile, 0, strrpos($uidfile, "."));

   return $uid;
 }


//****************************************************************

function filteremail($list, $email){
	$email = strtolower(getemail($email, "", true));

	//parse emails
	$a  = explode(",",$list);
	$tmp = -1;
	foreach($a as $k => $v){
		$c = substr_count($v,'"');

		if ($tmp>-1){
			$b[$tmp].= ','.$v;
			if ($c) $tmp = -1;
			continue;
		}
		elseif ($c == 1)
			$tmp = $k;

		if ($v) $b[$k] = $v;
	}

	foreach($b as $k => $v)
		if(ereg(strtolower($email),strtolower($v))) unset($b[$k]);

	return implode(",", $b);
}


  function replaceurl($original, $what)
  {
    $i = 0;
    while ($i < strlen($original))
    {
      if (strtolower(substr($original, $i, strlen($what))) == strtolower($what))
      {
        $text = substr($original, $i, strlen($original) - $i);
        $p = strpos(strtr($text, "\r\n", "  ") . " ", " ");
        $i += $p - 1;
        $text = substr($text, 0, $p);
        if (strtolower($text) <> strtolower($what)) { $result .= "<A HREF=\"" . $text . "\" target=\"_blank\"><FONT CLASS=\"link\">" . $text . "</FONT></A>"; }
        else
          $result .= $text;
      }
      else
        $result .= $original[$i];

      $i++;
    }
    return $result;
  }


$replyattachments = array();

  function dotconvert($value)
  {
    if ($value) if ($value[0] == ".") $value = "." . $value;
    return str_replace("\n.", "\n.." , $value);
  }

  function emaillist($line)
  {
    $quots = false;
    $exchar = "\16";
    for ($i = 0; $i < strlen($line); $i++)
    {
      if ($quots) { if ($line[$i] == ",") $line[$i] = $exchar; } else if ($line[$i] == ";") $line[$i] = ",";
      if ($line[$i] == "\"") $quots = !($quots);
    };

    $list = explode(",", $line);

    for ($i = 0; $i < count($list); $i++) $list[$i] = strtr($list[$i], $exchar, ",");
    return $list;
  }

  function getmail($line, $id,$header="",$fmerak="",$signed=false)
  {
    global $showlite,$signed_message,$lang,$skin_dir;
    $list = emaillist($line);
    $value = "";

    if($showlite==2)
    {
      $sh1='javascript:WOX(650,630,1,\'';
      $sh2='javascript:WOX(720,550,1,\'';
      if($signed_message && $header=="from:") $shx="&certfile=".urlencode($signed_message);

      $shx.='&closewin=1\');';
      $shx2='target="_parent"';
    }

    //AS images
/*
    if(file_exists($skin_dir."images/as_0.gif")) $path_as0 = $skin_dir;
    if(file_exists($skin_dir."images/as_1.gif")) $path_as1 = $skin_dir;
*/
    for ($i = 0; $i < count($list); $i++)
    {
      $item = trim($list[$i]);
      if ($item)
      {

        $value .='<A HREF="'.$sh1.'writemail.html?id='.$id.'&writeto=' . rawurlencode(($showlite==2?rawurlencode($item):$item)) .$shx.'"><FONT CLASS="link">' . htmlspecialchars($item) . '</FONT></A>&nbsp;
                  <A HREF="'.$sh2.'addressaction.html?id='.$id.'&addressemail=' . rawurlencode(substr(getemail($item),1,-1)) . '&addressname=' . rawurlencode(($showlite==2?rawurlencode(getmailname($item)):getmailname($item))). '&Add_x'.$shx.'"><FONT CLASS="link">[+]</FONT></A>';
/*
        if($header=="from:" && $fmerak){
        $value .='&nbsp;&nbsp;[<a href="bwlist.html?id='.$id.'&addstring='.rawurlencode('From: '.substr(getemail($item),1,-1)).'&ra=0" '.$shx2.'><img src="'.$path_as0.'images/as_0.gif" border="0" align="absbottom" alt="'.$lang[MSG_ADDFILTERREJECT].'"></a>
                  <a href="bwlist.html?id='.$id.'&addstring='.rawurlencode('From: '.substr(getemail($item),1,-1)).'&ra=1" '.$shx2.'><img src="'.$path_as1.'images/as_1.gif" border="0" align="absbottom" alt="'.$lang[MSG_ADDFILTERACCEPT].'"></a>]';
        }
*/
        $value.=addressdelimiter;
      }
    }
    return substr($value, 0, strlen($value) - strlen(addressdelimiter));
  }
?>