<?
  function getaccountindex($accounts, $accountid)
  {
    $index = 0;

    $ca = count($accounts);
    for ($i = 0; $i < $ca; $i++)
    {
      if (strtolower($accounts[$i]["USER"]) == strtolower($accountid))
      {
        $index = $i + 1;
        break;
      }
    }

    return $index;
  }

  function createaccountline($account)
  {
    return rawurlencode($account["USER"]) . delimiterchar .
        rawurlencode(shadowstring . base64_encode($account["PASS"])) . delimiterchar .
        rawurlencode($account["ADMIN"]) . delimiterchar .
        rawurlencode($account["HOST"]) . delimiterchar .
        rawurlencode($account["HOSTUSER"]) . delimiterchar .
        rawurlencode(shadowstring . base64_encode($account["HOSTPASS"])) . delimiterchar .
        rawurlencode($account["DELETE"]) . delimiterchar .
        rawurlencode($account["FULLNAME"]) . delimiterchar .
        rawurlencode($account["EMAIL"]) . delimiterchar .
        rawurlencode($account["REPLYTO"]) . delimiterchar . delimiterchar . //fullheader removed
        rawurlencode($account["MULTI"]) . delimiterchar . delimiterchar .   //attach removed
        rawurlencode($account["DELETESERVER"]) . delimiterchar .
        rawurlencode($account["NOQUOTA"]) . delimiterchar .
        rawurlencode($account["UIDLDELETE"]) . delimiterchar .
        rawurlencode($account["COLOR"]) . delimiterchar .
        rawurlencode($account["ALTEMAIL"]) . delimiterchar . "\r\n";
  }

  function saveaccounts($accounts)
  {
    if (!(@$file = fopen(usersfile, "wb"))) return false;
    $ca = count($accounts);

    for ($i = 0; $i < $ca; $i++)
    {
      if (!$accounts[$i]["DELETED"])
      {
        fputs($file, createaccountline($accounts[$i]));
        saveuserconfig($accounts[$i]["USER"], $accounts[$i]);
      }
      else
        deltree($accounts[$i]["USER"],3);
    }
    fclose($file);

    return true;
  }


  function getaccounts()
  {
    $accounts = array();

    if (!(@$file = fopen(usersfile, "rb"))) return $accounts;

    while (!(feof($file)))
    {
      $line = trim(fgets($file, 16384));
      if ($line)
      {
        $account = convertuser($line);

        // Check If Other Settings And Load
        if(file_exists(usersdir . $account['USER'] . "/" . userfile))
        {
          $ffile = @file(usersdir . $account['USER'] . "/" . userfile);
          if (is_array($ffile)) $account = convertuser(trim($ffile[0]));
        }
        $accounts[] = $account;
      }
    }
    fclose($file);
    return $accounts;
  }
?>