<?php
  // Handles the call request parsed by rpc_request() function
  //
  // $call is an array with multiple calls, methods and params
  //
  // returns an array with results for each call for rpc_result() function
  //

  function handle_gw_call(&$call) {

    // Call API function
    $result[METHOD] = $call[METHOD];
    if (!count($call[PARAMS])) 
      $result[PARAMS][] = icewarp_calendarfunctioncall($method); 
    else
      $result[PARAMS][] = icewarp_calendarfunctioncall($method, $call[PARAMS][0], $call[PARAMS][1], $call[PARAMS][2], $call[PARAMS][3], $call[PARAMS][4]); 

    // Return
    return $result;  
  }
?>