<?php
include_once 'xml.php';

$syncml_table_xml2code=array(array('Add'=>'05','Alert'=>'06','Archive'=>'07','Atomic'=>'08','Chal'=>'09','Cmd'=>'0a','CmdID'=>'0b','CmdRef'=>'0c',
                                   'Copy'=>'0d','Cred'=>'0e','Data'=>'0f','Delete'=>'10','Exec'=>'11','Final'=>'12','Get'=>'13','Item'=>'14',
                                   'Lang'=>'15','LocName'=>'16','LocURI'=>'17','Map'=>'18','MapItem'=>'19','Meta'=>'1a','MsgID'=>'1b','MsgRef'=>'1c',
                                   'NoResp'=>'1d','NoResults'=>'1e','Put'=>'1f','Replace'=>'20','RespURI'=>'21','Results'=>'22','Search'=>'23','Sequence'=>'24',
                                   'SessionID'=>'25','SftDel'=>'26','Source'=>'27','SourceRef'=>'28','Status'=>'29','Sync'=>'2a','SyncBody'=>'2b','SyncHdr'=>'2c',
                                   'SyncML'=>'2d','Target'=>'2e','TargetRef'=>'2f','VerDTD'=>'31','VerProto'=>'32','NumberOfChanges'=>'33','MoreData'=>'34',
                                   'Anchor'=>'05','EMI'=>'06','Format'=>'07','FreeID'=>'08','FreeMem'=>'09','Last'=>'0a','Mark'=>'0b','MaxMsgSize'=>'0c',
                                   'MaxObjSize'=>'15','Mem'=>'0d','MetInf'=>'0e','Next'=>'0f','NextNonce'=>'10','SharedMem'=>'11','Size'=>'12','Type'=>'13','Version'=>'14'),
                             array('CTCap'=>'05','CTType'=>'06','DataStore'=>'07','DataType'=>'08','DevID'=>'09','DevInf'=>'0a','DevTyp'=>'0b','DisplayName'=>'0c',
                                   'DSMem'=>'0d','Ext'=>'0e','FwV'=>'0f','HwV'=>'10','Man'=>'11','MaxGUIDSize'=>'12','MaxID'=>'13','MaxMem'=>'14',
                                   'Mod'=>'15','OEM'=>'16','ParamName'=>'17','PropName'=>'18','Rx'=>'19','Rx-Pref'=>'1a','SharedMem'=>'1b','Size'=>'1c',
                                   'SourceRef'=>'1d','SwV'=>'1e','SyncCap'=>'1f','SyncType'=>'20','Tx'=>'21','Tx-Pref'=>'22','ValEnum'=>'23','VerCT'=>'24',
                                   'VerDTD'=>'25','XNam'=>'26','XVal'=>'27','UTC'=>'28','SupportNumberOfChanges'=>'29','SupportLargeObjs'=>'2a','Property'=>'2b','PropParam'=>'2c',
																	 'MaxOccur'=>'2d','NoTruncate'=>'2e','Filter-Rx'=>'30','FilterCap'=>'31','FilterKeyword'=>'32','FieldLevel'=>'33','SupportHierarchicalSync'=>'34'));

$syncml_table_code2xml=array(array('05'=>'Add','06'=>'Alert','07'=>'Archive','08'=>'Atomic','09'=>'Chal','0a'=>'Cmd','0b'=>'CmdID','0c'=>'CmdRef',
                                   '0d'=>'Copy','0e'=>'Cred','0f'=>'Data','10'=>'Delete','11'=>'Exec','12'=>'Final','13'=>'Get','14'=>'Item',
                                   '15'=>'Lang','16'=>'LocName','17'=>'LocURI','18'=>'Map','19'=>'MapItem','1a'=>'Meta','1b'=>'MsgID','1c'=>'MsgRef',
                                   '1d'=>'NoResp','1e'=>'NoResults','1f'=>'Put','20'=>'Replace','21'=>'RespURI','22'=>'Results','23'=>'Search','24'=>'Sequence',
                                   '25'=>'SessionID','26'=>'SftDel','27'=>'Source','28'=>'SourceRef','29'=>'Status','2a'=>'Sync','2b'=>'SyncBody','2c'=>'SyncHdr',
                                   '2d'=>'SyncML','2e'=>'Target','2f'=>'TargetRef','31'=>'VerDTD','32'=>'VerProto','33'=>'NumberOfChanges','34'=>'MoreData',
																	 '35'=>'Field','36'=>'Filter','37'=>'Record','38'=>'FilterType','39'=>'SourceParent','3a'=>'TargetParent','3b'=>'Move',
																	 '3c'=>'Correlator'),
                             array('05'=>'Anchor','06'=>'EMI','07'=>'Format','08'=>'FreeID','09'=>'FreeMem','0a'=>'Last','0b'=>'Mark','0c'=>'MaxMsgSize',
                                   '0d'=>'Mem','0e'=>'MetInf','0f'=>'Next','10'=>'NextNonce','11'=>'SharedMem','12'=>'Size','13'=>'Type','14'=>'Version',
                                   '15'=>'MaxObjSize'),
                             array('05'=>'CTCap','06'=>'CTType','07'=>'DataStore','08'=>'DataType','09'=>'DevID','0a'=>'DevInf','0b'=>'DevTyp','0c'=>'DisplayName',
                                   '0d'=>'DSMem','0e'=>'Ext','0f'=>'FwV','10'=>'HwV','11'=>'Man','12'=>'MaxGUIDSize','13'=>'MaxID','14'=>'MaxMem',
                                   '15'=>'Mod','16'=>'OEM','17'=>'ParamName','18'=>'PropName','19'=>'Rx','1a'=>'Rx-Pref','1b'=>'SharedMem','1c'=>'Size',
                                   '1d'=>'SourceRef','1e'=>'SwV','1f'=>'SyncCap','20'=>'SyncType','21'=>'Tx','22'=>'Tx-Pref','23'=>'ValEnum','24'=>'VerCT',
                                   '25'=>'VerDTD','26'=>'XNam','27'=>'XVal','28'=>'UTC','29'=>'SupportNumberOfChanges','2a'=>'SupportLargeObjs','2b'=>'Property','2c'=>'PropParam',
																	 '2d'=>'MaxOccur','2e'=>'NoTruncate','30'=>'Filter-Rx','31'=>'FilterCap','32'=>'FilterKeyword','33'=>'FieldLevel','34'=>'SupportHierarchicalSync'));

class wbxml_tree_node extends xml_tree_node
{
  function &wbxml_tree_node($name,$attribs) 
  {
    $this->_name=$name;
    $this->_attribs=$attribs;
    $this->_children=array();
    return $this;
  }

  function &new_child($name,$attribs) 
  {
    return $this->add_child(new wbxml_tree_node($name,$attribs));
  }

  function &new_child_data($name,$attribs,$data) 
  {
    $tmp=&$this->new_child($name,$attribs);
    $tmp->add_child(new xml_text_node($data));
    return $tmp;
  }

  function print_wbxml($devinf_page=false)
  {
    global $syncml_table_xml2code;

    $result='';
    $attrib_str='';
    $content_flag=false;
    $metinf=false;
    $devinf=false;

    if (is_array($this->_attribs)) //M zpracovvan tag atributy?
      foreach($this->_attribs as $key=>$val)
        if ($key=='xmlns')
        {
          if ($val=='syncml:devinf')
          {
            $devinf=true;
            $devinf_page=true;
          }
        }
        else
          $attrib_str.=' '.$key."=\"".$val."\""; //Vlastn zpracovn cizch atribut (ne SyncML)

    $code=hexdec($syncml_table_xml2code[$devinf_page][$this->_name]);

		if (!$code) //Pouvme intern neznam tag?
			do_log("ERROR: We're using unknown tag <".$this->_name.'>',1);

		if ($attrib_str) //M n tag atributy (ne SyncML)?
    {
      $atrib_str=chr(3).$attrib_str.chr(0).chr(1);
      $code+=128;
    }

    if ($this->children_count()) //M n tag obsah?
    {
      $code+=64;
      $content_flag=true;
    }

    $result.=chr($code).$attrib_str;

    //Zpracovn vnoench tag
    foreach($this->_children as $child)
      if (get_class($child)=='xml_text_node')
        $result.=chr(3).$child->print_node(0,false).chr(0);
      else
      {
        if (($child->_attribs['xmlns']=='syncml:metinf')&&(!$metinf))
        {
          $result.=chr(0).chr(1);
          $metinf=true;
        }
        $result.=$child->print_wbxml($devinf_page);
      }
    //Nvrat k domc codepage
    if ($metinf)
      $result.=chr(0).chr(0);

    //Ukonen tagu
    if ($content_flag)
      $result.=chr(1);

    //Zpracovn DevInf
    if ($devinf)
    {
      $result=chr(2).chr(0).chr(0).chr(106).chr(29).'-//SYNCML//DTD DevInf '.$_SESSION['sync_session']->get_version().'//EN'.$result;
			//$result=chr(2).chr(159).chr(84).chr(106).chr(0).$result;

			$len=strlen($result);
      $len_str='';
      $next=0;
      do
      {
        $len_str=chr($len%128+$next*128).$len_str;
        $next=1;
      }
      while(($len=intval($len/128))!=0);
      $result=chr(195).$len_str.$result;
    }
    return $result;
  }
}

function wbxml_to_xml($wbxml,$devinf=false)
{
  global $syncml_table_code2xml;

  if (!$devinf) //Pevdme SyncML nebo DevInf?
  {
    $codepage=0;
    $startcode='6d';
  }
  else
  {
    $codepage=2;
    $startcode='4a';
  }
  $attribs=NULL;
  $data='';
  $stackpos=0;
  $stack=array();
  $pos=0;
  $length=strlen($wbxml);

  //Ignorujeme ve do tagu SyncML nebo DevInf
  while(($pos<=$length)&&(bin2hex($wbxml[$pos])!=$startcode))
    $pos++;

  while($pos<=$length)
  {
    //Dekdujeme, zdali m tag atributy a njak obsah
    $code=ord($wbxml[$pos]);
    $attrib_flag=intval($code/128);
    $code=$code%128;
    $content_flag=intval($code/64);
    $code=bin2hex(chr($code%64));

    if ($tag=$syncml_table_code2xml[$codepage][$code]) //Existuje tag s nam kdem?
    {
      if ($attrib_flag) //M n tag atributy?
      {
        $attrib_str='';
        while(($pos<$length)&&(bin2hex($wbxml[++$pos])!='01'))
          $attrib_str.=$wbxml[$pos];
        //Schz dekdovn cizch atribut (ne SyncML) tj. fce($attrib_str,&attribs)
      }
      if ($content_flag) //M n tag njak obsah?
      {
        $pos++;
        if (bin2hex($wbxml[$pos])=='03') //Mme njak data ve formtu nulou ukonenho etzce?
          while(($pos<$length)&&(bin2hex($wbxml[++$pos])!='00'))
            $data.=$wbxml[$pos];
        else
          if (bin2hex($wbxml[$pos])=='c3') //Mme njak data s pedem znmou dlkou etzce?
          {
            $len=0;
            do
            {
              $p=ord($wbxml[++$pos]);
              $len=$len*128+$p%128;
            }
            while($p>=128);

            for($p=1;$p<=$len;$p++)
              $data.=$wbxml[++$pos];

            //if (strpos($data,'//SYNCML//DTD DevInf')) //Mme data Devinf?
            if (ord($data[0])==2) //Mme data Devinf?
            {
              $devinf_request=wbxml_to_xml($data,true);
              $data='//SYNCML//DTD DevInf';
            }
          }
          else
            $pos--;
      }
      //Nastaven SyncML atribut
      if (($codepage==1)&&($changepos==$stackpos))
        $attribs=array('xmlns'=>'syncml:metinf');
      if ($tag=='DevInf')
        $attribs=array('xmlns'=>'syncml:devinf');

      //Uloen tagu do naich struktur
      if ($stackpos)
        $stack[$stackpos]=&$stack[$stackpos-1]->new_child($tag,$attribs);
      else
        $stack[0]=&new wbxml_tree_node($tag,$attribs);

			if ($data!='')
        if ($data=='//SYNCML//DTD DevInf')
          $stack[$stackpos]->add_child(&$devinf_request);
        else
          $stack[$stackpos]->add_child(new xml_text_node($data));

			if (($attrib_flag)||($content_flag))
        $stackpos++;

      $attribs=NULL;
      $data='';
    }
    else
      if ($code=='00') //Mnme codepage?
      {
        $codepage=ord($wbxml[++$pos]);
        if ($codepage==1)
          $changepos=$stackpos;
      }
      else
        if ($code=='01') //Mme ukonovac tag?
        {
          if ($stackpos)
            $stackpos--;
        }
        else
          //Neznm kd!!!
          do_log('ERROR: Unknown code '.$code.' in position '.$pos.' in namespace '.($devinf?'Devinf':'Normal'),1);

    $pos++;
  }
  return $stack[0];
}

function request_to_xml($request,$content_type)
{
  if ($content_type=='xml')
    return text_to_xml($request);
  else
    return wbxml_to_xml($request);
}
?>
