_me = frm_confirm.prototype;
function frm_confirm(){};

/**
 * @brief
 * 
 * @see  objects/frm_select_folder.xml
 * @see  inc/frm_select_folder.js
 * @see  forms/select_folder.xml
 * @see  inc/obj_context_folder.js
 * @see  inc/obj_context_item.js    
 */         
_me.__constructor = function(aResponse, sLabel1, sLabel2, aSubstitution) {

    this._draw('frm_confirm', 'main');
        
	var me = this;

	this._size(400,'',true);
    this._resizable  = false;
	this._modal(true);
    
	if (sLabel1) this._title(sLabel1);

	if (sLabel2) this.obj_label._value(getLang(sLabel2, aSubstitution));

	// Create 'OK' button
	this._create('btn_ok', 'obj_button', 'footer');
	this.btn_ok._value('FORM_BUTTONS::OK');
    this.btn_ok._tabindex(5000);
    
	// This function is triggered when 'OK' button is pressed.
	this.btn_ok._onclick = function() {
		this._disabled(true);
		executeCallbackFunction(aResponse);
		me._destruct();
	};

	// Create 'CANCEL' button
	this._create('btn_cancel', 'obj_button', 'footer');
	this.btn_cancel._value('FORM_BUTTONS::CANCEL');
    this.btn_cancel._tabindex(5001);
    
	// When clicked destroy this form
	this.btn_cancel._onclick = function() {
		me._destruct();
	}
	
	this.btn_ok._focus();
};