_me = frm_insert_item.prototype;
function frm_insert_item(){};

_me.__constructor = function(aResponse) {

	var me = this;

	this._dataSet = 'tmp_'+this._name;
	this.__value = null;

	this._title('INSERT_ITEM::INSERT_ITEM');
	this._size(800,500,true);

	// Create formular from template
	this._draw('frm_insert_item', 'main');

	//TREE
	this.tree_folder._open(sPrimaryAccount);
	this.tree_folder._onclick = function(e,elm,id,arg){
		if (e.type != 'contextmenu' && arg['aid'] && arg['fid']){
			me.datagrid._serverSort(arg);
			if (dataSet.get("folders",[arg['aid'],arg['fid'],'TYPE']) == 'M'){
				me.radio._disabled(true);
				me.radio._value('embedded');
			}
			else
				me.radio._disabled(false);
		}
	};
	
	//DATAGRID
	this.datagrid._select_single = true;
	this.datagrid._listen_data(this._dataSet,'',true);
	this.datagrid._onchange = function(){
		if (this.__value.length>0){
			var f = this._getFolder();
			me.__value = {};
			me.__value[this.__value[0]] = dataSet.get(this._listener_data,[f.aid,f.fid,this.__value[0]]);
		}
	};
	this.datagrid._ondblclick = function(){
		me.x_btn_ok._onclick();
	};

	// This function is triggered when 'OK' button is pressed.
	this.x_btn_ok._onclick = function() {

		var aItem,v = me.datagrid._value();
		if (v.length && (aItem = me.__value[v[0]])){

			var sTitle;
			switch (dataSet.get("folders", [aItem.aid, aItem.fid, 'TYPE'])) {
				case 'M': sTitle = aItem['SUBJECT']; break;
				case 'C': sTitle = aItem['ITMCLASSIFYAS']; break;
				case 'F': sTitle = aItem['EVNLOCATION']; break;
				case 'E':
				case 'J':
				case 'N':
				case 'T': sTitle = aItem['EVNTITLE']; break;
				default:  sTitle = getLang('INSERT_ITEM::UNTITLED');
			}

			var aResult = [{
				'id': v[0],
				'title': sTitle,
				'fullpath': aItem.aid+'/'+aItem.fid+'/'+v[0],
				'embedded': me.radio._value() == 'embedded'}];
		}

		if (Is.Defined(aResponse))
			executeCallbackFunction(aResponse, aResult);

		me._destruct();
	};

	this._onclose = function() {
		dataSet.remove(me._dataSet);
		return true;
	};
};