_me = frm_main.prototype;
function frm_main(){};

_me.__constructor = function(bAlreadySynced)
{
	if (gui.copyright)
	    gui.copyright._destruct();

	//Create sound object
	this.sound = gui._create('sound','obj_sound');

	//Create Drag n Drop
	storage.library('dragndrop');
	this.dnd = new cDnD();

	var me = this;
	this.__cookieTimeout = 60000;

	// load libraries
	storage.library('class_old_message');
	storage.library('class_new_message');
	storage.library('class_item');
	storage.library('gw_others');


	//Synchro-set accounts dataset
	var aAccounts;
	//var accounts;
	if (!bAlreadySynced){
		aAccounts = WMAccounts.list();
		dataSet.add('accounts','',aAccounts);
	}
	else
		aAccounts = dataSet.get('accounts');

	// tento kod se muze odendat, jakmile prestaneme pouzivat ?frm=main... v URL
	if (!bAlreadySynced) {
		//Synchro-set storage dataset
        GWOthers.load([	'skins',
						'gw_groups',
						'mail_settings_default',
						'mail_settings_general',
						'layout_settings',
						'calendar_settings',
						'default_calendar_settings',
						'cookie_settings',
						'default_reminder_settings',
						'default_folders',
						'signature',
						'restrictions',
						'personalities',
						'read_confirmation']);
	}

	//Synchro-set folders dataset
	for (var sAccId in aAccounts){

		if (!aAccounts[sAccId]) continue;

		if (aAccounts[sAccId]['PRIMARY']) {
			if (!bAlreadySynced)
				dataSet.add('folders',[sAccId],WMAccounts.refresh({'aid':sAccId})[sAccId]);
/*
			else{
				setTimeout(
				function(){
                    //_getEmails
					WMAccounts.refresh({'aid':sPrimaryAccount},'folders',[sPrimaryAccount]);
				},5000);
			}
*/
		}
		else
		if (GWOthers.getItem('RESTRICTIONS','disable_otheraccounts') == 0 || aAccounts[sAccId].TYPE == 'rss')
			dataSet.add('folders',[sAccId],WMFolders.list({'aid':sAccId})[sAccId]);
	}


	//Obsluha pohledů
	this._lastView;
	this._defaultViews = {	'C':{'view':'list_view','sort':{'column':'CONTACT_FULLNAME','type':'asc'},'offset':0},
							'E':{'view':GWOthers.getItem('DEFAULT_CALENDAR_SETTINGS','event_view'),'sort':{'column':'EVENT_STARTDATE','type':'desc'},'offset':0},
							'J':{'view':'list_view','sort':{'column':'EVENT_STARTDATE','type':'desc'},'offset':0},
							'M':{'view':'mail_view','sort':{'column':'DATE','type':'desc'},'offset':0},
							'R':{'view':'mail_view','sort':{'column':'DATE','type':'desc'},'offset':0},
							'N':{'view':'list_view','sort':{'column':'EVNTITLE','type':'asc'},'offset':0},
							'F':{'view':'list_view','sort':{'column':'EVNLOCATION','type':'asc'},'offset':0},
							'Q':{'view':'mail_view','sort':{'column':'QDATE','type':'desc'},'offset':0},
							'QL':{'view':'list_view','sort':{'column':'SNDEMAIL','type':'asc'},'offset':0},
							'T':{'view':'list_view','sort':{'column':'TASK_ENDDATE','type':'desc'},'offset':0},
							'X':{'view':'nothing'}};

	this._defaultWindowSize = {'frm_compose':{'x':-1,'y':-1,'w':800,'h':500,'max':0},
							'frm_contact':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_distrib':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_event':{'x':-1,'y':-1,'w':700,'h':-1,'max':0},
							'frm_task':{'x':-1,'y':-1,'w':600,'h':-1,'max':0},
							'frm_journal':{'x':-1,'y':-1,'w':600,'h':-1,'max':0},
							'frm_note':{'x':-1,'y':-1,'w':450,'h':450,'max':0},
							'frm_dial':{'x':-1,'y':-1,'w':320,'h':400,'max':0},
							'frm_mail':{'x':-1,'y':-1,'w':700,'h':400,'max':0},
							'frm_file':{'x':-1,'y':-1,'w':450,'h':-1,'max':0}};

	//Načtení cookies
	storage.library('gw_others');
	var aCookies = GWOthers.get('COOKIE_SETTINGS','storage');

	var aViews;
	var aTree = [];
	var sActiveFolder = '';
	var oActiveFolder = {};
	var sSuggest = '';
	var nVerticalSlider, nVerticalMSlider, nHorizontalSlider;
	var aWindowSize;
	
	if (aCookies['VALUES']){

		// Recipients suggestion
		dataSet.add('suggest_address','',aCookies['VALUES']['suggest_address'] || '');

		// Views
		try{
			var sArray = aCookies['VALUES']['views'];
			aViews = new Function("return "+sArray)();
		}
		catch(e){
			aViews = {};
		}

		// Open tree nodes
		try{
			var sArray = aCookies['VALUES']['tree'];
			aTree = sArray.split('|');

			if (aTree[0] == '')
				throw true;
		}
		catch(e){
			  aTree = [sPrimaryAccount];
		}


		try{
			sActiveFolder = aCookies['VALUES']['folder'];
			nVerticalSlider = aCookies['VALUES']['vertical_slider'];
			nVerticalMSlider = aCookies['VALUES']['vertical_mail_slider'];
			nHorizontalSlider = aCookies['VALUES']['horizontal_slider'];
		}
		catch(e){}
		
		try{
			var sArray = aCookies['VALUES']['window_size'];
			aWindowSize = new Function("return "+sArray)();
			for(sFrm in this._defaultWindowSize){
				if(!aWindowSize[sFrm])
					aWindowSize[sFrm] = this._defaultWindowSize[sFrm];
			}
		}
		catch(e){
			aWindowSize = this._defaultWindowSize;
		}
	}

	if (typeof aViews != 'object')
		aViews = {};
	if (typeof aWindowSize != 'object')
		aWindowSize = this._defaultWindowSize;

	var aFolders = dataSet.get('folders');

	//Promazání cookies neexistujících folders
	if (count(aViews)){
		for(var sAccId in aViews){
			if (!aFolders[sAccId])
				delete aViews[sAccId];
			else
			for(var sFolId in aViews[sAccId])
				if (!aFolders[sAccId][sFolId])
					delete aViews[sAccId][sFolId];
		}
	}


	if (sActiveFolder && GWOthers.getItem('LAYOUT_SETTINGS','remember_folder')>0){
		var aPos = sActiveFolder.split('/');
		var sAccId = aPos.shift();
		var sFolId = aPos.join('/');

		if (!aFolders[sAccId] || (sFolId && !aFolders[sAccId][sFolId]))
			sActiveFolder = '';
		else{
			oActiveFolder.aid = sAccId;
			if (sFolId) oActiveFolder.fid = sFolId;
		}
	}
	else{
		//homepage (odendat fid)
		sActiveFolder = sPrimaryAccount+'/INBOX';
		oActiveFolder = {'aid':sPrimaryAccount,'fid':'INBOX'};
	}

	//Přidání cookies nových folders
	for(var sAccId in aFolders)
		for(var sFolId in aFolders[sAccId]){
			//aView
			if (!aViews[sAccId] || !aViews[sAccId][sFolId]){
				if (!aViews[sAccId])
					aViews[sAccId] = {};

				aViews[sAccId][sFolId] = clone(this._defaultViews[aFolders[sAccId][sFolId]['TYPE']],true);
			}
		}

	//Promazani otevrenych nodu v aTree cookie
	if (aTree.length>0){
		var pos;
		for (var i = aTree.length-1;i>=0;i--){
			if ((pos = aTree[i].indexOf('/'))>1){
                sAccId = aTree[i].substr(0,pos);
                sFolId = aTree[i].substr(pos+1);

				if (!aFolders[sAccId] || (!aFolders[sAccId][sFolId] && sFolId!='SPAM_QUEUE'))
                	aTree.splice(i,1);
			}
			else
			if (!aFolders[aTree[i]])
                aTree.splice(i,1);
		}
	}


	dataSet.add('datagrid_views','',aViews);
	dataSet.add('folder_tree','',aTree);
	dataSet.add('active_folder','',''); //sActiveFolder se nastavuje az v selectView()
	dataSet.add('vertical_slider','',nVerticalSlider);
	dataSet.add('vertical_mail_slider','',nVerticalMSlider);
	dataSet.add('horizontal_slider','',nHorizontalSlider);

	dataSet.add('window_size','',aWindowSize);

	setTimeout('try{'+this._pathName+'.__cookieAutoSave();}catch(e){}',this.__cookieTimeout);

	/*** TREE ***/
	this._create('folders','obj_tree_folder_context','left');
	this.dnd.registr_drop(this.folders,['item','folder']);  // dat primo do  obj_tree_folder_context

	/*** TOP MENU 1 ***/
	this._create('hmenu1','obj_hmenu_basic','menu1');
	this._create('hmenu3','obj_hmenu_basic2','menu1');

	/*** TOP MENU 2 ***/
	this._create('hmenu2','obj_hmenu','menu2');
	this.hmenu2._fill({"logout":{"title":'',"arg":'logout'}});
	this.hmenu2._onclick = function(e,elm,id,arg){
		switch(arg){
			case 'logout':
			if (me.__cookieSave([me,'__logout']) == 2)
				me.__logout();
		}
	}

	//Aktivace dříve aktivního folderu
	if (sActiveFolder){
		gui.frm_main.folders._setActive(sActiveFolder);
		gui.frm_main.folders._handleNode(oActiveFolder);
	}

	//Nastaveni title = account
    var sPgTitle = GWOthers.getItem('LAYOUT_SETTINGS','title') || '';
	var aAccounts = dataSet.get('accounts');
	
	for(var mail in aAccounts)
		if (aAccounts[mail].PRIMARY){
			document.title = (sPgTitle?sPgTitle+' - ':'')+(aAccounts[mail].FULLNAME?aAccounts[mail].FULLNAME+' <'+mail+'>':mail);
			break;
		}

	//Expired Account
	if (aAccounts[sPrimaryAccount].EXPIRED)
		gui._create('expired','frm_passexpired');
};


_me._logout = function(){

	//catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
	var bReturn = false;
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__logoutOnDestruct = true;
			bReturn = true;
		}
	}

	if (bReturn) return;

	//logout user
};

/**
 * refreshne pravou stranu je-li refreshovan account s prave aktivnim adresarem
 **/
_me._refreshItems = function(sAccId)
{
	var aSelected = this.folders._getActive();

	if (aSelected[0] == sAccId && aSelected[1])
	{
		var sFolID = aSelected[1];

		if (dataSet.get('folders',[sAccId,sFolID]))
			this.folders._handleNode({'aid':sAccId,'fid':sFolID},true);
		else{
			if (this.main)
				this.main._destruct();

			this.folders._invalidateActive();
			this._lastView = '';
			this.hmenu3._fill();

			dataSet.remove('items');
			dataSet.remove('mailview');
		}
	}
};


_me._selectView = function(aFolder,sView,bUpdate,oDate,bForceUpdate){
	var me = this;

	// promazat datasety
	dataSet.remove('items','',true);
    //dataSet.remove('mailview','',true);    // odebrano protoze se diky tomu refreshoval mailview pri GetEmails

	// HomePage
	if(!aFolder['fid']){
		if(!aFolder['aid'])
			aFolder['aid'] = sPrimaryAccount;

		aFolder['fid'] = 'INBOX';
	}

	// ziskat typ folderu
	var sFolType = dataSet.get("folders",[aFolder['aid'],aFolder['fid'],'TYPE']);

	//Ziskat pohled a jeho nastaveni
	if (sView)
		dataSet.add('datagrid_views',[aFolder['aid'],aFolder['fid'],'view'],sView);
	else{
		var atmp = dataSet.get('datagrid_views',[aFolder['aid'],aFolder['fid']]);
		if (atmp && atmp['type'] == sFolType && atmp.view)
			sView = atmp.view;
	}

	if (!sView){
        var aView = this._defaultViews[sFolType];
            aView['type'] = sFolType;
            
		dataSet.add('datagrid_views',[aFolder['aid'],aFolder['fid']],aView);
        sView = aView.view;
	}
	else
		var aView = dataSet.get('datagrid_views',[aFolder['aid'],aFolder['fid']]);

	// nastavit horni menu
    this.hmenu3._contextFill(sFolType,aFolder,sView,false);

	//Změnil se pohled?
	if (sView != this._lastView || bForceUpdate)
	{
		//Změnil se pohled v rámci stejného objektu?
		if ((sView == 'day_view' || sView =='week_view') && (this._lastView == 'day_view' || this._lastView =='week_view'))
		{
			//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
			if (!oDate){
                var oDate = new Date();
				if (this.main.calendar._selection && this.main.calendar._selection.startdate)
                    oDate.setQTime(this.main.calendar._selection.startdate);
				else {
					var aRange = this.main.calendar._range();
					if (aRange['start'])
						oDate.setQTime(aRange['start']);
				}
			}
/*
			switch(sView){
				case 'day_view':
					this.main._setDayView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
					break;
				case 'week_view':
					this.main._setWeekView(oDate);
//					if (bUpdate) gui.frm_main.main.__update();
			}
*/
		}
		else {
			if (this.main){
				if  (this._lastView == 'day_view' || this._lastView == 'week_view' || this._lastView == 'month_view')
					oDate = oDate || this.main._getDate();
				else
					oDate = new Date();

				this.main._destruct();
			}
			else
				oDate = new Date();

			switch(sView){
                case 'mail_view_wide':

                    dataSet.remove('mailview');
					this._create('main','frm_main_mail_wide');

					if (aView.search)
     					this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'mail_view':

                    dataSet.remove('mailview');
					this._create('main','frm_main_mail');

					if (aView.search)
     					this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'list_view':
					this._create('main','frm_main_datagrid');
					if (sFolType=='C' || aView.search)
						this.main._showsearch(sFolType,aFolder['aid']+'/'+aFolder['fid'],true);
					else
						this.main._hidesearch(true);

					break;

				case 'day_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setDayView(date);
					break;

				case 'week_view':
					this._create('main','frm_main_calendar_dayweek','','','items');
					//this.main._setWeekView(date);
					break;
				case 'month_view':
					this._create('main','frm_main_calendar_month','','','items',oDate);
					break;
			}
		}
		this._lastView = sView;
	}
	else{
		switch(sView){
        case 'mail_view_wide':
		case 'mail_view':
		case 'list_view':
			if (dataSet.get('active_folder') != aFolder['aid'] + '/' + aFolder['fid']){
				if (sFolType=='C' || aView.search)
					this.main._showsearch(sFolType, aFolder['aid']+'/'+aFolder['fid']);
				else
					this.main._hidesearch(true);
			}
			break;
		case 'day_view':
		case 'week_view':
			//NEni li zadan Date veme se range[start] z obj_evnview nebo dnesni den
			if (!oDate){
				oDate = new Date();
				if (this.main.calendar._selection && this.main.calendar._selection.startdate)
                    oDate.setQTime(this.main.calendar._selection.startdate);
				else{
					var aRange = this.main.calendar._range();
					if (aRange['start'])
						oDate.setQTime(aRange['start']);
				}
			}
		}
	}

	switch(sView){
		case 'mail_view_wide':
		case 'mail_view':
		case 'list_view':
			//Máme mailový pohled?
			if (sView == 'mail_view' || sView == 'mail_view_wide'){
				var aActiveMails = dataSet.get('active_mails');

				if (!aActiveMails || !aActiveMails[aFolder['aid']] || !aActiveMails[aFolder['aid']][aFolder['fid']])
					 dataSet.remove('mailview');

				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type'],[this,'__synchroDatasetHandler',[aFolder['aid'],aFolder['fid']]]);
			}
			else
				this.main.list._serverSort(aFolder,aView['sort']['column'],aView['sort']['type']);

			break;

		case 'home':
			break;

		case 'day_view':
			this.main._setDayView(oDate);
            this.main._serverSort();
			break;

		case 'week_view':
			this.main._setWeekView(oDate);
            this.main._serverSort();
			break;

		case 'month_view':
            this.main._serverSort();
	}
	
	// smazat mailview nejedna-li se o mailovy pohled (jinak se nenacita obj_mailview pri zmene folderu C->M)
	if (sView != 'mail_view_wide' && sView != 'mail_view')
		dataSet.remove('mailview');

	dataSet.add('active_folder','',aFolder['aid'] + '/' + aFolder['fid']);
};

/* pokud je posledni aktivni email v danem folderu otevre ho v mailview */
_me.__synchroDatasetHandler = function(sAccId,sFolId)
{
	var sActiveMail = dataSet.get('active_mails', [sAccId, sFolId]);
	if (sActiveMail){

		//check if folder is blank
		var aItems = dataSet.get('items', [sAccId, sFolId]);
		if (!aItems || !aItems['/'] || !parseInt(aItems['/'])){
			dataSet.remove('active_mails', [sAccId, sFolId]);
			dataSet.remove('mailview');
			return;
		}

		var v = gui.frm_main.main.list._value();
		if (inArray(v,sActiveMail)<0){
			v.push(sActiveMail);
			gui.frm_main.main.list._value(v);
		}

		OldMessage.open([sAccId, sFolId, sActiveMail]);
	}
};

_me.__cookieSave = function(aHandler){
	GWOthers.set('COOKIE_SETTINGS',{'views':arrToString(dataSet.get('datagrid_views')),'tree':valuesToString(dataSet.get('folder_tree')),'folder':dataSet.get('active_folder'),'vertical_slider':dataSet.get('vertical_slider'),'vertical_mail_slider':dataSet.get('vertical_mail_slider'),'horizontal_slider':dataSet.get('horizontal_slider'),'suggest_address':dataSet.get('suggest_address'),'window_size':arrToString(dataSet.get('window_size'))},'storage');
	return WMStorage.set({'resources':{'COOKIE_SETTINGS':dataSet.get('storage',['COOKIE_SETTINGS'])}},'storage','',aHandler); //velmi důležitý return!!!
};

_me.__cookieAutoSave = function(){
	if (this._destructed)
		return;

	this.__cookieSave();
	setTimeout('try{'+this._pathName+'.__cookieAutoSave();}catch(e){}',this.__cookieTimeout);
};

_me.__logout = function(){

	//#catch all opened compose windows
	var aChild = gui._getChildObjects('','frm_compose');
	for (var i in aChild){
		if (!aChild[i].__logoutOnDestruct && aChild[i]._onclose())
			aChild[i]._destruct();
		else{
			aChild[i].__show();
			aChild[i].__logoutOnDestruct = true;
			return;
		}
	}

	//#logout user
    var sURL = dataSet.get('main',['referrer_url']);

	auth.logout();

	//remove datasets
	dataSet.remove('accounts');
	dataSet.remove('folders','',true);
	dataSet.remove('items','',true);
	dataSet.remove('mailview','',true);
	dataSet.remove('active_mails');
	dataSet.remove('settings');

	// destruct parent form
	this._destruct();

	// destruct everything in gui
	gui._clean();

	//forward to external login homepage
	if (sURL)
        document.location.href = sURL;
	//create login page
    else
		gui._create('frm_login','frm_login');
};