_me = obj_evnmonth.prototype;
function obj_evnmonth(){};

_me.__constructor = function(){

    this._dDate = new Date();

	this.__value;
    this.__idTable = [];

	this.__blocks = {};
    
	//access rights
	this.__rights = {'read':true,'write':true,'modify':true,'remove':true};

    this.__eHeader = this._getAnchor('header');
    this.__eMain = this._getAnchor('main');

	this._selection = {};
	this.__range = {};
	
	var me = this;
	
	//Get offset
	var aDays = {'monday':0,'tuesday':6,'wednesday':5,'thursday':4,'friday':3,'saturday':2,'sunday':1};
	storage.library('gw_others');
	try{
		this.__offset = aDays[GWOthers.get('CALENDAR_SETTINGS','storage')['VALUES']['week_begins']];
	}
	catch(er) {
		this.__offset = 1;
	}





	/* REMOVE EVENT */
	function dispatch(obj){
        me.__eMain.onmousemove = null;

		gui._disobeyEvent('mouseup', [me,'__mouseup']);
		me.__mouseup = null;
		
	};
	this.__dispatch = dispatch;


	
	// MOUSEDOWN HANDLER
	this.__eMain.onmousedown = function(e){
        dispatch();
        
		var e = e || window.event;
		var elm = e.target || e.srcElement;
		if (elm === this) return;



		//to avoid execution before contextmenu
		if (e.button>1) return;

		//dblclick emulation part II
		if (me.__dblclick){
			if (me.__dblclick[0]>(new Date()).getTime()-500){
				this.ondblclick({target:me.__dblclick[1]});
				return;
			}
			me.__dblclick[1] = null;
			me.__dblclick = null;
		}

		//unselect selected cells
		if (me._selection.startdate>=0){
		    var tmp;
			for(var i = me._selection.startdate; i <= me._selection.enddate; i++){
				if ((tmp = document.getElementById(me._pathName + i)))
					removecss(tmp,'selected');
			}
			me._selection = {};
		}

		var etd = (elm.tagName == 'TD'?elm:searchParent(elm,'TD'));
        var eid = etd.id.substr(me._pathName.length);
        
		//select current cell
		me._selection = {};
		addcss(etd,'selected');
		var julian = etd.id.substr(me._pathName.length);
		me._selection = {startdate:julian,enddate:julian};

		//A -> activate event, enable move handler
		if (elm.tagName == 'SPAN'){

			if (!me.__rights.modify) return;
			
			//dblclick emulation part I
			me.__dblclick = [(new Date()).getTime(),elm];

            me.__mouseup = function(e){

				dispatch();

				window.clearTimeout(me.__dragTimeout);
				me.__dragTimeout = null;
			};
			gui._obeyEvent('mouseup',[me,'__mouseup']);

			me.__dragTimeout = window.setTimeout(me._pathName+'.__dragevent("'+elm.id+'",'+e.clientX+',"'+eid+'")',450);

		}
		//selections
		else{
			//stop multiselect
			me.__mouseup = function(e){

				dispatch();
				
				if (me._onselect) me._onselect();
				me.__exeEvent('onselect',null,{"owner":me,"selection":me._selection});
			};
			gui._obeyEvent('mouseup',[me,'__mouseup']);

		 	//start multiselect
			this.onmousemove = function(e){
				var e = e || window.event;
				var elm = e.target || e.srcElement;
				if (elm === this) return;
					elm = elm.tagName == 'TD'?elm:searchParent(elm,'TD');

				var id = elm.id.substr(me._pathName.length);
				var iStart = me._selection.startdate;
				var iEnd   = me._selection.enddate;

				if (id<eid){
					me._selection.startdate = id;
					me._selection.enddate   = eid;
				}
				else{
					me._selection.startdate = eid;
					me._selection.enddate   = id;
				}

				//css for selected cells
				var etmp;
				for(var i = me._selection.startdate>iStart?iStart:me._selection.startdate,j = me._selection.enddate<iEnd?iEnd:me._selection.enddate;i<=j;i++){
					if (!(etmp = document.getElementById(me._pathName+i))) continue;

					if (i<me._selection.startdate || i>me._selection.enddate)
						removecss(etmp,'selected');
					else
						addcss(etmp,'selected');

					etmp = null;
				}
			};
		}
	};
	
	// DBLCLCIK HANDLER
	this.__eMain.ondblclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;
		if (elm === this) return;
		
		var arg = {};

		//edit event
		if (elm.tagName == 'SPAN' && elm.id){
			var id = elm.id.substr(me._pathName.length);
			arg = clone(me.__value[id.split('/')[1]]);
			arg.evntype = 'event';

			if (arg.evnclass == 'H') return;
		}
		//add all day event
		else{
			if (elm.tagName != 'TD')
				elm = searchParent(elm,'TD');
				
            arg = {"startdate":elm.id.substr(me._pathName.length),"stattime":-1,"endtime":-1,"evntype":'allday'};
		}

		if (me._ondblclick) me._ondblclick(e,elm,arg);
        me.__exeEvent('ondblclick',e,{"elm":elm,"owner":me,"arg":arg});
	};
	
	// CONTEXT MENU HANDLER
	this.__eMain.oncontextmenu = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;
        if (elm === this) return;
        
		var arg = {};

		function select(){
			//unselect selected cells
			if (me._selection.startdate>=0){
			    var tmp;
				for(var i = me._selection.startdate; i <= me._selection.enddate; i++){
					if ((tmp = document.getElementById(me._pathName + i)))
						removecss(tmp,'selected');
				}
				me._selection = {};
			}

			var etd = (elm.tagName == 'TD'?elm:searchParent(elm,'TD'));
	        var eid = etd.id.substr(me._pathName.length);

			//select current cell
			me._selection = {};
			addcss(etd,'selected');
			var julian = etd.id.substr(me._pathName.length);
			me._selection = {startdate:julian,enddate:julian};
		}

		//edit event
		if (elm.tagName == 'SPAN' && elm.id){
			var id = elm.id.substr(me._pathName.length);
			arg = clone(me.__value[id.split('/')[1]]);
			arg.evntype = 'event';

            select();
			
			if (arg.evnclass != 'H'){
				if (me._oncontext) me._oncontext(e,elm,arg);
		        me.__exeEvent('oncontext',e,{"elm":elm,"owner":me,"arg":arg});

	            return false;
            }
		}
		
		//add all day event
        var etd = searchParent(elm,'TD');
        var id  = etd.id.substr(me._pathName.length);

		if (elm.tagName == 'DIV' && elm.className == 'day' && me._selection.startdate<=id && me._selection.enddate>=id){
			arg.startdate = me._selection.startdate;
			arg.enddate = me._selection.enddate;
			arg.evntype = 'selection';

			arg.contains = [];

			var event;
			var selection = me._selection;
			for (var i in me.__idTable) {
			    for (var j in me.__idTable[i]) {
				    event = me.__idTable[i][j];
				    if (event.startdate >= selection.startdate && event.enddate <= selection.enddate)
					    arg.contains.push(event['id']);
				}
			}
		}
		else{
			select();

			arg.startdate = etd.id.substr(me._pathName.length);
			arg.evntype = 'allday';
		}

		elm = etd;

		arg.stattime = -1;
		arg.endtime  = -1;

		if (me._oncontext) me._oncontext(e,elm,arg);
        me.__exeEvent('oncontext',e,{"elm":elm,"owner":me,"arg":arg});
        
        return false;
	};
};


_me.__dragevent = function(elm,x,eid){

	if (!elm || !this.__dragTimeout){
		this.__dispatch();
		return;
	}
	else
	if (!(elm = document.getElementById(elm)))
	    return;
			
	//pomocna funkce na vykrelseni bloku eventu
	function drawblocks(aEvn,sTitle){
	    var iStart = aEvn.startdate,
        	iEnd = aEvn.endtime==0?aEvn.enddate-1:aEvn.enddate;

		for(var i in me.__blocks){
			if (i>=iStart && i<=iEnd) continue;

			if (me.__blocks[i])
			    me.__blocks[i].parentNode.removeChild(me.__blocks[i]);

			me.__blocks[i] = null;
            delete me.__blocks[i];
		}

		var belm,telm;
		for(var i = iStart;i<=iEnd;i++){

			if (me.__blocks[i]) continue;

   			if((telm = document.getElementById(me._pathName + i))){
    			telm = telm.getElementsByTagName('div')[1];

				belm = mkElement('SPAN');
				belm.innerHTML = sTitle;
				telm.appendChild(belm);

				belm.style.top = (getSize(telm).y - getSize(belm).y) + 'px';

				addcss(belm,'active');

				me.__blocks[i] = belm;

				telm = null; belm = null;
			}
		}
	};

	var me = this;
	var pos = getSize(elm);
	var x   = x - pos.x;

	var elmid = elm.id.substr(me._pathName.length).split('/');

	if (me.__value[elmid[1]].evnclass == 'H') return;

	//stop multiselect
	this.__dispatch();

	me.__mouseup = function(e){

		me.__dispatch();

		// clear chache
		for(var i in me.__blocks){
			me.__blocks[i] = null;
			delete me.__blocks[i];
		}

		if (iStart!=me.__value[elmid[1]].startdate || iEnd!=me.__value[elmid[1]].enddate){
			if (me._onchange) me._onchange(me.__value[elmid[1]]);
			me.__exeEvent('onchange',null,{"owner":me,"event":me.__value[elmid[1]]}); // dodelat id
		}
		me._fill();
	};
	gui._obeyEvent('mouseup',[me,'__mouseup']);
	

	// "eid" is start offset;
	var iLastOffset;
	var iStart = me.__value[elmid[1]].startdate;
	var iEnd   = me.__value[elmid[1]].enddate;


	// clear curent event blocks
	var belm;
	for(var i = iStart;i<=iEnd;i++){
    	if((belm = document.getElementById(me._pathName + i +'/'+ elmid[1]))){
            belm.parentNode.removeChild(belm);
            belm = null;
		}
	}

	// draw temporary blocks
	drawblocks(me.__value[elmid[1]],(me.__value[elmid[1]].title?me.__value[elmid[1]].title.escapeHTML():getLang("EVENT_VIEW::NOTITLE")));

	//RESIZE & MOVE
	this.__eMain.onmousemove = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;
		if (this === elm) return;

		if (elm.tagName!='TD') elm = searchParent(elm,'TD');
		var id = elm.id.substr(me._pathName.length);

		//zabrani zbytecne recursi
		if (iLastOffset && iLastOffset == id) return;
		iLastOffset = id;

		if (x<8){
			if (iStart + (id - eid) <= me.__value[elmid[1]].enddate)
				me.__value[elmid[1]].startdate = iStart + (id - eid);
		}
		else
		if (x>pos.w-8){
			if (iEnd + (id - eid) >= me.__value[elmid[1]].startdate)
				me.__value[elmid[1]].enddate = iEnd + (id - eid);
		}
        else{
			me.__value[elmid[1]].startdate = iStart + (id - eid);
			me.__value[elmid[1]].enddate = iEnd + (id - eid);
		}

		drawblocks(me.__value[elmid[1]],(me.__value[elmid[1]].title?me.__value[elmid[1]].title.escapeHTML():getLang("EVENT_VIEW::NOTITLE")));
	};
};

/**
 * Set rights for object
 **/
_me._rights = function(v){
	if(!v) return this.__rights;
	
	this.__rights = v;
	
	if (!this.__rights.modify)
		addcss(this.__eMain,'obj_evnmonth_nomove');
	else
		removecss(this.__eMain,'obj_evnmonth_nomove');
};

_me.__cursor = function(left,right){

		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (!this.__rights.modify){
			elm.style.cursor = 'default';
			return;
		}

		var mainpos = getSize(elm);
		
		var x = e.clientX - mainpos.x;

		if ((x<9 && left) || (mainpos.w-9<x && right)){
			if (elm.style.cursor != 'w-resize') elm.style.cursor = 'w-resize';
		}
		else{
			if (elm.style.cursor != 'default') elm.style.cursor = 'default';
		}
};

_me._fill = function(aDataIn){

	// prepare data
	if (typeof aDataIn == 'object'){
		/*
		//private sort function for AllDayEvents
		function sortallday(a,b){
			//Holidays
			if (a['evnclass']=='H' && b['evnclass']!='H')
			    return -1;
			else
			if (a['evnclass']!='H' && b['evnclass']=='H')
			    return 1;

			if (a['starttime']>-1){
				var x = a['starttime']-b['starttime'];
				if (x == 0) x = (b['endtime']-a['endtime']);
				return x;
			}

			if (a['id'] < b['id'])
				return -1;
			else
			if (a['id'] == b['id'])
			    return 0;
			else
			    return 1;
		};

		this.__value = aDataIn.sort(sortallday);
		*/
		this.__value = aDataIn;
	
	}

	this.__idTable = [];

	var aTmpData;
	for(var i in this.__value){

        this.__value[i].startdate = parseInt(this.__value[i].startdate);
        this.__value[i].starttime = parseInt(this.__value[i].starttime);
        this.__value[i].endtime   = parseInt(this.__value[i].endtime);
        this.__value[i].enddate   = parseInt(this.__value[i].enddate);

		for(var j = this.__value[i]['startdate']; j<=this.__value[i]['enddate']; j++){

            aTmpData = clone(this.__value[i]);
            aTmpData['tmpid'] = i;

			if (aTmpData['endtime'] == 0 && j == aTmpData['enddate'])
			    continue;

			aTmpData['org_start'] = aTmpData['starttime'];
			aTmpData['org_end'] = aTmpData['endtime'];
            
			if (this.__value[i]['enddate']>j)
            	aTmpData['endtime'] = '86400';

			if (this.__value[i]['startdate']<j)
			    aTmpData['starttime'] = '0';

			if (typeof this.__idTable[j] == 'undefined') this.__idTable[j] = [];
			this.__idTable[j].push(aTmpData);
		}
	}



	function sortevn(a,b){
		//Holidays
		if (a['evnclass']=='H' && b['evnclass']!='H')
		    return -1;
		else
		if (a['evnclass']!='H' && b['evnclass']=='H')
		    return 1;

		if (a['org_start']>-1){
			var x = a['org_start']-b['org_start'];
			if (x == 0) x = (b['org_end']-a['org_end']);
			return x;
		}
		else
		if (a['org_start']<0 && b['org_start']>-1)
		    return -1;
		else
		if (a['org_start']>-1 && b['org_start']<0)
		    return 1;

		if (a['title'] && b['title']){
			if (a['title'] < b['title'])
				return -1;
			else
			if (a['title'] == b['title'])
			    return 0;
			else
			    return 1;
		}
		else
		if (a['id']<b['id'])
			return -1;
		else
		if (a['id'] == b['id'])
		    return 0;
		else
		    return 1;
	};

	for(var i in this.__idTable)
        this.__idTable[i] = this.__idTable[i].sort(sortevn);

 	var dToday = new Date();
	var MStart = this._dDate.getDay() + this.__offset;
	if (!MStart) MStart = 7;

	var iToday = this._dDate.getFullYear() == dToday.getFullYear() && this._dDate.getMonth() == dToday.getMonth()?dToday.getDate():0;

	if (!this._selection.startdate && this._active && this._dDate.getFullYear() == this._active.getFullYear() && this._dDate.getMonth() == this._active.getMonth())
        this._selection.enddate = this._selection.startdate = this._active.getJulianDate();

	// months with February calculation
	var dim    = [31,0,31,30,31,30,31,31,30,31,30,31];
		dim[1] = (this._dDate.getFullYear()%100 != 0 && this._dDate.getFullYear()%4 == 0) || this._dDate.getFullYear()%400 == 0?29:28;
	var MEnd   = dim[this._dDate.getMonth()];


	//Fill days header
	var aData = {"days":['SHORT_DAYS::MONDAY','SHORT_DAYS::TUESDAY','SHORT_DAYS::WEDNESDAY','SHORT_DAYS::THURSDAY','SHORT_DAYS::FRIDAY','SHORT_DAYS::SATURDAY','SHORT_DAYS::SUNDAY']}
	if (this.__offset)
	   	aData.days 	= aData.days.slice(7-this.__offset).concat(aData.days.slice(0,7-this.__offset));
    this.__eHeader.innerHTML = template.tmp('obj_evnmonth_header',aData);


	var aData = {"_ins":this._pathName,"weeks":[]};

	var evn,tmp = [],tmp2, css = '';

	var julian = this._dDate.getJulianDate() - MStart + 1;//getJulianDate(1, this._dDate.getMonth()+1, this._dDate.getFullYear());

    this.__range['start'] = julian;

	var t1,t2;
	for (var i = 1,j = 1;i <= 42;i++){
        evn  = [];
		tval = {};

		if (this.__idTable[julian]){

			for(k in this.__idTable[julian]){

				tval = {"id":this.__idTable[julian][k].tmpid};
				if (this.__idTable[julian][k].evnclass == 'H')
                    tval["title"] = this.__idTable[julian][k].title;
				else
					tval["title"] = (this.__idTable[julian][k].title?this.__idTable[julian][k].title.escapeHTML():getLang("EVENT_VIEW::NOTITLE"));

				if (this.__idTable[julian][k].color){
					tval.color = this.__idTable[julian][k].color;

					var color = colors.hex2rgb(tval.color);
						color = colors.rgb2hsl(color[0],color[1],color[2]);

					if (color[2]<120){
						if (color[0]>30 && color[0]<80){
							if (color[2]<65)
	                            tval.color += ';color: #FFFFFF';
						}
						else
							tval.color += ';color: #FFFFFF';
					}
				}
				//Holiday
				if (this.__idTable[julian][k].evnclass == 'H')
					tval['class'] = 'evn_holiday';
				else{
					if (this.__idTable[julian][k].startdate == julian) tval.resize = '1';
					if (this.__idTable[julian][k].enddate == julian || (this.__idTable[julian][k].org_end == 0 && this.__idTable[julian][k].enddate == julian+1)) tval.resize = tval.resize?tval.resize+',1':'0,1';

					if (this.__idTable[julian][k].org_start>-1){
						t1 = parseJulianTime(this.__idTable[julian][k].starttime);
					    t2 = parseJulianTime(this.__idTable[julian][k].endtime);
						tval['title'] = (t1 || t2?(t1 + (t2 && t1?'-':'')+ t2 +' '):'') +tval['title'];
					}
				}

				evn.push(tval);
			}
		}

		if (i<MStart || j>MEnd){
			tmp2 = {"value":parseJulianDate(julian).day};
		}
		else
			tmp2 = {"class":'month '+(j==iToday?'today':''),"value":j++};

		if (julian>=this._selection.startdate && julian<=this._selection.enddate)
			tmp2["class"] += ' selected';

		tmp2["events"] = evn;
		tmp2["julian"] = julian;

		tmp.push(tmp2);

		julian++;

		if (!(i%7)) {
			aData.weeks.push(tmp);
			tmp = [];
			if (j>MEnd){
				this.__range['end'] = julian-1;
				break;
			}
		}
	}

	var str = ['<table class="evnmonth_calendar"><tbody>'];
	for(var i=0; i<aData.weeks.length; i++){
		str.push('<tr>');

		for (var j=0; j<aData.weeks[i].length;j++){
			str.push('<td id="'+ this._pathName+aData.weeks[i][j].julian +'"'+(aData.weeks[i][j]['class']?' class="'+ aData.weeks[i][j]['class'] +'"':'')+' unselectable="on">');

			if (aData.weeks[i][j].value){
				str.push('<div class="day" unselectable="on">'+aData.weeks[i][j].value+'</div><div class="cell" unselectable="on">');

				for (var k=0; k<aData.weeks[i][j].events.length;k++)
					str.push('<span'+
					(aData.weeks[i][j].events[k]['class']?' class="'+aData.weeks[i][j].events[k]['class']+'"':'')+
					(aData.weeks[i][j].events[k]['color']?' style="background-color:'+aData.weeks[i][j].events[k]['color']+'"':'')+
					(aData.weeks[i][j].events[k].resize?' onmousemove="'+this._pathName+'.__cursor('+aData.weeks[i][j].events[k].resize+')"':'')+
					' id="'+this._pathName+aData.weeks[i][j].julian+'/'+aData.weeks[i][j].events[k].id +'" unselectable="on">'+(aData.weeks[i][j].events[k].title || '')+'</span>');

				str.push('</div>');
			}
			str.push('</td>');
		}
		str.push('</tr>');
	}
	str.push('</tbody></table>');

	this.__eMain.innerHTML = str.join('');
};

/**
 * @brief : update datasets
 * @status: COMPLETE
 * @date  : 18.9.2006 15:48:48
 **/
_me.__update = function (sDataSet){
	if (!sDataSet) return;

	/* update range */
	if (this._listener == sDataSet)
		this._value(dataSet.get(this._listener,this._listenerPath));

	/* update evenst */
	if (this._listener_data == sDataSet)
		this._fill();
};

_me._range = function(aData){

	if (aData){
 		this._active = new Date();
		this._dDate  = new Date();

		if (aData.constructor == 'Date'){
			this._active = aData;
			this._dDate.setFullYear(aData.getFullYear(),aData.getMonth(),1);
  		}
		else{
			this._active.setGWTime(aData);
			var oDate = parseJulianDate(aData);
			this._dDate.setFullYear(oDate.year,oDate.month-1,1);
		}

		this._fill();
	}
	else
		return this.__range;
};

_me._value = function(v){
	if (Is.Object(v) && count(v))
		this._fill(v);
	else
		return this.__value;
};

/**
 * @brief : update datasets
 * @status: COMPLETE
 * @date  : 18.9.2006 15:48:48
 **/
_me.__update = function (sDataSet){
      if (!sDataSet) return;

      /* update evenst */
      if (this._listener_data == sDataSet)
          this._value(dataSet.get(this._listener_data,this._listenerPath_data));

	  /* update range */
      if (this._listener == sDataSet)
		  this._range(dataSet.get(this._listener,this._listenerPath));
};
