_me = obj_evnview.prototype;
function obj_evnview(){};

/*
Input Array format
	[startdate] = julian int
	[enddate] = julian int
	[starttime] = int
	[endtime] = int
	[rmn] = bool
	[title] = string
	[id]

1] seradit dle starttime

2] ulozit do idTable + pridat start,end pro visual
3] nahazet do sloupecku + nastavit TOP
4] pustit fci na rozrezeni

Fill Array
[int]	[elm]
		[start]
		[top]
		[left]
		[width]
*/

_me.__constructor = function(){
	var me = this;

	this.__rowheight = 19;
	this.__topheight = 21;

	this.__idTable;
	this.__value;

	//access rights
	this.__rights = {'read':true,'write':true,'modify':true,'remove':true};

	this.__eTitle = this._getAnchor('title');
	this.__eMain = this._getAnchor('main');

	setSelectNone(this.__eMain);

	this.__eContainer = this._getAnchor('container');
	this.__eContainer2 = this._getAnchor('container2');
	this.__activecol;



	this.__edivs = [];		// selection divs buffer
	this._selection = {};	// indexes "startday", "starttime", "endday", "endtime"

	this.__eTitle.ondblclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		//edit event
		if (elm.tagName == 'DIV' && elm.className == "obj_evnviewallday"){
			var id = elm.id.substr(me._pathName.length+1).split('/');
			var	arg = clone(me.__value[id[1]]);
				arg.evntype = 'event';
				
			if (arg.evnclass == 'H') return;
		}
		//add allday event
		else{
			if (elm.tagName!='TD') elm = searchParent(elm,'TD');
			var id = elm.id.substr(me._pathName.length+6);
			var	arg = {"startdate":id,"enddate":id,"starttime":-1,"endtime":-1,"evntype":'allday'};
		}

		if (me._ondblclick) me._ondblclick(e,elm,arg);
		me.__exeEvent('ondblclick',e,{"elm":elm,"owner":me,"arg":arg});
	};
	
	this.__eTitle.oncontextmenu = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		//edit event
		if (elm.tagName == 'DIV' && elm.className == "obj_evnviewallday"){
			var id = elm.id.substr(me._pathName.length+1).split('/');
			var	arg = clone(me.__value[id[1]]);
				arg.evntype = 'event';

			if (arg.evnclass == 'H') return false;
		}
		//add allday event
		else{
			if (elm.tagName!='TD') elm = searchParent(elm,'TD');

			var id = elm.id.substr(me._pathName.length+6);
			var	arg = {"startdate":id,"enddate":id,"starttime":-1,"endtime":-1,"evntype":'allday'};
		}


		if (me._oncontext) me._oncontext(e,elm,arg);
		me.__exeEvent('oncontext',e,{"elm":elm,"owner":me,"arg":arg});
		
		return false;
	};
	
	/* MOUSE DBLCLICK HANDLING */
	this.__eMain.ondblclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName != 'DIV' || elm.className == 'obj_evnviewblock') return;
		if (!elm.id) elm = elm.parentNode;

		if (elm.id && elm.parentNode.tagName == 'TD'){

			var id = elm.id.substr(me._pathName.length+1).split('/');
			var	arg = clone(me.__value[id[1]]);
				arg.evntype = 'event';

			if (!arg) return false;

			if (me._ondblclick) me._ondblclick(e,elm,arg);
			me.__exeEvent('ondblclick',e,{"elm":elm,"owner":me,"arg":arg});
		}
	};











	/* MOUSE CLICK HANDLING */
	this.__eMain.onmousedown = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		//to avoid execution before contextmenu
		if (e.button>1) return;

		var mainpos = getSize(me.__eMain);
		    mainpos.h = 48*me.__rowheight;  // natahuje se to v MSIE jak se to plni DIVama

		//columns position
		var cols = [];
		for(var cln = 0; cln < me.__eMain.childNodes.length; cln++)
			cols.push(getSize(me.__eMain.childNodes[cln]));

		// DblClick on blank spase emulation (part 2)
		if (me.__dblclick && me.__dblclick>(new Date()).getTime()-300){

			if (elm.tagName != 'TD') elm = searchParent(elm,'TD');

			var id = elm.id.substr(me._pathName.length+1);

            // ZJISTIT CAS
            var iStart = e.clientY + me.__eContainer2.scrollTop - mainpos.y;
                iStart = ((iStart - iStart%me.__rowheight)/me.__rowheight)*1800;

			arg = {"evntype":'blank',"startdate":id,"starttime":iStart};

			if (me._ondblclick) me._ondblclick(e,elm,arg);
	        me.__exeEvent('ondblclick',e,{"elm":elm,"owner":me,"arg":arg});

			me.__dblclick = null;
			return;
		}

        //DESTROY CONTEXTMENU
		gui.__exeEvent('click',e);

		// remove SELECTION and all it's DIVs from previous session
		for(var i in me.__edivs){
			try{
				me.__edivs[i].parentNode.removeChild(me.__edivs[i]);
			}catch(e){}
			me.__edivs[i] = null;
		}
		if (me.__eorigdiv){
			try{
				me.__eorigdiv.parentNode.removeChild(me.__eorigdiv);
        	}catch(e){}
        	me.__eorigdiv = null;
        	delete me.__eorigdiv;
		}

		me.__edivs = [];
        me._selection = {};

		/*** CLICK TO BLANK SPACE ***/
		if (elm.tagName == 'TD'){

			// DblClick on blank spase emuilation (part 1)
			me.__dblclick = (new Date()).getTime();

			var x = e.clientX - mainpos.x;
			var y = e.clientY + me.__eContainer2.scrollTop - mainpos.y;

			var	ediv = mkElement('div');
				ediv.className = 'obj_evnviewblock';
			    ediv.style.height = me.__rowheight + 'px';
				me.__eorigdiv = ediv;
                setSelectNone(ediv);
                
			elm.appendChild(ediv);
			
			var parentpos = getSize(elm);
            var startpos = getSize(ediv);
			var ey = mainpos.y - startpos.y + (y - y%me.__rowheight) + 1;
			ediv.style.top = ey + 'px';
			var pos = getSize(ediv);

			var difY = e.clientY + me.__eContainer2.scrollTop;
			
			// remove all divs
			for(var i in me.__edivs){
				me.__edivs[i].parentNode.removeChild(me.__edivs[i]);
				me.__edivs[i] = null;
			}

			me.__edivs = [];

				function mousemove(e){
                	//var e = e || window.event;
					var scroll = me.__eContainer2.scrollTop;

					// check columns
					var mycol = -1,orgcol = -1;
					for (var i = cols.length-1;i>-1;i--){
                            if (orgcol<0 && cols[i].x == parentpos.x) orgcol = i;
							if (mycol<0 && e.clientX>cols[i].x) mycol = i;
							if (orgcol>-1 && mycol>-1) break;
					}
					if (mycol<0) return;
					
					// remove all divs
					for(var i in me.__edivs){
						me.__edivs[i].parentNode.removeChild(me.__edivs[i]);
						me.__edivs[i] = null;
					}
					me.__edivs = [];
					
                    //ORIGINATOR -> RIGHT
					if (orgcol < mycol){

						//originator div
                        ediv.style.top = ey + 'px';
						ediv.style.height = (mainpos.h + mainpos.y - pos.y) + 'px';

						//temporary divs
						var tmpdiv,tmptd,tmppos,tmpheight;
						for(var i = orgcol+1;i<=mycol;i++){

							tmptd = me.__eMain.childNodes[i];

							tmpdiv = mkElement('div');
							tmpdiv.className = 'obj_evnviewblock';
                            me.__edivs.push(tmpdiv);

                            tmptd.appendChild(tmpdiv);
                            tmppos = getSize(tmpdiv);

							//top
                            tmpdiv.style.top = (mainpos.y - tmppos.y) + 'px';

							//height
							if (i<mycol)
							    tmpheight = mainpos.h;
							else
							    tmpheight = e.clientY + scroll - mainpos.y;

                            tmpheight -= tmpheight%me.__rowheight;
                            
							tmpdiv.style.height = (tmpheight>0?tmpheight:0) +'px';

							//clear memory
							tmpdiv = null;
							tmptd  = null;
						}

						return;
					}
					else
					//ORIGINATOR -> LEFT
					if (orgcol > mycol){

                        //originator div
                        var ePosY = mainpos.y - pos.y;
                        ediv.style.top = (ey + ePosY) + 'px';
                        ediv.style.height = (me.__rowheight - ePosY) + 'px';

						//temporary divs
						var tmpdiv,tmptd,tmppos,tmpheight;
						for(var i = orgcol-1;i>=mycol;i--){

							tmptd = me.__eMain.childNodes[i];

							tmpdiv = mkElement('div');
							tmpdiv.className = 'obj_evnviewblock';
                            me.__edivs.push(tmpdiv);

                            tmptd.appendChild(tmpdiv);
                            tmppos = getSize(tmpdiv);

							if (i>mycol){
							    tmpdiv.style.top = (mainpos.y - tmppos.y) + 'px';
								tmpdiv.style.height = mainpos.h + 'px';
							}
                            else{
                                var tmptop = (e.clientY + scroll) - tmppos.y;
                                    tmptop -= tmptop%me.__rowheight;

								tmpdiv.style.top = tmptop;
								tmpheight = mainpos.h - (tmppos.y - mainpos.y);
								tmpheight = tmpheight>0?tmpheight:0;
								tmpdiv.style.height = tmpheight + 'px';
							}

							//clear memory
							tmpdiv = null;
							tmptd  = null;
						}

						return;
					}

					var ePosY = (e.clientY + scroll - difY);
						ePosY = ePosY - ePosY%me.__rowheight;

					//move Up
					if (ePosY<=0) {
						ediv.style.top = (ey + ePosY) + 'px';
						ePosY *= -1;
					}
					else
						ediv.style.top = ey + 'px';
						
					// move Down
					ediv.style.height = (ePosY +  me.__rowheight) + 'px';
				};
				gui._obeyEvent('mousemove',[mousemove]);


				function mouseup(){
					// prida originator div do bufferu aby se pri dalsim klinuti take smazal
					me.__edivs.push(ediv);

					// retrieve selection area from divs position
					me._selection = {};
					var iDay,iTime1,iTime2,tmppos;
					for(var i in me.__edivs){

						// TIME
						tmppos = getSize(me.__edivs[i]);
						
						iTime1 = tmppos.y - mainpos.y;//me.__edivs[i].offsetTop;
						iTime1 -= iTime1%me.__rowheight;

						iTime2 = me.__edivs[i].offsetHeight + iTime1;
						iTime2 -= iTime2%me.__rowheight;


						// DATE
						iDay = me.__edivs[i].parentNode.id.substr(me._pathName.length+1);

						if (typeof me._selection.startdate == 'undefined' || me._selection.startdate > iDay){
							me._selection.startdate = iDay;
							me._selection.starttime = (iTime1/me.__rowheight)*1800;
						}

						if (typeof me._selection.enddate == 'undefined' || me._selection.enddate < iDay){
							me._selection.enddate = iDay;
							me._selection.endtime = (iTime2/me.__rowheight)*1800;
						}
					}
					tmppos = null;

					if (me._selection.starttime>=86400){
					    me._selection.starttime = 0;
					    me._selection.startdate++;
					}
					if (me._selection.endtime <= 0){
					    me._selection.endtime = 86400;
					    me._selection.enddate--;
					}

					//dispatch();
					gui._disobeyEvent('mouseup',[mouseup]);
					gui._disobeyEvent('mousemove',[mousemove]);

					if(me._onselect) me._onselect();
					me.__exeEvent('onselect',null,{"owner":me,"selection":me._selection});

					return false;
				};
				gui._obeyEvent('mouseup',[mouseup]);

			return;
		}
		/*** CLICK ON EVENT BORDER ***/
		else
		if (elm.tagName == 'DIV' && elm.id && elm.parentNode.tagName == 'TD'){

			if (!me.__rights.modify) return true;

			var parentpos = getSize(elm);

			var x = e.clientX - parentpos.x;
			var y = e.clientY - parentpos.y + me.__eContainer2.scrollTop;

			if (typeof x == 'undefined' || typeof y == 'undefoned') return;

			var id = elm.id.substr(me._pathName.length+1).split('/');
			var mycol = id[0];

			var value = clone(me.__value[id[1]]);

			var eElm,ediv,eTd,height,top,dragElm;

			//zneviditelni stavajici bloky Eventu
			for(var i = value['startdate']; i <= value['enddate']; i++){
				eElm = null;

				for(var j in me.__idTable[i]){
					if (me.__idTable[i][j]['tmpid'] == id[1]){
						if ((eElm = document.getElementById(me._pathName+'/'+i+'/'+id[1])))
							eElm.style.visibility = 'hidden';

						break;
					}
				}
			}

			var events = {};
			function __block(){
				var eTd,eElm;

				//remove old blogs
				for(var i in events){
					if (i<value.startdate || i>value.enddate){
						if (events[i].div)
							events[i].div.parentNode.removeChild(events[i].div);

						events[i].div = null;
						delete events[i];
					}
				}
				
				//create bloks
				for(var i = value.startdate; i <= value.enddate; i++){
					eElm = '',eDif = 0,height = 0,top = 0;

					if((eTd = document.getElementById(me._pathName + '/' + i))){

						if (value.startdate == value.enddate){
							top = Math.floor(value.starttime/1800)*me.__rowheight;
							height = (Math.ceil(value.endtime/1800) - Math.floor(value.starttime/1800)) * me.__rowheight;
						}
						else
						if (i>value.startdate && i<value.enddate){
							top = 0;
							height = mainpos.h;
						}
						else
						if (i == value.startdate){
							top = Math.floor(value.starttime/1800)*me.__rowheight;
							height = mainpos.h - top;
						}
						else{
							top = 0;
							height = Math.ceil(value.endtime/1800)*me.__rowheight;
						}

						if (!events[i] || !events[i].div){
							eElm = mkElement('div');
							eElm.className = 'obj_evnviewevn obj_evnviewopacity';
							eTd.appendChild(eElm);

							eDif = getSize(eElm).y - mainpos.y;
						}
						else{
							eElm = events[i].div;
							eDif = events[i].dif;
						}

						eElm.style.top = (top - eDif) + 'px';
						eElm.style.height = height + 'px';

						eElm.innerHTML = parseJulianTime(value.starttime) +'-'+ parseJulianTime(value.endtime) +' '+ (value.title?value.title.escapeHTML():getLang("EVENT_VIEW::NOTITLE"));
					}

					events[i] = {"div":eElm,"dif":eDif};
				}
			};
			__block();
			
			var difY = e.clientY + me.__eContainer2.scrollTop;

			var evn_tstart = value.starttime,
				evn_tend = value.endtime,
				evn_dstart = value.startdate,
				evn_dend = value.enddate;
			
			function mousemove2(e){
				var scroll = me.__eContainer2.scrollTop;

				var cur = e.clientY - difY + scroll;
					cur = cur - cur%me.__rowheight;

				var increment = ((cur/me.__rowheight)*1800);

				for (var i = 0;i<cols.length;i++){

					if (e.clientX>=cols[i].x && e.clientX<=cols[i].x+cols[i].w || e.clientX<cols[0].x || (cols.length-1==i && e.clientX>cols[i].x)){
						//check for diferent column
						if (me.__start+i != mycol) increment += (me.__start + i - mycol)*86400;
						break;
					}

				}

				var tmp;
				// MOVE WITH EVENT BY CLICKIN ON LEFT PART
				if (x<8){







					// START TIME & START DATE
					tmp = evn_tstart + increment;
					if (tmp<0){

						var posun = Math.ceil(tmp/-86400);

						value.startdate = evn_dstart-posun;
						tmp += posun*86400;

					}
					else
					if (tmp>=86400){

						var posun = Math.floor(tmp/86400);
							posun = posun?posun:1;

						value.startdate = evn_dstart+posun;
						tmp -= posun*86400;
						
					}
					else
						value.startdate = evn_dstart;

					value.starttime = tmp;


					// END TIME & END DATE
					tmp = evn_tend + increment;

					if (tmp<=0){

						var posun = Math.ceil(tmp/-86400);
							posun = posun?posun:1;

						tmp += posun*86400;
						
						if (!tmp) {
							posun++;
							tmp = 86400;
						}
						
						value.enddate = evn_dend-posun;
					}
					else
					if (tmp>86400){

						var posun = Math.floor(tmp/86400);
							posun = posun?posun:1;

						tmp -= posun*86400;

						if (tmp == 0){
						posun--;
						tmp = 86400;
						}

						value.enddate = evn_dend+posun;
					}
					else
					    value.enddate = evn_dend;
					
					value.endtime = tmp;











					
				}
				else
				//RESIZE BY CLICKING ON UPPER PART
				if(y<8){
					tmp = evn_tstart + increment;

					if (tmp<0){

						var posun = Math.ceil(tmp/-86400);
							posun = posun?posun:1;

						value.startdate = evn_dstart-posun;
						tmp += posun*86400;

					}
					else
					if (tmp>=86400){

						var posun = Math.floor(tmp/86400);
						    posun = posun?posun:1;

						value.startdate = evn_dstart+posun;
						tmp -= posun*86400;

					}
					else
					    value.startdate = evn_dstart;
					
					//min size
					if (value.startdate>value.enddate || (value.startdate==value.enddate && tmp>=value.endtime)){
						value.startdate = value.enddate;
						tmp = value.endtime-1800;
					}
					
					value.starttime = tmp;
				}
				else
				//RESIZE BY CLICKING ON BOTTOM PART
				if(y>0 && parentpos.h<y+8){

					tmp = evn_tend + increment;

					if (tmp<me.__rowheight){

						var posun = Math.ceil(tmp/-86400);
							posun = posun?posun:1;

						tmp += posun*86400;

						if (!tmp) {
							posun++;
							tmp = 86400;
						}
						
						value.enddate = evn_dend-posun;
					}
					else
					if (tmp>86400){

						var posun = Math.floor(tmp/86400);
						posun = posun?posun:1;

						tmp -= posun*86400;

						if (!tmp) {
							posun--;
							tmp = 86400;
						}

						value.enddate = evn_dend+posun;
					}
					else
						value.enddate = evn_dend;

					//min size
					if (value.startdate>value.enddate || (value.startdate==value.enddate && value.starttime>=tmp)){
						value.enddate = value.startdate;
						tmp = value.starttime+1800;
					}

					value.endtime = tmp;
				}
				__block();
			};
			gui._obeyEvent('mousemove',[mousemove2]);


			function mouseup2(){
				gui._disobeyEvent('mousemove',[mousemove2]);
                gui._disobeyEvent('mouseup',[mouseup2]);

				//remove events from memory
				for (var i in events)
					if (events[i].div && events[i].div != null)
						events[i].div = null;

				if (compareObj(me.__value[id[1]],value,true)){
					me._fill();
					return true;
				}
				else
					me.__value[id[1]] = value;

				me._fill();

				if (me._onchange) me._onchange(value);
				me.__exeEvent('onchange',null,{"owner":me,"event":value});
			};
			gui._obeyEvent('mouseup',[mouseup2]);
		}

		return false;
	};

























	// CONTEXT MENU PART
	this.__eMain.oncontextmenu = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		var arg;

		// blank space
		if (elm.tagName == 'TD'){

			var mainpos = getSize(me.__eMain);
				mainpos.h = 48*me.__rowheight;  // natahuje se to v MSIE jak se to plni DIVama

			var id = elm.id.substr(me._pathName.length+1);

			// ZJISTIT CAS
			var iStart = e.clientY + me.__eContainer2.scrollTop - mainpos.y;
				iStart = ((iStart - iStart%me.__rowheight)/me.__rowheight)*1800;

				arg = {"evntype":'blank',"startdate":id,"starttime":iStart};
		}
		else
		if (elm.tagName == 'DIV'){

			// click on selection block
			if (elm.className == 'obj_evnviewblock'){
				var selection = me._selection;

				arg = selection;
				arg.evntype = 'selection';
				arg.contains = [];

				var event;
				for (var i in me.__idTable) {
					for (var j in me.__idTable[i]) {
						event = me.__idTable[i][j];

						if (event.startdate >= selection.startdate && event.enddate <= selection.enddate) {
							if (event.startdate == selection.startdate && event.starttime < selection.starttime) continue;
							if (event.enddate == selection.enddate && event.endtime > selection.endtime) continue;

							arg.contains.push(event['id']);
						}
					}
				}
			}
			// click on event block
			else{
				// in case of clicking into div inside event block
				if (!elm.id) elm = elm.parentNode;

				var id = elm.id.substr(me._pathName.length+1).split('/');

				arg = me.__value[id[1]];
				arg.evntype = 'event';
			}
		}

		if (!arg) return false;

		if (me._oncontext) me._oncontext(e,elm,arg);
		me.__exeEvent('oncontext',e,{"elm":elm,"owner":me,"arg":arg});

		return false;
	};

	/* Browser CSS hack for scrollbar width check */

	var img = this._getAnchor('img');
	img.onload = function(){
		var eh = me._getAnchor('header');
		if (eh){
			var sbar = me.__eContainer2.offsetWidth - me.__eContainer2.clientWidth - 1;
			eh.style.paddingRight = (sbar<10?18:sbar)+"px";
			eh = null;
		}

		return true;
	};

};

/**
 * Set rights for object
 **/
_me._rights = function(v){
	if (!v) return this.__rights;
	this.__rights = v;
};

/**
 * @brief : view range setter
 * @status: COMPLETE
 * @date  : 8.9.2006 13:17:44
 **/
_me._range = function(iStart,iEnd,iTimeStart,iTimeEnd){
	if (iStart && iEnd){
		this.__start = parseInt(iStart);
		this.__end   = parseInt(iEnd);

		this.__startTime = parseInt(iTimeStart) || 0;
		this.__endTime  = parseInt(iTimeEnd) || 0;
		
		if (this.__value && count(this.__value)) this._fill();
	}
 	else
		return {"start":this.__start,"end":this.__end};
};

/**
 * @brief : set or returns events in object
 * @status: COMPLETE
 * @date  : 18.9.2006 15:48:48
 **/
_me._value = function(v){
	if (Is.Object(v) && count(v))
		this._fill(v);
	else
		return this.__value;
};

/**
 * @brief : update datasets
 * @status: COMPLETE
 * @date  : 18.9.2006 15:48:48
 **/
_me.__update = function (sDataSet){
      if (!sDataSet) return;

      /* update evenst */
      if (this._listener_data == sDataSet){
	     this._value(dataSet.get(this._listener_data,this._listenerPath_data));
	  }

	  /* update range */
      if (this._listener == sDataSet){
          var tmp = dataSet.get(this._listener,this._listenerPath);
		  this._range(tmp['start'],tmp['end']);
	  }
};

/**
 * @brief : fill method, draw events and calendar grid
 * @status: COMPLETE
 * @date  : 11.9.2006 16:36:36
 **/
_me._fill = function(aDataIn){

	// prepare data
	if (typeof aDataIn == 'object') this.__value = clone(aDataIn,1);
	
	this.__idTable = [];

	var aTmpData;
	for(var i in this.__value){

		if (this.__value[i]['id']=='/' || this.__value[i]['id']=='#' || this.__value[i]['$']) continue;

        this.__value[i].startdate = parseInt(this.__value[i].startdate);
        this.__value[i].starttime = parseInt(this.__value[i].starttime);
        this.__value[i].endtime   = parseInt(this.__value[i].endtime);
        this.__value[i].enddate   = parseInt(this.__value[i].enddate);

		if (this.__value[i]['startdate'] < this.__value[i]['enddate'] && this.__value[i].endtime==0){
		    this.__value[i]['enddate']--;
		    this.__value[i]['endtime'] = 86400;
		}

		for(var j = this.__value[i]['startdate']; j<=this.__value[i]['enddate']; j++){

            aTmpData = clone(this.__value[i]);
            aTmpData['tmpid'] = i;

            if (this.__value[i]['starttime']>-1){
				if (this.__value[i]['enddate']>j) aTmpData['endtime'] = 86400;
				if (this.__value[i]['startdate']<j) aTmpData['starttime'] = 0;
			}

			if (typeof this.__idTable[j] == 'undefined') this.__idTable[j] = [];
			this.__idTable[j].push(aTmpData);
		}
	}

	//restrict
	var aData = {};
	for(var i = this.__start; i<=this.__end; i++)
		aData[i] = clone(this.__idTable[i]);

	//clear HTML Title
	while (this.__eTitle.childNodes.length)
		this.__eTitle.removeChild(this.__eTitle.childNodes[0]);
		
	// remove SELECTION and all it's DIVs
	for(var i in this.__edivs){
       	this.__edivs[i].parentNode.removeChild(this.__edivs[i]);
		this.__edivs[i] = null;
	}
	this.__edivs = [];
	this._selection = {};

	//clear HTML Main
	while (this.__eMain.childNodes.length)
		this.__eMain.removeChild(this.__eMain.childNodes[0]);

	//private sort function
	function sortdata(a,b){
		var x = a['start']-b['start'];
		if (x == 0) x = (b['end']-a['end']);
		return x;
	};
	
	//private sort function for AllDayEvents
	function sortallday(a,b){
		//Holidays
		if (a['evnclass']=='H' && b['evnclass']!='H')
		    return -1;
		else
		if (a['evnclass']!='H' && b['evnclass']=='H')
		    return 1;

		if (a['title'] && b['title']){
			if (a['title']<b['title'])
				return -1;
			else
			if (a['title'] == b['title'])
			    return 0;
			else
			    return 1;
		}
		else
		if (a['id']<b['id'])
			return -1;
		else
		if (a['id'] == b['id'])
		    return 0;
		else
		    return 1;
	};

	//private cursor function
	function swapcursor(e){
				var e = e || window.event;
				var elm = e.target || e.srcElement;

				var x = e.x || e.layerX;
				var y = e.y || e.layerY;

                if (typeof x == 'undefined' || typeof y == 'undefoned'){
					elm.style.cursor = 'default';
					return;
				}
				
				if (x <= 6){
					if (elm.style.cursor != 'Move')
						elm.style.cursor = 'Move';
				}
				else
				if (x && elm.style.cursor != 'n-resize')
					elm.style.cursor = 'n-resize';
	};
	
	var etd,ettd,ediv,ediv2,initPos;
	
	var months = [
		"months::january","months::february","months::march","months::april","months::may",
		"months::june","months::july","months::august","months::september","months::october",
		"months::november","months::december"
		];

	var colsize = 100/(count(aData) || 1);

	var adcount = 0,adcount2 = 0;
    var aDays = ['SHORT_DAYS::SUNDAY','SHORT_DAYS::MONDAY','SHORT_DAYS::TUESDAY','SHORT_DAYS::WEDNESDAY','SHORT_DAYS::THURSDAY','SHORT_DAYS::FRIDAY','SHORT_DAYS::SATURDAY'];
    var oJSDate = new Date();

    for (var i = this.__start; i<=this.__end; i++){
	//for (var i in aData){

		var aAllDay = [];
		var oDate = parseJulianDate(i);

        oJSDate.setQTime(i);

		//title TD
		ettd = mkElement('td');
		ettd.style.width = colsize + '%';
		ettd.id = this._pathName+'title/'+i;
		ettd.innerHTML = '<div class="obj_evnviewday" unselectable="on">' + getLang(aDays[oJSDate.getDay()]) +' '+ oDate.day +' '+ getLang(months[oDate.month-1]) +'</div>';
        
		//mian TD
	    etd = mkElement('td');
        setSelectNone(etd);
		etd.style.width = colsize + '%';
		etd.id = this._pathName+'/'+i;

		//continue, if day is blank
		if (!aData[i] || !aData[i].length){
			this.__eTitle.appendChild(ettd);
	        ettd = null;
			this.__eMain.appendChild(etd);
			etd = null;
			continue;
		}

        // create START & END
		for (var j = aData[i].length-1;j>-1;j--){

			//All day
			if (aData[i][j]['starttime']<0){
                aAllDay.push(aData[i][j]);
				aData[i].splice(j,1);
				continue;
			}

			//add Start & End
			aData[i][j]['start'] = Math.floor(aData[i][j]['starttime']/1800);
			aData[i][j]['end'] = Math.ceil(aData[i][j]['endtime']/1800);
			if (aData[i][j]['start'] >= aData[i][j]['end']) aData[i][j]['end'] = aData[i][j]['start']+1;

			aData[i][j]['position'] = 0;
			aData[i][j]['delimiter'] = 1;
			aData[i][j]['width'] = 1;
		}

		// sort array
		aData[i].sort(sortdata);

		// move block into holes :)
		var j = 0,
			old_j,
			block,
			iend=0,
			relPosition = 0;

		while (aData[i][j]){
			old_j = j;
			block = aData[i][j];
			iend = iend?iend:block['end'];
			relPosition = 0;       // relativni pozice vuci hlavnimu bloku

			//najit celou posloupnost bloku az do urovne 0
			for (var k = j+1,kk = aData[i].length; k<kk; k++){

					//nejaky to omezeni... kdyby to blblo je to tim :)
					if (aData[i][k]['start']>=iend){
						j++;
						break;
					}

					if (iend<aData[i][k]['end']) iend = aData[i][k]['end'];

					//blok lze zasunout
					if (block['end']<=aData[i][k]['start']){

						aData[i][k]['position'] = block['position'];

						aData[i].splice(j+1,0,aData[i][k]);
						aData[i].splice(k+1,1);
						j++;

						break;
					}
					else{
						if (aData[i][k-1]['end'] && aData[i][k]['start']<aData[i][k-1]['end'])
							relPosition++;
							
						aData[i][k]['position'] = aData[i][j]['position'] + relPosition;
					}
			}

			if (!aData[i][j]['position'] && aData[i][j]['start']>=iend)
				iend = 0;
			
			if (old_j == j)
				j++;
		}


		// delimiter
		var tmpData = [],pos,del;
		for(var j=0,DataLng=aData[i].length;j<DataLng;j++){

			if (aData[i][j]['position']==0){

				//zjistit jestli ho neco prekrejva, pokud ne tak continue
				var prekrejva = -1;
				for(var k = j;k<DataLng;k++){

					if (aData[i][k]['position']>aData[i][j]['position']){
						if (aData[i][k]['start']<aData[i][j]['end'])
							prekrejva = k;

						break;
					}
				}
				if (prekrejva<0) continue;

				// zjistit pocet columns z potomku
                del = 1;
                pos = 0;
				for(var k = prekrejva;k<DataLng;k++){
					if (aData[i][k]['position'] <  pos) break;
					if (aData[i][k]['position'] == pos) continue;
					
					pos = aData[i][k]['position'];
					del = pos+1;
				}

				/*
				  @Note:
				  j...(k-1) - klice celeho seskupeni bloku
				  del       - delimiter
				*/

				//priradit delimiter celemu bloku

				/*
				  @Note:
				  naschval pouzivam opet "j" aby dalsi iterace nadrazene smycky
				  zacala az za seskupenim
				*/
				for(;j<k;j++){                  // pozor jestli je J dostatecne velke!
					aData[i][j]['delimiter'] = del;

					var dif = 0;

					for (var l = j+1;l<k;l++){
						if (aData[i][j]['position']<aData[i][l]['position'] && aData[i][j]['start']<aData[i][l]['end'] && aData[i][j]['end']>aData[i][l]['start']){
							dif = aData[i][l]['position'] - aData[i][j]['position'];
							break;
						}
					}
					if (dif>1)
						aData[i][j]['width'] = dif;
					else
					if (dif == 0 && aData[i][j]['position']+1<aData[i][j]['delimiter'])
						aData[i][j]['width'] = aData[i][j]['delimiter'] - aData[i][j]['position'];
				}
				j--;

			}
		}

		var value;
		initPos = 0;

		for (var j=0,jj=aData[i].length;j<jj;j++){

			// start position
			aData[i][j]['init'] = initPos;
			initPos += aData[i][j]['end'] - aData[i][j]['start'];

			// event div
			ediv = mkElement('div');

			setSelectNone(ediv); // no select (inheritance doesnt work in  MSIE)
			
			ediv.className = 'obj_evnviewevn' + (this.__rights.modify?'':' obj_evnviewevn_disabled');
			ediv.id = this._pathName +'/'+i+'/'+aData[i][j].tmpid;
			ediv.style.top = (this.__rowheight*(aData[i][j]['start']-aData[i][j]['init'])) + 'px';
			ediv.style.height = (this.__rowheight*(aData[i][j]['end'] - aData[i][j]['start'])) + 'px';

			if (this.__rights.modify)
				ediv.onmousemove = swapcursor;

			ediv.style.width = ((100/aData[i][j]['delimiter'])*aData[i][j]['width'])+'%';
			ediv.style.left  = ((100/aData[i][j]['delimiter'])*aData[i][j]['position']) +'%';
				
			//text
			ediv2 = mkElement('div');

			setSelectNone(ediv2); // no select (inheritance doesnt work in  MSIE)

			value = this.__value[aData[i][j].tmpid];

			if (value.color){
				ediv.style.backgroundColor = value.color;
				var color = colors.hex2rgb(value.color);
					color = colors.rgb2hsl(color[0],color[1],color[2]);

				if (color[2]<120){
					if (color[0]>30 && color[0]<80){
						if (color[2]<65)
						ediv.style.color = '#FFFFFF';
					}
					else
						ediv.style.color = '#FFFFFF';
				}
			}

			ediv2.innerHTML = parseJulianTime(value.starttime) +'-'+ parseJulianTime(value.endtime) +' '+ (value.title?value.title.escapeHTML():getLang("EVENT_VIEW::NOTITLE"));
			ediv.appendChild(ediv2);

			etd.appendChild(ediv);
			ediv = null;
		}


		var adtmp;
		var adcount2 = aAllDay.length;
		if (adcount2){
			if (adcount2>adcount) adcount = adcount2;

			aAllDay.sort(sortallday);

			for (var ad in aAllDay){
				adtmp = mkElement('div');
				adtmp.className = 'obj_evnviewallday' + (aAllDay[ad]['evnclass']=='H'?' obj_evnviewholiday':'');
				adtmp.id = this._pathName +'/'+i+'/'+aAllDay[ad].tmpid;

				if (aAllDay[ad]['evnclass']=='H')
					adtmp.innerHTML = aAllDay[ad].title;
				else
					adtmp.innerHTML = (aAllDay[ad].title?aAllDay[ad].title.escapeHTML():getLang("EVENT_VIEW::NOTITLE"));

				setSelectNone(adtmp);

				//All day
				ettd.appendChild(adtmp);
				adtmp = null;
			}
		}
		this.__eTitle.appendChild(ettd);
		ettd = null;
		this.__eMain.appendChild(etd);
		etd = null;
		
		// return All days into aData
		aData[i] = aData[i].concat(aAllDay);
	}

	this.__eContainer.style.paddingTop = ((adcount + 1)*this.__topheight) + 'px';

	//set range
	if (this.__startTime){
		this.__eContainer2.scrollTop = this.__rowheight*this.__startTime*2;

		var tmpt1 = this._getAnchor('time1');
			tmpt1.style.height = (this.__rowheight*this.__startTime*2) + 'px';

		this.__startTime = null;
	}
	if (this.__endTime){

		var tmpt2 = this._getAnchor('time2');
			tmpt2.style.top = (this.__rowheight*this.__endTime*2) + 'px';
			tmpt2.style.height = (this.__rowheight*(24-this.__endTime)*2) + 'px';


		this.__endTime = null;
	}
};