_me = obj_mailview.prototype;
function obj_mailview(){};

_me.__constructor = function(sDataSet,sDataPath){
	this._skipsaving = false;
	this._noupdate = false;

	// Browser detection
	this._MSIE = currentBrowser().indexOf('MSIE')>-1;

	this.__eHeader = this._getAnchor('header');
	this.__eSubject = this._getAnchor('subject');
	this.__eFrom = this._getAnchor('from');

	this.__FullHeaders = null;

	this.__eFrame = this._getAnchor('frame');

	this.__doc = this.__eFrame.contentDocument;
	if (typeof this.__doc == 'undefined' || this.__doc == null)
		this.__doc = this.__eFrame.contentWindow.document;
		
	var html =	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"+
				"<html>\n<head>\n"+
				(this._MSIE?'<link type="text/css" rel="stylesheet" href="client/skins/default/css/obj_mailview_body.css" />':'')+
				"\n</head>\n<body></body>\n</html>";

	this.__doc.open('text/html','replace');
	this.__doc.write(html);
	this.__doc.close();

	// Append Style Sheet (all browsers except MSIE)
	if (!this._MSIE){
		var link = this.__doc.createElement('link');
			link.setAttribute("type","text/css");
			link.setAttribute("rel","stylesheet");
			link.setAttribute("href","client/skins/default/css/obj_mailview_body.css");
			this.__doc.getElementsByTagName('head')[0].appendChild(link);
			link = null;
	}

	// Events
	var eFrame = this.__eFrame;
	var win = eFrame.contentWindow;
	function mouseEvn(e){
		var e = e || win.event;

		if (!window.document['on'+e.type]) return false;

		var pos = getSize(eFrame);
		var evn = {"type":e.type,"clientX":e.clientX + pos.x,"clientY":e.clientY + pos.y,'target':(e.target || e.srcElement)};

		window.document['on'+e.type](evn);
	};

	if (win.addEventListener){
		win.addEventListener("mousemove", mouseEvn, false);
		win.addEventListener("mousedown", mouseEvn, false);
		win.addEventListener("mouseover", mouseEvn, false);
		win.addEventListener("mouseup", mouseEvn, false);
		win.addEventListener("click", mouseEvn, false);
		win.addEventListener("context", mouseEvn, false);
	}
	else{
		this.__doc.onmousemove = function(e){ mouseEvn(e); };
		this.__doc.onmousedown = function(e){ mouseEvn(e); };
		this.__doc.onmouseup = function(e){ mouseEvn(e); };
		this.__doc.onclick = function(e){ mouseEvn(e); };
		this.__doc.oncontext = function(e){ mouseEvn(e); };
		this.__doc.onmouseover = function(e){ mouseEvn(e); };
	}

	//Events

	var me = this;

	// FULL HEADERS
	this.__eSubject.ondblclick = function(e,aHandler){

		//get info from dataset
		var aMails = dataSet.get(me._listener,me._listenerPath);
		if (!aMails) return;

		for(var sAccId in aMails)
			for(var sFolId in aMails[sAccId]){
				delete aMails[sAccId][sFolId]['#'];
				delete aMails[sAccId][sFolId]['/'];
				delete aMails[sAccId][sFolId]['$'];
				for(var sItId in aMails[sAccId][sFolId]);
			}

		//Back to normal view
		if (me.__FullHeaders && me.__FullHeaders.aid == sAccId && me.__FullHeaders.fid == sFolId && me.__FullHeaders.iid == sItId){

			//get short headers
			WMItems.list({"aid": sAccId, "fid": sFolId, "iid": sItId, "values": OldMessage.__FULLMAIL_VALUES},me._listener,me._listenerPath,'',aHandler);

			me.__FullHeaders = '';
			return;
		}

		//Load All headers
		var MAILINFO_VALUES = [	'FROM', 'SUBJECT', 'ALL_HEADERS', 'HTML', 'ATTACHMENTS', 'FLAGS', 'HAS_ATTACHMENT', 'PRIORITY',
								'STATIC_FLAGS', 'SMIME_STATUS', 'CONFIRM_ADDR'];

		// Async list item (refresh mailview) and refresh folders (folder tree)
		WMItems.list({"aid": sAccId, "fid": sFolId, "iid": sItId, "values": MAILINFO_VALUES},me._listener,me._listenerPath);

		me.__FullHeaders = {"aid": sAccId, "fid": sFolId, "iid": sItId};
	};

	// predelat do dedice
	if (sDataSet)
		this._listen(sDataSet,sDataPath);
		
	setTimeout('try{'+this._pathName+'._checksize()}catch(e){}',50);
};

	_me._header = function(aData){

		// clear attach
		if (this.attach){
			this.attach._destruct();
			delete this.attach;				//testnout jestli to je treba!
		}

		// clear header
		// clear header
		for (var i = this.__eHeader.childNodes.length-1;i>=0;i--)
			this.__eHeader.removeChild(this.__eHeader.childNodes[i]);

		var scr = this._getAnchor('scroll');
			scr.innerHTML =	'';
			scr.style.display = 'none';

		if (!aData) return;

		var att,tr,th,td,aData2 = [];

		// Order and Langs
		if (aData['TO']){
			aData2[getLang('DATAGRID_ITEMS_VIEW::TO')] = aData['TO'];
			delete aData['TO'];
		}
		if (aData['CC']){
			aData2[getLang('DATAGRID_ITEMS_VIEW::CC')] = aData['CC'];
			delete aData['CC'];
		}
		if (aData['BCC']){
			aData2[getLang('DATAGRID_ITEMS_VIEW::BCC')] = aData['BCC'];
			delete aData['BCC'];
		}

		if (aData['ATTACHMENTS']){
			aData2['ATTACHMENTS'] = aData['ATTACHMENTS'];
			delete aData['ATTACHMENTS'];
		}
		aData2 = arrConcat(aData2,aData);

		// create header
		for (var i in aData2){

			tr = mkElement('tr');
			this.__eHeader.appendChild(tr);


			if (i == 'ALL_HEADERS'){
				td = mkElement('td');
				td.style.width = "100%";
				td.className = 'obj_mailview_allheaders';
				td.colSpan = 2;
				tr.appendChild(td);
			}
			else {
				th = mkElement('th');
				th.style.width= "0.1%";
				td = mkElement('td');
				td.style.width= "99.9%";

				tr.appendChild(th);
				tr.appendChild(td);
			}

			if (i == 'ATTACHMENTS'){

				td.id = this._pathName+'attach';
				this._create('attach','obj_attach_mailview','attach');
				this.attach._aid = this.__aid;
				this.attach._fid = this.__fid;
				this.attach._iid = this.__iid;

				for (var j in aData2['ATTACHMENTS'])
					 this.attach._add({"name":aData2['ATTACHMENTS'][j]['values'].NAME,"size":aData2['ATTACHMENTS'][j]['values'].SIZE,"id":j,"type":aData2['ATTACHMENTS'][j]['values'].TYPE});

				i = getLang('DATAGRID_ITEMS_VIEW::ATTACHMENTS');
				th.innerHTML = i + ':';
			}
			else
			if (i == 'ALL_HEADERS'){
				scr.style.display = 'block';
				if (this._MSIE)
					scr.innerHTML =	aData2[i].replace(/\n/gm,'<br>');
				else
					scr.innerHTML =	aData2[i];
			}
			else{
				if (aData2[i].length>500)
					td.innerHTML = '<div class="scroll_header">'+aData2[i]+'</div>';
				else
					td.innerHTML = aData2[i];
				th.innerHTML = i + ':';
			}

			tr = null; th = null; td = null;
		}

		setTimeout('try{'+this._pathName+'._checksize()}catch(e){}',50);
	};


	_me._checksize = function(){
		var d = this._getAnchor('body');
		var o = this._getAnchor('headers').offsetHeight;
			d.style.paddingTop = o + 'px';
			d.style.marginTop = (-o) + 'px';

			d = null;
	};
	
	
	_me._frame = function(v){

		if (typeof v != 'undefined'){
			var eBody = this.__doc.getElementsByTagName('body')[0];

			if (currentBrowser() != 'Mozilla'){
				eBody.innerHTML = v;
				eBody = null;
				return;
			}
			
			//Firefox 2.0.8 was too slow in case of rewriting big amount of text data thru innerHTML
			var eDiv = eBody.getElementsByTagName('div');
			if (eDiv.length>0){
				var nodes = eBody.childNodes;
				var i = nodes.length-1;
				for(;i>=0;i--)
					eBody.removeChild(nodes[i]);

				nodes = null;
			}

			var eDiv = this.__doc.createElement('div');
			eDiv.innerHTML = v;
			eBody.appendChild(eDiv);

			eDiv = null;
			eBody = null;
		}
		else{
			try{
				if (currentBrowser() != 'Mozilla')
					this.__doc.getElementsByTagName('body')[0].innerHTML;
				else
					return this.__doc.getElementsByTagName('div')[0].innerHTML;
			}
			catch(e){
				return '';
			}
		}
	};
	
	_me.__update = function(sName)
	{
		var aItems = dataSet.get('items');
		var aMails = dataSet.get(this._listener,this._listenerPath);

//try{

		if (!aItems || !aMails)
			this._value(); //"FROM":'',"TO":'',"SUBJECT":'',"HTML":'',"CC":''
		else {
			//Get Item info
			for(var sAccId in aMails){
				for(var sFolId in aMails[sAccId]){
					delete aMails[sAccId][sFolId]['#'];
					delete aMails[sAccId][sFolId]['/'];
					delete aMails[sAccId][sFolId]['$'];
					for(var sItId in aMails[sAccId][sFolId])
						break;

					break;
				}
				break;
			}

			//disable full headers
			if (this.__FullHeaders && (this.__FullHeaders.aid != sAccId || this.__FullHeaders.fid != sFolId || this.__FullHeaders.iid != sItId))
				this.__FullHeaders = '';

			if (sItId.indexOf('|')<0){
				if (!aItems[sAccId] || !aItems[sAccId][sFolId] || !aItems[sAccId][sFolId][sItId]){
					this._value();
					return;
				}
				aItems = aItems[sAccId][sFolId][sItId];
			}
			else
				aItems = {};

			aMails = clone(aMails[sAccId][sFolId][sItId]);

			delete aMails.aid;
			delete aMails.fid;
			delete aMails.FLAGS;
			delete aMails.STATIC_FLAGS;
			delete aMails.HAS_ATTACHMENT;
			delete aMails.SMIME_STATUS;
			delete aMails.PRIORITY;
			delete aMails.CONFIRM_ADDR;
			delete aMails.DATE;
			delete aMails.REPLY_TO;
			delete aMails.SIZE;

			aMails.AID = sAccId;
			aMails.FID = sFolId;
			aMails.IID = sItId;
			aMails.SUBJECT = aItems['SUBJECT'] || aItems['SNDSUBJECT'] || aMails['SUBJECT'];
			aMails.FROM = aItems['FROM'] || aItems['SNDEMAIL'] || aMails['FROM'];

			this._value(aMails);
		}
		
//}catch(r){inspect2(r);}

	};

	_me.__showImages = function(bHide) {

		if (bHide){
			var elm = this.__doc.getElementById(this._pathName+'frame_images');
			if (elm){
				elm.parentNode.removeChild(elm);
				elm = null;
			}
			return;
		}

		if (!this.__aImages)
			return;

		var sImgFrame = '<div id="'+this._pathName+'frame_images" class="obj_mailview_images">';
		var sFullPath = this.__aid+'/'+this.__fid+'/'+this.__iid;
		var aURL;
		for (var i in this.__aImages) {
			aUrl = {'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':sFullPath+'/'+this.__aImages[i]};
			sImgFrame += '<img src="server/download.php?' + buildURL(aUrl) + '" alt="' +i+ '" title="' +i+ '" />';
		}
		sImgFrame += '</div>';

		this.__doc.getElementsByTagName('body')[0].innerHTML += sImgFrame;
	};

	_me._print = function(){
		if (!this.__aid || !this.__fid || !this.__iid || !this.__doc) return false;

		if (this.__FullHeaders){
			this.__eSubject.ondblclick(null,[this,'_print']);
			return false;
		}

		this.__eFrame.contentWindow.focus();
		this.__eFrame.contentWindow.print();

		return true;
	};

	_me._value = function(aData){
		if (!aData){

			this.__aid = '';
			this.__fid = '';
			this.__iid = '';

			this.__FullHeaders = '';

			this.__eSubject.innerHTML = '';
			this.__eFrom.innerHTML = '';
			this.__aImages = {};
			if (this.btn_show) this.btn_show._destruct();
			this._frame('');
			this._header();
			return;
		}

		/*
		if (this.__FullHeaders)
			 addcss(this._getAnchor('scroll'),"obj_mailview_scroll");
		else
			removecss(this._getAnchor('scroll'),"obj_mailview_scroll");
		*/
		// HTML has higher priority than TEXT
		if (aData['HTML'])
			delete aData['TEXT'];

		var aHeaders = {};
		var sBody = '';
		var aIMIP = [];

		this.__aImages = {};
		for (var i in aData){
			switch(i){
				case 'BASE_URL': break;
				case 'SUBJECT':
					if (Is.String(aData[i]))
						this.__eSubject.innerHTML = aData[i].entityify();
					else
						this.__eSubject.innerHTML = getLang('MAIL_VIEW::NOSUBJECT');
					break;

				case 'FROM':
					if (Is.String(aData[i])){
// LINKS
/*
						var emails = MailAddress.splitEmails(aData[i]);
						for(var mno in emails){
							this.__eFrom.innerHTML += '<a href="javascript:void(0);">'+ emails[mno].entityify() +'</a>';
						}
*/
						this.__eFrom.innerHTML = aData[i].entityify();
					}
					else
						this.__eFrom.innerHTML = '';
					break;

				case 'HTML':
					if (aData[i]) sBody = aData[i];
					break;
				case 'TEXT':
					if (aData[i]) sBody = aData[i].entityify();
					break;

				case 'AID':
					this.__aid = aData[i];
					break;

				case 'FID':
					this.__fid = aData[i];
					break;

				case 'IID':
					this.__iid = aData[i];
					break;

				case 'ATTACHMENTS':

					var arr;
					for(var n in aData[i]) {
						aData[i][n]['values']['NAME'] = aData[i][n]['values']['NAME'].entityify();

						if (aData[i][n]['values']['TYPE']){
							if (aData[i][n]['values']['TYPE'].indexOf('image') == 0)
								this.__aImages[aData[i][n]['values']['NAME']] = n;
							else
							if (aData[i][n]['values']['TYPE'].toLowerCase() == 'text/calendar' && aData[i][n]['values']['IMIP']){
								try{
									arr = XMLTools.Str2Arr(aData[i][n]['values']['IMIP']);
									arr.VCALENDAR[0].PARTID = [{VALUE:n}];
									aIMIP.push(arr);
								}
								catch(r){}
							}
						}
					}

					aHeaders[i] = aData[i];
				break;

				// headers
				default	:
					if(Is.String(aData[i])) aHeaders[i] = aData[i].entityify();
			}
		}

		/** iMip 1 **/
		if (aIMIP.length>0){
			var atmp, stmp = '', stmp2, aData;

			for(var i in aIMIP){

				aData = {};

				atmp = aIMIP[i].VCALENDAR[0];
				if (atmp.VEVENT){
					atmp = atmp.VEVENT[0];
					aData.imip_type = 'VEVENT';
				}
				else
				if (atmp.VTODO){
					atmp = atmp.VTODO[0];
					aData.imip_type = 'VTODO';
				}
				else
				if (atmp.VJOURNAL){
					atmp = atmp.VJOURNAL[0];
					aData.imip_type = 'VJOURNAL';
				}
				else
					continue;

				aData.pid = aIMIP[i].VCALENDAR[0].PARTID[0].VALUE;
				aData.summary = atmp.SUMMARY?atmp.SUMMARY[0].VALUE.entityify():'- - -';

				if (atmp.LOCATION && atmp.LOCATION[0] && atmp.LOCATION[0].VALUE)
					aData.location = atmp.LOCATION[0].VALUE.entityify();

				if (atmp.DTSTART){
					var a = new Date();
						a.setVersit(atmp.DTSTART[0].VALUE);

					if (atmp.DTSTART[0].VALUE.indexOf('T')>-1)
						aData.date = a.toWMString();
					else
						aData.date = a.toWMString(true);

					if (atmp.DTEND || atmp.DTDUE){
						var b = new Date();
							b.setVersit(atmp.DTEND?atmp.DTEND[0].VALUE:atmp.DTDUE[0].VALUE);

						if (a.getDate() == b.getDate() && a.getMonth() == b.getMonth() && a.getFullYear() == b.getFullYear()){
							if (a.getTime() != b.getTime())
								aData.date += ' - ' + b.toWMString(false,true);
						}
						else
						if ((atmp.DTEND?atmp.DTEND[0].VALUE:atmp.DTDUE[0].VALUE).indexOf('T')>-1)
							aData.date += ' - ' + b.toWMString();
						else
							aData.date += ' - ' + b.toWMString(true);
					}

					if (atmp.DESCRIPTION && atmp.DESCRIPTION[0] && atmp.DESCRIPTION[0].VALUE)
						aData.description = atmp.DESCRIPTION[0].VALUE.entityify();
				}

				//DISABLE BUTTONS
				aData.disabled = aIMIP[i].VCALENDAR[0].METHOD[0].VALUE != 'REQUEST';
				sBody += template.tmp('obj_mailview_imip',aData);
			}
		}


		var date = dataSet.get('items',[this.__aid,this.__fid,this.__iid,'DATE']);
		if (date){
			var oDate = new Date();
				oDate.setUNIX(date);
		}

		//add target to links
		//sBody = sBody.replace(/\<[aA]\b/gm,'<a target="_blank" ');

		sBody_data = '<div class="msg_header">'+
		'<h1>'+ (aData['SUBJECT']?aData['SUBJECT'].entityify():'') +'</h1>'+
		'<table>'+
		'<tr><th width="0%">'+getLang('DATAGRID_ITEMS_VIEW::FROM')+':&nbsp;</th><td width="100%">'+ (aData['FROM']?aData['FROM'].entityify():'') +'</td>'+(oDate?'<td width="0%" valign="top" nowrap>'+(oDate?oDate.toWMString():'')+'</td>':'')+'</tr>'+
		(aData['TO']?'<tr><th width="0%">'+ getLang('DATAGRID_ITEMS_VIEW::TO') +':&nbsp;</th><td width="100%" colspan="2">'+ aData['TO'].entityify() +'</td></tr>':'')+
		(aData['CC']?'<tr><th width="0%">'+ getLang('DATAGRID_ITEMS_VIEW::CC') +':&nbsp;</th><td width="100%" colspan="2">'+ aData['CC'].entityify() +'</td></tr>':'')+
		(aData['BCC']?'<tr><th width="0%">'+ getLang('DATAGRID_ITEMS_VIEW::BCC') +':&nbsp;</th><td width="100%" colspan="2">'+ aData['BCC'].entityify() +'</td></tr>':'');

		if (aData['ATTACHMENTS']){
            sBody_data += '<tr><th width="0%">'+getLang('DATAGRID_ITEMS_VIEW::ATTACHMENTS')+':&nbsp;</th><td colspan="2">';

			for (var j in aData['ATTACHMENTS'])
                 sBody_data += (aData['ATTACHMENTS'][j]['values'].NAME || '').entityify() +' ('+ aData['ATTACHMENTS'][j]['values'].SIZE +'); ';

			sBody_data += '</td></tr>';
		}

		sBody_data += '</table></div>' + (sBody || '');

		this._frame(sBody_data);
			

		if (sBody){
			var url = this.__doc.URL;
				url = url.substr(0,url.indexOf('/',url.indexOf('/')+2)+1);

			//add target and BASE to links
			if (aData['BASE_URL']){
				if (aData['BASE_URL'].indexOf('file://')===0)
					delete aData['BASE_URL'];
				else{
					if (!(/\/$/gi.test(aData['BASE_URL'])))
						aData['BASE_URL'] += '/';
					if (!(/^((http)|(https))\:/gi.test(aData['BASE_URL'])))
						aData['BASE_URL'] = 'http://' + aData['BASE_URL'];
				}
			}

			var r = /^((http)|(https)|(ftp)|(mailto))\:/gi;
			var h =  new RegExp("^"+ url.quoteMeta(),"gi");

			var a = this.__doc.getElementsByTagName('a');

			//base UTL because of Safari vs Anchors
		    var base = document.getElementsByTagName('base');
                base = base[base.length-1];

			for (var i = 0; i<a.length; i++){
				if (a[i].href){

					//Anchor
					if (a[i].href.indexOf(document.location.href+'#')==0 || (base && a[i].href.indexOf(base.href+'#')==0)){
						a[i].onclick = function(e){

                            this.ownerDocument.location.hash = '';
							this.ownerDocument.location.hash = this.hash;
							/*
							try to workout FFox3 but it doesn't work :(

							//Safari
							if (currentBrowser() == 'Safari'){
                                this.ownerDocument.location.hash = '';
								this.ownerDocument.location.hash = this.hash;
							}
							else
							//Others
							if (this.ownerDocument.location.href.indexOf(this.hash)<0)
								this.ownerDocument.location = this.ownerDocument.location + this.hash;
							else
								this.ownerDocument.location.href = this.ownerDocument.location.href;
							*/
							
							return false;
						};
					}
					//Mailto
					else
					if (a[i].href.toLowerCase().indexOf('mailto:') == 0){
                        a[i].onclick = function(){
							NewMessage.compose({to:this.href.substr(7)});
							return false;
						}
					}
					//Link
					else{
						a[i].target = '_blank';
						if (aData['BASE_URL'])
							a[i].href = a[i].href.replace(h,aData['BASE_URL']);
					}
				}
			}

			//change URLs for links and img
			if (aData['BASE_URL']){
				var a = this.__doc.getElementsByTagName('link');
				for (var i = 1; i<a.length; i++)  //1 because we skip our CSS
					a[i].href = a[i].href.replace(h,aData['BASE_URL']);

				var a = this.__doc.getElementsByTagName('img');
				for (var i = 0; i<a.length; i++)
					a[i].src = a[i].src.replace(h,aData['BASE_URL']);
			}

			/** iMIP 2 - oziveni tlacitek **/
			if (aIMIP.length>0){
				var frm, elm;

				var aItem = {aid:this.__aid,fid:this.__fid,iid:this.__iid};
				for(var i in aIMIP){

					if ((frm = this.__doc.getElementsByTagName('form')))
						for (var i=0;i<frm.length;i++){
							elm = frm[i].getElementsByTagName('input');
							for (var j=0;j<elm.length;j++){
								if (elm[j].type != 'button') continue;

								elm[j].__disable = function(v){
									var inp = this.form.getElementsByTagName('input');
									for(var i = 0;i<inp.length;i++)
										if (inp[i].type == 'button')
											inp[i].disabled = inp[i]==this?v:!v;
								};

								switch (elm[j].name){
									case 'accept':
										elm[j].onclick = function(e){
											aItem.partid = this.form.partid.value;
											aItem.imip_type = this.form.imip_type.value;

											WMItems.imip(aItem,'accept',[this,'__disable',[true]]);
										}
										break;
									case 'decline':
										elm[j].onclick = function (e){
											aItem.partid = this.form.partid.value;
											aItem.imip_type = this.form.imip_type.value;
											WMItems.imip(aItem,'decline',[this,'__disable',[true]]);
										}
										break;
								}
							}
						}
				}
			}
		}
/*
		else
			this._frame('');
*/

		this._header(aHeaders);

		//show images
		if (count(this.__aImages)>0){
			if (!this.btn_show){
				this._create('btn_show','obj_checkbox','button');
				this.btn_show._title('ATTACHMENT::SHOW_IMAGES');

				this.btn_show._onclick = function(){
				this._parent.__showImages(!this._value());
				};
			}

			storage.library('gw_others');
			if (parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','auto_show_images')) == 1){
				this.btn_show._value(1);
				this.__showImages();
			}
			else{
				this.btn_show._value(0);
				this.__showImages(1);
			}
		}
		else
		if (this.btn_show)
			this.btn_show._destruct();

/*
		storage.library('gw_others');
		if (parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','auto_show_images')) == 1){
			if (this.btn_show)
				this.btn_show._destruct();

			this.__showImages();
		}
		else{
			if(!this.btn_show){
				this._create('btn_show','obj_button','button');
				this.btn_show._value('ATTACHMENT::SHOW_IMAGES');

			}
			if (count(this.__aImages))
				this.btn_show._disabled(0);
			else{
				this.btn_show._value('ATTACHMENT::SHOW_IMAGES');
				this.btn_show._disabled(1);
			}
		}
*/

	};