_me = obj_reminder.prototype;
function obj_reminder() {};

_me.__constructor = function() {
	var me = this;

	// Default values
	this.reminder_1._disabled(true);
	this.reminder_2._disabled(true);
	
	this.checkbox_1._onclick = function() { 
		me.reminder_1._disabled(!this._value()); 
		// when enabling the first reminder for the first time, load default values
		if (!me.__prdka && this._value()) {
			storage.library('gw_others');
			var aReminderDefault = GWOthers.get('DEFAULT_REMINDER_SETTINGS','storage')['VALUES'];
			if (aReminderDefault)
				loadDataIntoForm(me.reminder_1,aReminderDefault);
		}
		me.__prdka = true;
	}
	this.checkbox_2._onclick = function() { 
		me.reminder_2._disabled(!this._value()); 
	}
}

_me._value = function(aValues) {
	if (Is.Defined(aValues)) {
		var aReminder;
		if ((aReminder = shiftObject(aValues)) != null) {
			this.reminder_1._value(aReminder);
			this.checkbox_1._value(true);
			this.reminder_1._disabled(false);
		}
		if ((aReminder = shiftObject(aValues)) != null) {
			this.reminder_2._value(aReminder);
			this.checkbox_2._value(true);
			this.reminder_2._disabled(false);
		}
	} else {
		var aResult = [];
		var aReminder1 = this.reminder_1._value();
		var aReminder2 = this.reminder_2._value();
		
		if (this.checkbox_1._value()) {
			aResult.push(aReminder1);
		} else {
			if (Is.Defined(aReminder1['uid'])) {
				delete aReminder1['values'];
				aResult.push(aReminder1);
			}
		}
		if (this.checkbox_2._value()) {
			aResult.push(aReminder2);
		} else {
			if (Is.Defined(aReminder2['uid'])) {
				delete aReminder2['values'];
				aResult.push(aReminder2);
			}
		}

		return (!isFormEmpty(aResult)) ? aResult : [];
	}
}
