_me = obj_select_import.prototype;
function obj_select_import(){};

_me.__constructor = function(owner){

	this.__selectdata = {
	NONE:'----',
	ITMCLASSIFYAS:getLang('CONTACT::CONTACT_NAME'),
	ITMFIRSTNAME:getLang('CONTACT::FIRST_NAME'),
	ITMMIDDLENAME:getLang('CONTACT::MIDDLE_NAME'),
	ITMSURNAME:getLang('CONTACT::LAST_NAME'),
	ITMTITLE:getLang('CONTACT::TITLE'),
	ITMSUFFIX:getLang('CONTACT::SUFFIX'),
	ITMNICKNAME:getLang('CONTACT::NICK_NAME'),

	ITMCATEGORY:getLang('CONTACT::CATEGORY'),

	LCTEMAIL1:getLang('BACKUP::EMAIL1'),
	LCTEMAIL2:getLang('BACKUP::EMAIL2'),
	LCTEMAIL3:getLang('BACKUP::EMAIL3'),
	LCTWEBPAGE:getLang('CONTACT::WEB'),

	ITMBDATE:getLang('CONTACT::BIRTHDATE'),
	ITMANNIVERSARY:getLang('CONTACT::ANNIVERSARY'),
	ITMGENDER:getLang('CONTACT::GENDER'),
	ITMSPOUSE:getLang('CONTACT::SPOUSE'),

	LCTCOUNTRY:getLang('CONTACT::COUNTRY'),
	LCTSTATE:getLang('CONTACT::STATE'),
	LCTCITY:getLang('CONTACT::CITY'),
	LCTSTREET:getLang('CONTACT::STREET'),
	LCTZIP:getLang('CONTACT::ZIP'),

	PHONE_1:getLang('BACKUP::PHONE1'),
	PHONE_2:getLang('BACKUP::PHONE2'),
	PHONE_3:getLang('BACKUP::PHONE3'),
	PHONE_4:getLang('BACKUP::PHONE4'),
	PHONE_TYPE_4:getLang('BACKUP::PHONE_TYPE4'),
	PHONE_TYPE_3:getLang('BACKUP::PHONE_TYPE3'),
	PHONE_TYPE_1:getLang('BACKUP::PHONE_TYPE1'),
	PHONE_TYPE_2:getLang('BACKUP::PHONE_TYPE2'),

	ITMOFFICELOCATION:getLang('CONTACT::OFFICE_LOCATION'),
	ITMCOMPANY:getLang('CONTACT::COMPANY'),
	ITMJOBTITLE:getLang('CONTACT::JOB'),
	ITMPROFESSION:getLang('CONTACT::PROFESSION'),
	ITMDEPARTMENT:getLang('CONTACT::DEPARTMENT'),
	ITMASSISTANTNAME:getLang('CONTACT::ASSISTANT'),
	ITMMANAGERNAME:getLang('CONTACT::MANAGER'),

	ITMDESCRIPTION:getLang('CONTACT::NOTES'),

	ITMINTERNETFREEBUSY:getLang('CONTACT::CALENDAR_URL')
	};
};

_me.__scrolloffset = function(){
	return {x:this._main.scrollLeft,y:this._main.scrollTop};
};

_me._fill = function(aData){

	//clean old selects
    this._clean();

	//clean Anchors
	for(var i in this._anchors)
		if (i.indexOf('select_')==0)
			delete this._anchors[i];

	//clean html
	this._main.innerHTML = '';
    
    if (typeof aData != 'object' || !count(aData)) return false;

	var len = aData[0].length, out = '<table>';

	//Col group
	for(var i=0; i<len; i++)
		out += '<col>';

	//select header
	out += '<tr>';
	for(var i=0; i<len; i++){
		out += '<th id="'+ this._pathName +'select_'+i+'"></th>';
		this._anchors['select_'+i] = this._pathName +'select_'+i;
	}
	out += '</tr>';
	
	//table body
	for(var i=0; i<aData.length; i++){
		out += '<tr>';
		for(var j=0; j<len; j++){
            out += '<td>'+ (aData[i][j]?aData[i][j].escapeHTML():'') +'</td>';
		}
		out += '</tr>';
	}

    out += '</table>';

	//PRINT
	this._main.innerHTML = out;
	
	//Append selects into <TH>
	var me = this;
	for(var i=0; i<len; i++){
		var obj = this._create('select_'+i,'obj_select','select_'+i);
		    obj._fill(this.__selectdata);
			obj._value('NONE');
			
		    obj._onchange = function(){
				var col = me._main.getElementsByTagName('col')[this._name.substr(7)];

				if (this._value()=='NONE')
                	removecss(col,'active');
				else
					addcss(col,'active');

			};
	}
};

_me._value = function(){

	var out = {},v,ch = this._getChildObjects();
    
	for(var i in ch){
		v = ch[i]._value();
		if (v=='NONE') continue;
		
		if (v.indexOf('LCT')==0){
		    if (!out.LOCATIONS) out.LOCATIONS = [{}];
		    if (!out.LOCATIONS[0].LOCATION) out.LOCATIONS[0].LOCATION = [{}];
		    if (!out.LOCATIONS[0].LOCATION[0].VALUES) out.LOCATIONS[0].LOCATION[0].VALUES = [{LCTTYPE:[{VALUE:'H'}]}];
		    
		    out.LOCATIONS[0].LOCATION[0].VALUES[0][v] = [{VALUE:i}];
		}
		else
		if (v.indexOf('PHONE_TYPE')==0){
		    //blank
		}
		else
		if (v.indexOf('PHONE')==0){
            if (!out.LOCATIONS) out.LOCATIONS = [{}];
			if (!out.LOCATIONS[0].LOCATION) out.LOCATIONS[0].LOCATION = [{}];
		    if (!out.LOCATIONS[0].LOCATION[0].VALUES) out.LOCATIONS[0].LOCATION[0].VALUES = [{LCTTYPE:[{VALUE:'H'}]}];

			if (!out.LOCATIONS[0].LOCATION[0].PHONES)
            	out.LOCATIONS[0].LOCATION[0].PHONES = [{PHONE:[]}];

			//prepare data
			var atmp = {PHNNUMBER:[{VALUE:i}]};

			//search for Type
			var stmp = v.replace('PHONE','PHONE_TYPE');
			for(var j in ch)
				if (ch[j]._value() == stmp)
                    atmp.PHNTYPE = [{VALUE:j}];

            out.LOCATIONS[0].LOCATION[0].PHONES[0].PHONE.push({VALUES:[atmp]});
		}
		else{
		    if (!out.VALUES) out.VALUES = [{}];
			out.VALUES[0][v]=[{VALUE:i}];
		}
	}
	
	return out;
};