_me = obj_suggest_mail.prototype;
function obj_suggest_mail(){};

_me.__constructor = function(){
	this._min = 2;
	this._limit = 15;
};


	_me._qvalue = function(v){

		//revert input to value before suggest execution
        this._value(this.__input_value);

		var s = this._value();

		var end = s.slice(this.__last_pos[1]);
		var txt = s.slice(0, this.__last_pos[0]>0?this.__last_pos[0]+1:0)+(end.trim().indexOf(';')==0 || end.trim().indexOf(',')==0?v:v+';')
		this._value(txt + end);

		this._setRange(txt.length+1);
	};

	_me._qdata = function(v){

		//1. naparsovat separaory do pole
		var col = false, sep = [];
		for (var i=0, l=v.length; i<l; i++){
			switch(v.charAt(i)){
			case ',':
			case ';':
				if (!col)
					sep.push(i);
				break;
			case '"':
				if (!i || (i && v.charAt(i-1) != '\\'))
					col = !col;
			}
		}

		//2. zjistit pozici kurzoru
		var cart = this._getCartPos();

		var pos1 = 0, pos2 = l;
		for (var i = 0; i<sep.length; i++){
			if (sep[i]<cart)
				pos1 = sep[i];
			else
			if (sep[i]>=cart){
				pos2 = sep[i];
				break;
			}
		}

		this.__last_pos = [pos1,pos2];

		//3. ziskat adresu pod kurzorem
		var adr = v.substring(pos1>0?pos1+1:0,pos2);
			adr = adr.trim();

		return adr;
	};



	_me._query = function(v){
		if (!this._listener_data) return;

        if (v.indexOf('[')==0){
			var tmp = v;
			if (!(v = v.replace(/[\[\]]+/g,'')))
			    return;
			
   			this.__last_qdata = {email:tmp};
			
			v = v.quoteSQL();
			var aFilter = {'limit':this._limit,'order_by':'ITMTITLE ASC'};
				aFilter['sql'] = "ITMCLASS = 'L' AND ITMTITLE NOT LIKE '' AND ITMTITLE LIKE '%"+ v +"%'";
		}
		else{
			//4. naparzovat adresu
			var aParsed = MailAddress.splitEmailsAndNames(v)[0];

			aParsed.email = aParsed.email.quoteSQL();

			if (!aParsed.name)
				aParsed.name = aParsed.email;
			else
				aParsed.name = aParsed.name.quoteSQL();

			this.__last_qdata = aParsed;

			var aFilter = {'limit':this._limit,'order_by':'ITMCLASSIFYAS ASC, ITMFIRSTNAME ASC, ITMSURNAME ASC, LCTEMAIL1 ASC, LCTEMAIL2 ASC, LCTEMAIL3 ASC'};

    //mySQL4: aFilter['sql'] = "(LCTEMAIL1 NOT LIKE '' OR LCTEMAIL2 NOT LIKE '' OR LCTEMAIL3 NOT LIKE '') AND " +;


				aFilter['sql'] ="((NOT (LCTEMAIL1 = '')) OR (NOT (LCTEMAIL2 = '')) OR (NOT (LCTEMAIL3 = ''))) AND "+
								'(LCTEMAIL1 LIKE \'%'+aParsed.email+'%\' OR LCTEMAIL2 LIKE \'%'+aParsed.email+'%\' OR LCTEMAIL3 LIKE \'%'+aParsed.email+'%\' OR '+
								'ITMCLASSIFYAS LIKE \'%'+aParsed.name+'%\' OR ITMTITLE LIKE \'%'+aParsed.name+'%\' OR ITMFIRSTNAME LIKE \'%'+aParsed.name+'%\' OR ITMMIDDLENAME LIKE \'%'+aParsed.name+'%\' OR ITMSURNAME LIKE \'%'+aParsed.name+'%\')';
		}

		WMItems.list({'aid':sPrimaryAccount,'fid':Mapping.getDefaultFolderForGWType('C'),'values':['ITMTITLE','ITMCLASS','ITMCLASSIFYAS','ITMFIRSTNAME','ITMMIDDLENAME','ITMSURNAME','ITMSUFFIX','LCTEMAIL1','LCTEMAIL2','LCTEMAIL3','LCTTYPE'],'filter':aFilter},this._listener_data,this._listenerPath_data);
	};

	_me._parse = function(aValues){

		if (!aValues){
			this.__show();
			return;
		}

		//Get last used emails from Cookie
		var rcp,emails = [];

		if ((rcp = dataSet.get('suggest_address'))){
			var emails = MailAddress.splitEmailsAndNames(rcp);

			//inspect2(emails);

			var name = this.__last_qdata.name.toLowerCase();
			var email = this.__last_qdata.email.toLowerCase();
			for (var i = emails.length-1;i>=0;i--){

				//inspect2({name:name,email:email,cookie:emails[i]});

				if (!(emails[i].name && emails[i].name.toLowerCase().indexOf(name)>-1) && emails[i].email.toLowerCase().indexOf(email)<0)
                	emails.splice(i,1);
			}
		}

		
		//Prepare Query data
		this.__eActive = null;
		this.__sQuery_data = '';

		if (!count(aValues)) return;

		for(var aid in aValues)
			for (var fid in aValues[aid]);

		if (aid && fid)
			aValues = aValues[aid][fid];
		else
			return;

		delete aValues['/'];
		delete aValues['#'];
		delete aValues['$'];

		var found,name, email, out;
		for(var i in aValues){

			if (aValues[i].ITMCLASS == 'L'){
				email = ['['+aValues[i].ITMTITLE+']'];
				name  = '';
			}
			else{
				name  = aValues[i].ITMCLASSIFYAS || ((aValues[i].ITMFIRSTNAME || '') + (aValues[i].ITMSURNAME?' '+aValues[i].ITMSURNAME:''));

				if (!aValues[i].LCTEMAIL1 && !aValues[i].LCTEMAIL2 && !aValues[i].LCTEMAIL3)
				    continue;

				email = [];
				if (aValues[i].LCTEMAIL1)
				    email.push(aValues[i].LCTEMAIL1);

				if (aValues[i].LCTEMAIL2)
				    email.push(aValues[i].LCTEMAIL2);

				if (aValues[i].LCTEMAIL3)
				    email.push(aValues[i].LCTEMAIL3);
			}

			for(var j in email){
				found = false;
				for (var k in emails)
					if (emails[k].email.toLowerCase() == email[j].toLowerCase() || (aValues[i].ITMCLASS=='L' && ('['+emails[k].email.toLowerCase()+']') == email[j].toLowerCase())){
						found = true;
						break;
					}

				if (!found)
					emails.push({name:name,email:email[j]});
			}
		}

		//Concat Query and Cookie Data
		function sc(a,b){
			var x = (a.name || '')+a.email.replace(/[\[\]]/g,'');
			var y = (b.name || '')+b.email.replace(/[\[\]]/g,'');
			if (x>y)
				return 1;
			else
			if (x<y)
				return -1;
			else
				return 0;
		};
		
		emails = emails.sort(sc);

		//Create output string
		var out;
		for(var i in emails){
			name  = emails[i].name;
			email = emails[i].email;

			if ((!name || emails[i].dlist || this.__last_qdata.name == name) && (!email || this.__last_qdata.email == email)){
				this.__hide();
				return;
			}

			if (emails[i].email.indexOf('[')==0)
				this.__sQuery_data +='<a href="javascript: void(0);">'+ emails[i].email.escapeHTML() +'</a>';
			else
				this.__sQuery_data +='<a href="javascript: void(0);">'+ MailAddress.createEmail(name,email).escapeHTML() +'</a>';
		}

		this.__show();
	};