_me = obj_tree_folder.prototype;
function obj_tree_folder(){};

/**
 * @date: 6.7.2006 16:28:30
 **/
_me.__constructor = function(sFilterAccountId, sFilterFolderType, sFilterRights)
{

	if (sFilterAccountId)
		this.sFilterAccountId = sFilterAccountId;

	if (sFilterFolderType)
		this._sFilterFolderType = sFilterFolderType;

	if (sFilterRights)
		this._sFilterRights = sFilterRights;

	/* Prepare data & create dataset if dosn't exist */
	var aAccounts = {};
	if (!(aAccounts = dataSet.get('accounts'))){
		aAccounts = accounts.list();
		dataSet.add('accounts',null,aAccounts);
	}
	
	if (!dataSet.get('folders')){
		var aFolders={};
		for (var sAccId in aAccounts)
			aFolders[sAccId] = folders.list({"aid":sAccId})[sAccId];

		dataSet.add('folders',null,aFolders);
	}

	this._listen_data('folders');
};


/**
 * Drag & Drop
 **/
_me._active_dropzone = function(v){
	if(v)
		switch(v['type']){
		case 'item':
			var itmtype = dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']);
			var getTargets = function (data,out){
				if (!out) out = [];
				if (typeof data != 'object') return out;

				for(var i in data){
					if (data[i].arg && itmtype=='M' && data[i].arg.ftype=='QL' && (data[i].arg.aid != v.value[0].aid || data[i].arg.fid != v.value[0].fid))
						out.push(data[i].arg.aid+'/'+data[i].arg.fid);
					else            //&& data[i].arg.ftype == itmtype
 					if (data[i].arg && (itmtype == 'M' || data[i].arg.ftype!='M') && WMFolders.getAccess({aid:data[i].arg.aid,fid:data[i].arg.fid},'write') && (data[i].arg.aid != v.value[0].aid || data[i].arg.fid != v.value[0].fid))
						out.push(data[i].arg.aid+'/'+data[i].arg.fid);

					if (data[i].nodes)
						getTargets(data[i].nodes,out);
				}
				return out;
			};

			this.__aDragFolders = getTargets(this.__aFillData);

			addcss(this._main,'active_drop');
			break;
		case 'folder':
			addcss(this._main,'active_drop');
			break;
		}
	else{
		removecss(this._main,'active_drop');
		this._ondragout();
	}
};

_me._ondragover = function(v){


	var a,size,elm,bOk = false;
    var iScroll = this._main.scrollTop;
    
	if (this.__aDragFolders)
		for (var i=0;i<this.__aDragFolders.length;i++){
			if (!(elm = document.getElementById(this._pathName+'/'+this.__aDragFolders[i])))
	      		continue;

			size = getSize(elm);

			if (v.y>=size.y-iScroll && v.y<=size.y+20-iScroll){

				a = elm.getElementsByTagName('A')[0];
				if (this.___lastdragover != a){
		            if (this.___lastdragover)
						removecss(this.___lastdragover,'dragover');

					this.___lastdragover = a;
			        addcss(a,'dragover');
		        }

				bOk = true;
				break;
			}
			else
			if (this.___lastdragover){
	            removecss(this.___lastdragover,'dragover');
	            this.___lastdragover = undefined;
	        }
		}

	a = null;
	elm = null;
	
	return bOk;
};

_me._ondragout = function(v){
	if (this.___lastdragover)
		removecss(this.___lastdragover,'dragover');

	this.___lastdragover = undefined;
};

_me._ondrop = function(v){
	var size,elm,id = '';
    var iScroll = this._main.scrollTop;
    
	for (var i=0;i<this.__aDragFolders.length;i++){
		if (!(elm = document.getElementById(this._pathName+'/'+this.__aDragFolders[i])))
      		continue;

		size = getSize(elm);

		if (v.y>=size.y-iScroll && v.y<=size.y+20-iScroll){
			id = this.__aDragFolders[i];
			break;
		}
	}
	if (!id) return false;

	var pos;
	if ((pos = id.indexOf('/'))>-1){
	
		var ids = [v.value[0].aid,v.value[0].fid,[]];
		for(var i in v.value)
			ids[2].push(v.value[i].iid);

		var acc = id.substr(0,pos);
		var fol = id.substr(pos+1);
		var t1  = dataSet.get('folders',[acc,fol,'TYPE']);
		var t2  = dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']);
		
		//Drag & Drop doesnt work with popups because of event handlers.
		gui.frm_main.dnd.remove_drag(true);

		if (fol == 'SPAM_QUEUE/Whitelist' || fol == 'SPAM_QUEUE/Blacklist')
			OldMessage.__blackOrWhiteList(ids, fol == 'SPAM_QUEUE/Whitelist');
		else
		if (t1!=t2){

			// DODELAT VALUES s ATT
			var title = [], name, mail, q, note, tmp, arg, out, att = [];
			for(var i in v.value){

                
				arg = {	id:v.value[i].iid,
						fullpath:v.value[i].aid+'/'+v.value[i].fid+'/'+v.value[i].iid,
						embedded:true};

				switch(t2){
				case 'M':
					arg.title = dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'SUBJECT']);
					arg.size =  dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'SIZE']);

					if (!title[0]){
						if (t1=='C'){
                            var splited = MailAddress.splitEmailsAndNames(dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'FROM']));
                            if (splited[0]){
								mail = splited[0].email;
                            	name = splited[0].name;
                            }
						}
						title.push(arg.title);
						
						q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['TEXT']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].TEXT;
					}

					if (t1!='F') arg.title += '.eml';
					
					break;
				case 'F':

				    arg.size = dataSet.get('items',[v.value[i].aid,v.value[i].fid, v.value[i].iid,'EVNCOMPLETE']) || 0;

					var aData = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['EVN_ID']});
					if (aData){
						aData = aData[v.value[i].aid][v.value[i].fid][v.value[i].iid];
						for (var sAtId in aData['ATTACHMENTS'])
							break;

	                    arg.fullpath += '/'+sAtId; //dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'EVNTITLE']);
	                    arg.type = 'push_attachment';
	                    
	                    if (typeof title[0] == 'undefined' && !note)
                            note = aData.EVNNOTE;
                    }

				    break;
				case 'C':
				case 'D':

					if (typeof title[0] == 'undefined' && !note){
                        q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['ITMDESCRIPTION']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].ITMDESCRIPTION;
					}

					if (t1!='F') arg.title = '.vcf';
				    break;

                case 'N':

					if (typeof title[0] == 'undefined' && !note){
                        q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['NOTES']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid].NOTES)
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].NOTES[0].values.NOTE_TEXT;
					}
					
                case 'T':
                case 'E':
				case 'J':

					if (typeof title[0] == 'undefined' && !note){
                        q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['EVNNOTE']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].EVNNOTE;
					}

					if (t1!='F') arg.title = '.vcs';
				}
				
				if (t2!='M'){
					tmp = dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'EVNTITLE']);
					title.push(tmp);
					arg.title = tmp + (arg.title || '');
				}

				att.push(arg);
			}
			
			out = {};

			if (name){
				var sTmp,aName = name.split(' ');
				if (aName.length>1){
					//FirstName
					sTmp = aName.shift();
					if (sTmp.indexOf('.')>0){
						sTmp = sTmp.split('.');
						out.ITMTITLE = sTmp[0];
						out.ITMFIRSTNAME = sTmp[1];
					}
					else
						out.ITMSURNAME = sTmp;

					//MiddleName
					sTmp = aName.shift();
					if (out.length>2 && out[2].indexOf('.')!=0){
						out.ITMMIDDLENAME = sTmp;
						sTmp = aName.shift();
					}

					//SurName
					if (sTmp.indexOf('.')>-1){
						sTmp = sTmp.split('.');
						out.ITMSURNAME = sTmp.shift();
						out.ITMSUFFIX = sTmp.join('.');
					}
					else{
						out.ITMFIRSTNAME = sTmp;

						//Suffix 2
						if ((sTmp = aName.shift()))
							out.ITMSUFFIX = sTmp;
					}
				}

				out.ITMCLASSIFYAS = name;
			}
			
			if (mail)
				out.LOCATIONS = [{values:{LCTTYPE:'H',LCTEMAIL1:mail}}];

			if (note){
				switch(t1){
				case 'C':
				case 'D':
				    out.ITMDESCRIPTION = note;
					break;
				case 'N':
					out.NOTES = [{values:{NOTE_TEXT:note}}];
					break;
				default:
					out.EVNNOTE = note;
				}
			}

			out.EVNTITLE = title.join(', ');
			out.PUSH_ATTACHMENTS = att;

			Item.createInFolder(acc, fol, out);
		}
		else
			Item.__copyOrMoveItems(acc, fol, v.ctrl?'copy':'move', ids);
	}
};






_me.__prepare_data = function(aData)
{
	var aResult = {};
	var aFrame;
	var aSplitFolder;
	var aParcSplitFolder;
	var sFolder;
	var sFolderType;
	var bCanDelete;
	var bCanRename;
	var sTotal;
	var bRecent;
	var sIconClass;
	var sMainClass;
	var bDisabled;

	var aAccounts = {},aAccounts_tmp = dataSet.get('accounts');

	//SORT
	var srt = [];
	for(var i in aAccounts_tmp)
	    if (i!=sPrimaryAccount)
			srt.push(i);

	srt = srt.sort();
    aAccounts[sPrimaryAccount] = aAccounts_tmp[sPrimaryAccount];
	for(var i = 0;i<srt.length;i++)
    	aAccounts[srt[i]] = aAccounts_tmp[srt[i]];
	aAccounts_tmp = null;

    //get common folders
	storage.library('wm_folders');
	var aDefFolders = WMFolders._getDefaultFolders();
	var sTrashFolder = aDefFolders['trash'];
	var sDraftFolder = aDefFolders['drafts'];
	var sSentFolder = aDefFolders['sent'];
	var sSpamFolder = aDefFolders['spam'];

	//get groups
	storage.library('gw_groups');
	var groups = new gw_groups;
	var aGroupsProps = groups.get('storage');
	var aGroups = [];
	for(var n in aGroupsProps)
		if (aGroupsProps[n]['SUBSCRIBED'] == 'true')
			aGroups.push(aGroupsProps[n]['GRPTITLE']);

	//create RegExp for rights
	if (this._sFilterRights)
	    var rRights = new RegExp ('['+this._sFilterRights+']','gi');

	//Procházíme jednotlivé accounts
	for(var sAccId in aAccounts)
	{
		if (this.sFilterAccountId && sAccId != this.sFilterAccountId)
			continue;

		if (aAccounts[sAccId]['DESCRIPTION']){
			aResult[sAccId] = {"nodes":{},"arg":{"aid":sAccId},"text":aAccounts[sAccId]['DESCRIPTION']};
            if (sAccId == sPrimaryAccount+'_rss')
                aResult[sAccId].liclass = 'rss';
		}
		else
			aResult[sAccId] = {"nodes":{},"arg":{"aid":sAccId}};
			


		//Procházíme jednotlivé folders
		for(var sFolId in aData[sAccId])
		{
			//TYPE filter
			if (this._sFilterFolderType)
				if (typeof this._sFilterFolderType == 'object'){
					if (inArray(this._sFilterFolderType,aData[sAccId][sFolId]['TYPE'])<0)
					    continue;
				}
				else
				if (aData[sAccId][sFolId]['TYPE'] != this._sFilterFolderType)
					continue;

			// RIGHTS filter (regExp.test() doesnt work properly in loop)
			if (this._sFilterRights){
                if (!aData[sAccId][sFolId].RIGHTS) continue;
				if (aData[sAccId][sFolId].RIGHTS.replace(rRights,'#').indexOf('#')<0) continue;
			}

			aSplitFolder = sFolId.split("/");
			//sFolderName =
			aParcSplitFolder = [];
			aFrame = aResult[sAccId]["nodes"];

			//Procházíme cestu folderu
			for(var i in aSplitFolder)
			{
				aParcSplitFolder.push(aSplitFolder[i]);
				sFolder = aParcSplitFolder.join('/');

				//Nemáme uzel ještě nastavený
				if (!aFrame[aSplitFolder[i]]){

					//Máme uzel definovaný ve vstupních datech
					if (aData[sAccId][sFolder]){

						sFolderType = aData[sAccId][sFolder]['TYPE'];
						//bCanDelete = (aData[sAccId][sFolder]['CANDELETE'] == 'true') ? true : false;
						//bCanRename = (aData[sAccId][sFolder]['CANRENAME'] == 'true') ? true : false;
						bDisabled = (sFolder != sFolId);

						switch (sAccId + '/' + sFolId){
							case (sAccId+'/INBOX') : sIconClass = 'ico_inbox'; break;
							case sTrashFolder: sIconClass = 'ico_trash'; break;
							case sSentFolder: sIconClass = 'ico_sent'; break;
							case sDraftFolder: sIconClass = 'ico_drafts'; break;
							case sSpamFolder: sIconClass = 'ico_spam'; break;
							case (sAccId+'/Quarantine') : sIconClass = 'ico_quarantine'; break;
							case (sAccId+'/SPAM_QUEUE/Blacklist') :
								sIconClass = 'ico_black';
								break;
							case (sAccId+'/SPAM_QUEUE/Whitelist') : sIconClass = 'ico_white'; break;
							default:
								sIconClass = '';
								if (sFolderType != 'A' || sFolderType != 'R')
									for(var n in aGroups)
										if (sFolId == aGroups[n]){
											sIconClass = 'ico_shared';
											delete aGroups[n];
											break;
										}

								if (!sIconClass)
									sIconClass = (sFolderType ? 'ico_' + sFolderType : '').toLowerCase();
						}

						bRecent = aData[sAccId][sFolder]['RECENT']>0 ? true : false;
						sTotal =  bRecent ? '('+aData[sAccId][sFolder]['RECENT']+')' : '';
						sMainClass = bRecent ? 'recent' : '';


						if (aData[sAccId][sFolder]['NAME'])                                                             //"candelete":bCanDelete,"canrename":bCanRename,
							aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":sFolderType,"disabled":bDisabled},"text":aData[sAccId][sFolder]['NAME'],"title2":'&nbsp;'+sTotal,"ico":sIconClass,"itmclass":sMainClass};
						else                                                                                            //"candelete":bCanDelete,"canrename":bCanRename,
							aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":sFolderType,"disabled":bDisabled},"title2":'&nbsp;'+sTotal,"ico":sIconClass,"itmclass":sMainClass};
					}
					else
					if (sFolder == 'SPAM_QUEUE')                                                           //"candelete":"false","canrename":"false",
						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":"X","disabled":"true"},"title":'COMMON_FOLDERS::SPAM_QUEUE',"title2":' ',"itmclass":sMainClass,"ico":'ico_spamqueue'};
					else                                                                                   //"candelete":"false","canrename":"false",
						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":"X","disabled":"true"},"title2":' ',"itmclass":sMainClass,"ico":'ico_shared'};
				}
				else
				// folder has been marked as disabled, because it was added as a parent of another folder
				// now - when this folder should really be added, disabled flag should be removed
				if (sFolder == sFolId && aData[sAccId][sFolder])
					aFrame[aSplitFolder[i]]["arg"]["disabled"] = false;

				aFrame = aFrame[aSplitFolder[i]]["nodes"];
			}
		}
		
		if (this._sFilterFolderType && Is.Empty(aResult[sAccId]['nodes']) && sAccId != sPrimaryAccount) delete aResult[sAccId];
	}

	return aResult;
};

/**
 * @brief: redraw tree object
 **/
_me._fill = function (aData){

	/* retrieve data from dataset */
	if (!aData) aData = dataSet.get(this._listener_data,this._listenerPath_data);
	if (!aData){
		/* clear container object */
		this._main.innerHTML = '';
		return;
	}

	//important for Drag & Drop
	this.__aFillData = this.__prepare_data(WMFolders.sort(aData));
	this.__row(this.__aFillData);
};