_me = obj_vdock.prototype;
function obj_vdock(){};
/**
 * dockovane objekty:
 *      _dock = null;
 *      _docked = false;
 *
 *      _ondock()
 *      _onundock()
 *
 * gui bude mit vlastnist _dock, kde bude ulozen DOCK s true v constructoru a ten se bude brat jako default
 *
 **/
_me.__constructor = function(bDefault){
	// set default
	if (bDefault) gui._dock = this;

	this._docked = [];

	this._add_destructor('__unregistr');

	var me = this;

	this._main.onclick = function(e){

		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName!='SPAN') return;

		var id = elm.id.substr(me._pathName.length);
		
		me._remove(me._docked[id]);

	}

};

/**
 * @brief:	destructor,
 *			removes dock object from gui._dock in case of object is default dock for gui
 **/
_me.__unregistr = function(){
	if (gui._dock === this) delete gui._dock[this._name];
	
	for(var i in this._docked){
		if (this._docked[i]._onundock)
			this._docked[i]._onundock(this,i);
	}
};

_me._remove = function(Obj){

	var id;
	if (typeof Obj != 'object' || (id = inArray(this._docked,Obj))<0) return;

	if (Obj._undock) Obj._undock(this,id);

	var elm;
	if ((elm = document.getElementById(this._pathName+(id)))){
		elm.parentNode.removeChild(elm);
		delete this._docked[id];
	}

};

_me._add = function(Obj,sTitle){

	if (typeof Obj != 'object' || inArray(this._docked,Obj)>-1) return;

	// add to dock
	var id = this._docked.length;
	this._docked[id] = Obj;

	var elm = mkElement('SPAN',{"href":'',"id":this._pathName + id});
		elm.className = 'ico_'+Obj._type;
		elm.title = sTitle;

	this._getAnchor('main').appendChild(elm);
};