<div class="popupmaindialog">
<table class="frmtbl">
<tr>
	<th>{COMMON::EMAIL}</th>
	<td>
		<obj name="EMAIL" type="obj_input" focus="true">
			<restrictions>
				<item>^([a-z0-9][\\-\\_\\.]?)*[a-z0-9]+\\@[a-z0-9]+([\\.\\-\\_]?[a-z0-9])*\\.[a-z]{2,4}$</item>
				<item>{sPrimaryAccount}</item>
			</restrictions>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::USERNAME}</th>
	<td>
		<obj name="USERNAME" type="obj_input">
			<restrictions>^.+$</restrictions>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::PASSWORD}</th>
	<td>
		<obj name="PASSWORD" type="obj_password">
			<restrictions>^.+$</restrictions>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::PROTOCOL}</th>
	<td>
		<obj name="PROTOCOL" type="obj_select">
			<value>imap</value>
			<fill>
				<item key="imap">{ACCOUNT_TYPES::IMAP}</item>
				<item key="pop3">{ACCOUNT_TYPES::POP3}</item>
			</fill>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::SERVER}</th>
	<td>
		<obj name="SERVER" type="obj_input">
			<restrictions>.+</restrictions>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::PORT}</th>
	<td>
		<obj name="PORT" type="obj_input">
			<restrictions>
				<item>&gt;0</item>
				<item>&lt;65536</item>
			</restrictions>
		</obj>
	</td>
</tr>
<tr>
	<th>{FORM_ACCOUNTS::DESCRIPTION}</th>
	<td><obj name="DESCRIPTION" type="obj_input" ></obj></td>
</tr>
</table>
</div>