testFile('dataset');

function datasetTester() {
   var   testVariable;

   this.__update = function() {
      this.testVariable = 20;
   }
};

/******************************************************************************/

/**************** Test 1 **************
 * Try to add some data to dataset and read it back
 */ 
dataSet.add('test', ['level1', 'level2'], ['ahoj', 'nazdar']);
var ret = dataSet.get('test', ['level1', 'level2']);

assert('Test1', ret[0] == 'ahoj' && ret[1] == 'nazdar');

/**************** Test 2 **************
 * Try to remove data from dataset
 */
dataSet.remove('test', ['level1', 'level2']);

assert('Test2', typeof dataSet.get('test', ['level1', 'level2']) == 'undefined');

/**************** Test 3 **************
 * Check obey
 */
var datasetTester = new datasetTester();
datasetTester.testVariable = 10; 
dataSet.obey(datasetTester, null, 'test');

assert('Test3', datasetTester.testVariable == 20);

/**************** Test 4 **************
 * Check update
 */

datasetTester.testVariable = 10;
dataSet.update('test');
assert('Test4', datasetTester.testVariable == 20);

/**************** Test 5 **************
 * Check disobey
 */
datasetTester.testVariable = 10;
dataSet.disobey(datasetTester);
dataSet.update('test');
assert('Test5', datasetTester.testVariable == 10);
