<?php
global $aError;
//An array that contatins strings for error messages
$aError = Array(
				//XML Request
				'invalid XML' => 'invalid XML',
				'invalid root tag' => 'invalid root tag',
				'missing sid' => 'missing sid',
				'expired sid' => 'expired sid',
				'invalid sid' => 'bad session id',
				'missing query tag' => 'missing query tag',
				'missing query::xmlns attribute' => 'missing query::xmlns attribute',
				'invalid query::xmlns attribute' => 'invalid query::xmlns attribute',
				'class doesnt exists' => 'class doesnt exists',
				'file not exists' => 'file doesn\'t exists',
				//Private and Public
				'missing storage tag' => 'class PrivateAndPublic: missing <storage/> tag',
				'missing xmlns attribute' => 'class PrivateAndPublic: <storage/> missing xmlns attribute',
				'cannot write data to namespace' => 'class PrivateAndPublic: cannot write data to namespace',
				'invalid path'=> 'class PrivateAndPublic: invalid path',
				'invalid file'=> 'class PrivateAndPublic: invalid file',
				'invalid filter'=> 'class PrivateAndPublic: invalid filter syntax',
				'permittions' => 'class PrivateAndPublic: writing into user dir denied',
				'access denied' => 'class PrivateAndPublic: access denied for unauthorized users',
				//Iq - message
				'missing subject' => 'class WebmailIqMessage: missing \'subject\'',
		  		'missing from' => 'class WebmailIqMessage: missing \'from\'',
		  		'missing to' => 'class WebmailIqMessage: missing \'to\'',
		  		'missing body' => 'class WebmailIqMessage: missing \'body\' or \'htmlbody\'',
		  		//Iq - folders
	  			  'missing account'=>'class WebmailIqFolders: ACCOUNT tag missing',
				  'missing folder'=>'class WebmailIqFolders: FOLDER tag missing',
				  'missing aid'=>'class WebmailIqFolders: account ID missing',
				  'invalid aid'=>'class WebmailIqFolders: invalid account ID',
				  'missing id'=>'class WebmailIqFolders: folder ID missing',
				  'missing action'=>'class WebmailIqFolders: folder ACTION missing',
				  'invalid action'=>'class WebmailIqFolders: invalid folder ACTION',
				  'f_add_failed'=>'class WebmailIqFolders: Folder creation failed',
				  'g_open_failed'=>'GroupWare: Open group failed',
				  'f_open_failed'=>'GroupWare: Open folder failed',
				  'g_close_failed'=>'GroupWare: Close group failed',
				  'f_close_failed'=>'GroupWare: Close folder failed', 
				  'f_sync_gw'=>'class WebmailIqFolder: Groupware folder cannot be synchronized',
				
				//Iq - items
				  'missing account'=>'class WebmailIqFolders: ACCOUNT tag missing',
				  'missing folder'=>'class WebmailIqFolders: FOLDER tag missing',
				  'missing fid'=>'class WebmailIqItems: folder ID missing',
				  'invalid fid'=>'class WebmailIqItems: invalid folder ID',
				  'i_edit' =>'class WebmailIqItems: item can not be edited(email)',
				  'i_missing_item' =>'class WebmailIqItems: item element missing',
				  'i_missing_action' =>'class WebmailIqItems: item action missing',
				  'i_invalid_action' =>'class WebmailIqItems: invalid action specified',
				// GW - items
				'gwi_addon_delete'=>'GW Item : %s delete failed',		  	  
				  
				//Iq - auth
				'missing method' => 'class WebmailIqAuth: missing method',
				'unsupported method' => 'class WebmailIqAuth: unsupported method',
				'missing tag' => 'class WebmailIqAuth: missing tag: ',
				'heshid expired'=> 'class WebmailIqAuth: too long conection lag - hashID expired',
				//Iq - accounts
				'invalid action'=>'class WebmailIqAccounts: Invalid attribute ACTION',
				'invalid id'=>'class WebmailIqAccounts: Invalid attribute ID',
				'missing account'=>'class WebmailIqAccounts: Missing ACCOUNT tag',
				'missing eaccount'=>'class WebmailIqAccounts: Account you want to edit does not exist',
				'a_pad' => 'class WebmailIqAccounts: Cannot delete primary account',
				//User
				'invalid login' => 'Bad username or password',
				'permitions' => 'invalid file permitions',
				'u_missing_account' => 'class User : Account %s does not exist',
				//Groups 
				'g_no_values' => 'class WebmailIQGroups : No values specified',
				'g_data_missing' => 'class WebmailIQGroups : Import : Missing data',
				'g_id_missing' => 'class WebmailIQGroups : Delete : Missing group id',
				'g_delete_friend'=>'class PrivateAndPublic : Delete friend failed',
				//DB
				'db_bad_statement'=>'Database : Bad statement : %s'
				)



			  
?>
