<?php

require_once('inc/variable.php');

/**
  @class Get
  @brief Class for getting input variables from _GET array.
 */
class Get extends Variable {
	/** Instance of the class. */
	private static $instance = null;

	/**
	  @brief Get instance of the class.
	  @return The instance.
	 */
	public static function instance()
	{
		if (!isset(self::$instance)) {
			$class = __CLASS__;
			self::$instance = new $class($_GET);
		}

		return self::$instance;
	}
}

/**
  @brief Get the instance of class Get.
  @return The instance.
 */
function Get()
{
	return Get::instance();
}

?>
