<?php
interface ActionInterface
{
}

class WMAction extends Singleton
{
	public function checkInput()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$sNamespace = $oWMRequest->get('namespace');
		$sAction = $oWMRequest->get('action');
		$sView = $oWMRequest->get('view');
		if($sNamespace && $sAction)
		{
			if($sNamespace!='none'){
				$sExecutionLibrary = './interface/inc/action/'.strtolower($sNamespace).'.php';

				if(file_exists($sExecutionLibrary)){
					require_once($sExecutionLibrary);
					
					$this->oExec = new $sNamespace();
				} else{
					throw new Exc('no_action_class',$sNamespace);
				}
				if(!$this->sAction = $sAction){
					throw new Exc('no_action_action',$sAction);
				}
				$this->oExec->check($this->sAction);
			}
		}

		$this->sView = $sView;
	}
	
	public function execInput()
	{

		$oWMRequest = &Singleton::instance('WMRequest');
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');

		if($this->oExec && $this->sAction){
			$sAction = $this->sAction;
			$aResult = $this->oExec->$sAction();
		}
		
		if(!$oWMUserInterface->getView()){
			$oWMUserInterface->setView($oWMRequest->get('view'));
		}
		if(!$oWMData->get('general','sid')
			&& $oWMRequest->get('sid')){
			$oWMData->store('general','sid',$oWMRequest->get('sid'));
		}
		
		return $aResult;
	}
}
?>