<?php

//TODO : methods instead of one method getBody
class obj_table extends UIObject
{
	public function create($aConstruct)
	{
		
		parent::create($aConstruct);
		$oWMData = &Singleton::instance('WMData');
		$oWMLanguage = &Singleton::instance('WMLanguage');
		$oWMRequest = &Singleton::instance('WMRequest');
		$oXML = $this->getProperty('xml');
		
		//Configuration
		// can we select items ?
		$bSelectable = strval($oXML->config->selectable["enabled"])=='true'?true:false;
		$sSelectVariable = strval($oXML->config->selectable->variable);
		$sFormName = strval($oXML->config->form_name);
		$sFormID = strval($oXML->config->form_id);
		$sFormVariable = strval($oXML->config->form_variable);

		$this->setTemplateData('form_id',$sFormID);
		$this->setTemplateData('form_name',$sFormName);
		$this->setTemplateData('form_variable',$sFormVariable);
		$this->setTemplateData('selectable',$bSelectable);
		
		if($oXML->config->cut){
			foreach($oXML->config->cut as $index => $value){
				$cut[$index] = strval($value);
			}
		}
		//Override
		$cut = array(
			'subject'=>30,
			'from'=>25,
			'to'=>25,
			'heading'=>25);


		
		
		//Transform data(headers,content)
		$this->showDefault();
		
		//dmp($oWMLanguage);
		//Buttons
		$aButtons = $oXML->config->buttons->button;
		if($aButtons){
			foreach($aButtons as $button){
				$aLabel = explode('|',strval($button["label"]));
				$aConfirm = explode('|',strval($button["confirm"]));
				$buttons['num'][] = array
				(
					'name'=>strval($button["name"]),
					'label'=>strval($oWMLanguage->get($aLabel[0],$aLabel[1])),
					'confirm'=>$aConfirm?$oWMLanguage->get($aConfirm[0],$aConfirm[1]):false
				);
			}
		}
		//Listing
		$this->setTemplateData('actualPage',$oWMData->get('lister','page'));
		$this->setTemplateData('totalPages',$oWMData->get('lister','total'));
		$this->setTemplateData('buttons',$buttons);
		
		//FIXME : Do this globally ?
		$this->setTemplateData('script',basename($_SERVER['PHP_SELF']));
		$this->setTemplateData('view',$oWMData->get('general','view'));
		$this->setTemplateData('rid',$oWMData->get('general','rid'));
		$this->setTemplateData('sid',$oWMData->get('general','sid'));
		$this->setTemplateData('folder',$oWMData->get('general','folder'));
		$this->setTemplateData('folder_encoded',htmlspecialchars($oWMData->get('general','folder')));
	}
	public function showDefault()
	{
			$oWMData = &Singleton::instance('WMData');
			$oWMLanguage = &Singleton::instance('WMLanguage');
			$oWMRequest = &Singleton::instance('WMRequest');
			$oXML = $this->getProperty('xml');
			
			$sDataGroup = strval($oXML->config->data->group);
			$sDataItem = strval($oXML->config->data->item);
			$tableData = $oWMData->get($sDataGroup,$sDataItem);

			$headersCount = count($oXML->config->headers->header);
			$defaultSort = strval($oXML->config->defaultsort);
			
			for($iHeader = 0; $iHeader < $headersCount; $iHeader++){
				
				$iIndex = strval($oXML->config->headers->header[$iHeader]["id"]);
				$iGroup = strval($oXML->config->headers->header[$iHeader]["group"]);
				$sLabel = strval($oXML->config->headers->header[$iHeader]->label);
				$sSort = strval($oXML->config->headers->header[$iHeader]->sort);
				if(!$sSort){
					$sSort = $iIndex;
				}
				$aLabel = explode('|',$sLabel);
				$headers[$iIndex]['label'] = $oWMLanguage->get($aLabel[0],$aLabel[1]);
				$headers[$iIndex]['sort'] = $sSort;
			}
			$aSort = $_SESSION['COOKIE'][WMData::$aViewToFolderType[$oWMRequest->get('view')]]['sort'][$oWMRequest->get('folder')];
			$aHeaderID = array_keys($headers);
			$aHeaders = array();
			$f = 0;
			foreach ($headers as $id => $val) {
				$aHeaders['num'][$f]['id'] = $id;
				$aHeaders['num'][$f]['label'] = $val['label'];
				$aHeaders['num'][$f]['sort'] = $val['sort'];
				$f++;
			}
			if($aSort){
				$this->setSelectedSort($aHeaders,trim(reset(array_keys($aSort))),trim(reset(array_values($aSort))));
			}else{
				$this->setSelectedSort($aHeaders,$defaultSort);
			}

			if($tableData['num']){
				foreach($tableData['num'] as $rowNumber => $rowContent){
					$colCount = 0;
					$aTable['num'][$rowNumber] = $tableData['num'][$rowNumber];
					foreach($aHeaders['num'] as $header){
						$aTable['num'][$rowNumber][$header['id']] = $tableData['num'][$rowNumber][$header['id']];
					}
					
					$aTable['num'][$rowNumber]['address'] = $tableData['num'][$rowNumber]['heading'];
				}
				/*foreach($tableData['num'] as $rowNumber => $rowContent){
					$colCount = 0;
					foreach($aColumns as $column){
						if($bSelectable){
							$tableData['num'][$rowNumber]['selector'] = '<input type="checkbox" name="'.$sSelectVariable.'[]" value="'.$tableData['num'][$rowNumber]['id'].'" />';
						}
						//Cut column length
						if($cut){
							foreach($cut as $prop => $propVal){
								//Isset that field
								if($tableData['num'][$rowNumber][$prop]){
									//Longer ?
									if(mb_strlen(strip_tags($tableData['num'][$rowNumber][$prop]),'UTF-8')>$propVal){
										$tableData['num'][$rowNumber][$prop] = mb_substr(strip_tags($tableData['num'][$rowNumber][$prop]),0,$propVal,'UTF-8').'...';
									}else{
										$tableData['num'][$rowNumber][$prop] = strip_tags($tableData['num'][$rowNumber][$prop]);
									}
								}
							}
						}
						
						$aColumnData = array
						(
							'global'=>$this->getProperty('aTemplate'),
							'item'=>$tableData['num'][$rowNumber]
						);
						$tableDataWorkaround['num'][$rowNumber]['col']['num'][$colCount]['data'] = $aColumnData;
						$tableDataWorkaround['num'][$rowNumber]['col']['num'][$colCount]['value'] = template($aFileName[$colCount],$aColumnData);
						$tableDataWorkaround['num'][$rowNumber]['col']['num'][$colCount]['click'] = $aClickable[$colCount]?true:false;
						$tableDataWorkaround['num'][$rowNumber]['col']['num'][$colCount]['width'] = $aWidth[$colCount]?$aWidth[$colCount]:false;
						$colCount++;
					}
					$tableDataWorkaround['num'][$rowNumber]['class'] = $tableData['num'][$rowNumber]['unread']?'mail_unread':false;
				}*/
			}

			$this->setTemplateData('headers',$aHeaders);
			$this->setTemplateData('tableData',$aTable);
	}

	private function cutColumn($sColumn,$iLength)
	{
	
	}
	
	
	private function setSelectedSort(&$aHeaders,$sValue,$sDir = 'DESC'){
		foreach($aHeaders['num'] as $hID => $header){
			$aSort = explode(',',$header['sort']);
			$mandatorySort = $aSort[0];
			if($mandatorySort==$sValue){
				$aHeaders['num'][$hID]['sorted'] = true;
				if($sDir == 'ASC'){
					$aHeaders['num'][$hID]['sortedASC'] = true;
				}else{
					$aHeaders['num'][$hID]['sortedDESC'] = true;
				}
				
				return true;
			}
		}
	}

	public function getBody(&$oXML)
	{
		if($this->sTemplateFile){
			$aTemplate = $this->getProperty('aTemplate');
			$sTable = template($this->sTemplateFile,$aTemplate);
			$aTemplate['table'] = $sTable;
			$sResult = template($this->getPath('template').'table.tpl',$aTemplate);

			return $sResult;
		}else{
			return '';
		}
	}

}
?>
