<?php
/**
  @file
  @brief Script for uploading attachments.
 */

require_once('inc/system.php');
require_once('inc/post.php');
require_once('inc/user.php');

function main() {

	/* Get input variables. */
	if (($sid = Post()->sid) === null)
		exit('Invalid sid');
	if (!isset($_FILES['file']))
		exit('Invalid file');
	$folderID = Post()->folder;

	switch($_FILES['file']['error']) {
	case UPLOAD_ERR_OK:
		try {
			/* Load the user session. */
			$user = User::load($sid);
	
			if (!$folderID)
				$folderID = date('Y-m-d-') . Tools::my_uniqid();
			$itemID = Tools::my_uniqid();

if (Post()->dump){
echo $folderID."\r\n";
echo $itemID;
}
			/* Save the attachment. */
			if (!$user->addAttachment('file', $folderID, $itemID))
				exit('Cannot save the attachment');
		} catch (Exception $e) {
			exit($e->getMessage());
		}
		break;
	
	default:
		exit('File upload error: ' . $_FILES['file']['error']);
		break;
	}
	

  if (($obj = Post()->obj) !== null){
	     $name = str_replace('"','\\\\"',$_FILES['file']['name']);

		//BASE Tag
		$surl = ($_SERVER['HTTPS']=='ON'?'https':'http').'://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
		$surl = substr($surl,0,strpos($surl,"/server/")+1);

		echo '
		<html>
		<head>
			<base href="'.$surl.'">
			<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		</head>
		<body>
		<script language="javascript">
		   eval("window.parent.'.$obj.'._setFolder(\\"'.$folderID.'\\");");
		   eval("window.parent.'.$obj.'._add({id:\\"'.$itemID.'\\",path:\\"'.str_replace("\\","\\\\",quotemeta(Post()->path)).'\\",name:\\"'.$name.'\\",size:\\"'.$_FILES['file']['size'].'\\"})");
		</script>
		</body>
		</html>';
	}

}

main();

?>
