#!/bin/bash
#
# IceWarp Merak Mail Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: submitconf.sh - wizard menu script
# version: 1.0
#

# include functions
if [ -z "$SCRIPTDIR" ]
    then
	echo "This wizard script requires to have \$SCRIPTDIR variable set."
	exit 1
fi

if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ${SCRIPTDIR}/inc/functions.sh
fi

submitconf()
{
    good ""
    ask_with_confirmation "${BAD}Overwrite current configuration with system.conf values?${NORMAL}" "N" "y"
    if [ $? -eq 2 ]
	then
	    ${MERAKDIR}/tool "FILE" "BATCH" "config/system.conf" "modify system c." > /dev/null
	    if [ $? -eq 0 ]
		then
		    good "Configuration submitted"
		else
		    bad "Configuation submit problem!"
	    fi
	else
	    warn "User cancelled"
    fi
    return 0
}

submitconf
exit 0
