<?php

class Auth{


  public static function login()
  {
    $result = false;
  
    // Check auth header
    if ($_SERVER['HTTP_AUTHORIZATION'])
    {
    // Explode
    list($scheme, $text) = explode(' ', $_SERVER['HTTP_AUTHORIZATION']);
    
    // Get username and password
    $text = base64_decode($text);
    list($username, $password) = explode(':', $text);
    
    // Check account api
    require_once('../inc/api/account.php');
    $account = new MerakAccount();
    
    // Authenticate via api
    $result = $account->AuthenticateUser($username, $password, $SERVER_NAME);
    
    // User authenticated - is it really admin
    if ($result) $result = $account->GetProperty('u_admin');
    
    }
    
    
    // Send http authorization request
    if (!$result)
    {
    
    header('Status: 401 Access Denied');
    header('Authorization: Basic');
    header('WWW-Authenticate: Basic realm="Tools"');
    
    die();
    }
  }

}
?>
