<?
  include_once("variablefunctions.php");
  require_once("syntax/clsgridhandler.php");
  require_once("function.php");
  
  $accountids = array('user','domain','remote','list','listserv','catalog','remote','route','notify','exec','group');
  
  
  function checkformaction(&$error)
  {
    global $formtype, $formvalue, $formobject, $formapi;

    $result = true;

    // Saving an admin account by domain admin
    if ($result && $formtype=="edit" && $formobject=="user" && $_SESSION["ACCOUNT"] == 'DOMAINADMIN')
      if (@$formapi->GetProperty("u_admin"))
      {
        $result = false;
        global $alang;
        $error = $alang["ADMINACCOUNT"];
      }


    // Adding new account
    if ($result && $formtype=="add" && !($formobject=="domain"))
      if (!checkaccountlimit($_REQUEST['account_domain']))
      {
        $result = false;
        global $alang;
        $error = $alang["DOMAINACCOUNTEXCEED"];
      }

    return $result;
  }

  function checkformlimit($name)
  {
    $result = true;
    $name = strtolower($name);
    if (@$_SESSION["LIMIT"]) if (isset($_SESSION["LIMIT"][$name])) $result = intval($_SESSION["LIMIT"][$name]);
    return $result;
  }


  function checkoption($name, $type, $disable)
  {
    global $formtype;
    $result = true;

    // Text files not possible when adding a new object
    if ((($type == "textfile") || ($type == "bwfile") || ($type == "mailboxview")) && $formtype == "add") $result = false;

    // Option limits
    if ($result) $result = checkformlimit($name);

    if ($result) if ($disable)
    {
      // Prepare named array
      $l = explode("|", $disable);
      for ($i=0;$i<count($l);$i++) $list[$l[$i]] = true;

      // Items
      if ($list['admin']) $result = !($_SESSION["ACCOUNT"] == 'ADMIN');
      if ($list['domainadmin']) $result = !($_SESSION["ACCOUNT"] == 'DOMAINADMIN');
      if ($list['edit']) $result = !($formtype == "edit");
      if ($list['add']) $result = !($formtype == "add");
      if ($list['all'] || $list['true']) $result = false;
    }

    return $result;
  }
  /*
      Functions to convert numbers from decimal
	  to binary and the other way round
  */
  function binary2decimal($num)
  {
  	$dec = 0;
  	for ($i=0;$i<sizeof($num);$i++){
		$dec+=pow(2,$i)*$num[$i];
	}
	return $dec;
  }

  function decimal2binary($num,$length = 7)
  {
  	$i = 0;
  	while ($num!=0){
		$binary[$i++] = $num%2;
		if (($num - $num%2)!=0) $num = ($num - $num%2)/2;
		else					$num = 0;
	}
	while (sizeof(@$binary)!=$length)
		$binary[$i++] = 0;
	return $binary;
  }

  /*
  		*.dat files parser
   */
  function parsedatfile($file,$type)
  {
    global $rawdata,$rawindex,$formvalue,$formapi; // This global variable is used to store unusable data
                   // in order to write them back to file (comments etc.)
    
  $ipath = '';  
		if(strpos($file,'config/')===0){
			$filename = str_replace('config/',$_SESSION['CONFIGPATH'],$file);
		}else{
    	$filename = $file;
			$api = createobject("api");
			if (!$_SESSION["INSTALLPATH"]) $ipath = $api->getProperty("c_installpath");
	    else  $ipath =$_SESSION["INSTALLPATH"];
	    
	    if ($type=='spam' || $type=='spam2')
	      $ipath = $_SESSION['SPAMPATH'];
	      
	    if ($type=='calendar' || $type=='syncml' || $type=='caldav')
	      $ipath = $_SESSION['CALENDARPATH']; 
	    
			if ($type=='proxy' || $type=='smsusers')
	      $ipath = $_SESSION['CONFIGPATH'];
	      
		}
		
				
		if (strtolower($type)=="domainkey")	 $filename = "config/".$formvalue."/domainkey.dat";
	 	$path = $ipath.$filename;

		 //ICEWARP MISSING DEFAULT FILE HACK(spam.dat auto creation)
		if($type == 'spam2' && !file_exists($path)){
			if(get_class($formapi)!=='MerakAPI'
			|| get_class($formapi)!=='IcewarpAPI'){
				$hack_api = new MerakAPI();
				
			}else{
				$hack_api = &$formapi;
			}
			$hack_var = $formapi->GetProperty('C_AS_Challenge_ConnectionString');
			$hack_api->SetProperty('C_AS_Challenge_ConnectionString',$hack_var);
		}
		
		$lines = @file($path);

    if ($lines)
		switch (strtolower($type)){
		  case 'domainkey':
			case 'path':
				foreach($lines as $k=>$v)
					$ret[$k+1]=$v;
			break;
			case 'tags':
				$Header = explode(";",$lines[0]);
				$Footer = explode(";",$lines[1]);
				$Bits = $lines[4];

				$ret["TextHeader"] = $Header[0];
				$ret["HTMLHeader"]= $Header[1];
				$ret["TextFooter"] = $Footer[0];
				$ret["HTMLFooter"] = $Footer[1];

				$Bits = decimal2binary($Bits);

				$ret["L2L"] = $Bits[0];
				$ret["R2L"] = $Bits[2];
				$ret["L2R"] = $Bits[1];
				$ret["R2R"] = $Bits[3];
			break;
			case 'accdefaults':
			  foreach($lines as $v){
						$tmp = explode('=',$v);
						$ret[$tmp[0]]=$tmp[1];
					}
			break;
			case 'defaultrights':

				$rights = explode("=",$lines[0]);
				$rights = $rights[1];
				$ret["U"] = substr_count($rights,"U")>0?1:0;
				$ret["M"] = substr_count($rights,"M")>0?1:0;
				$ret["L"] = substr_count($rights,"L")>0?1:0;
				$ret["R"] = substr_count($rights,"R")>0?1:0;
				$ret["S"] = substr_count($rights,"S")>0?1:0;
				$ret["C"] = substr_count($rights,"C")>0?1:0;
				$ret["N"] = substr_count($rights,"N")>0?1:0;
				$ret["E"] = substr_count($rights,"E")>0?1:0;
				$ret["V"] = substr_count($rights,"V")>0?1:0;
				$ret["G"] = substr_count($rights,"G")>0?1:0;
				$ret["Q"] = substr_count($rights,"Q")>0?1:0;
				
        for($i=1;$i<count($lines);$i++)
          $rawdata[$i]=$lines[$i];
			break;
			case 'spam':
	
			     $varnames = array(0=>'use_bayes',
                             1=>'use_spf',
                             2=>'use_surbl',
                             3=>'use_domainkeys',
                             4=>'report_safe',
                             5=>'use_rbl',
                             6=>'spf_level',
                             7=>'use_razor2',
                             8=>'required_hits',
                             9=>'bayes_auto_learn',
                             10=>'bayes_auto_learn_threshold_spam',
                             11=>'bayes_auto_learn_threshold_nonspam');
			     unset($rawindex);
			     unset($rawdata);
           foreach ($lines as $lindex => $line){
			      $useable = false;
            //If line is not useable (blank,commented), store it

                $larr = explode(" ",$line);
                if  (in_array($larr[0],$varnames)){
                  $ret[$larr[0]] = $larr[1];
                  $rawdata[$lindex] = $line;
                  $rawindex[$lindex] = $larr[0];
                  $useable = true;
                }

              
                $rawdata[$lindex] = $line;
              }    
              //Some variables missing
             /* if (count($rawindex)<count($varnames))
                foreach($varnames as $variable){
                  //TODO: = 0 replace with default value
                  if (!in_array($variable,$rawindex)){ 
                    $ret[$variable] = 0;
                    $rawindex[count($rawdata)] = $variable;
                    $rawdata[count($rawdata)] = 0;
                  }
                }*/

                $_SESSION['rawdata'] = $rawdata;
                $_SESSION['rawindex'] = $rawindex;
  		break;
  		case 'domainad':
  		  @$xml = simplexml_load_file($path);
        if($xml->DOMAIN)
  		  foreach($xml->DOMAIN as $domain){
          if($formapi->Name && (strval($domain->DOMAIN)==$formapi->Name)){
            foreach($domain->children() as $key => $val)
              $ret[$key] = strval($val);
          }
        }

      break;
      case 'syncml':
      case 'caldav':
        @$xml = simplexml_load_file($path);

        if($xml->children())
   		  foreach($xml->children() as $var => $value){
           $ret[$var] = strval($value); 
        }

      break;
      case 'webmail':
        @$xml = simplexml_load_file($path);
        
        if($xml->item->children())
     		 foreach($xml->item->children() as $var => $value)
           $ret[$var] = trim(strval($value)); 
				if(!$ret['logging_type']){
					$ret['logging_type'] = 0;
				}
      break;
      case 'smsusers':
      	$ret['users'] = implode('',$lines);
      break;
      case 'spam2':
			case 'default':
			default:
			 
				 foreach($lines as $v){
						$tmp = explode('=',$v);
						$ret[$tmp[0]]=$tmp[1];
					}
			break;
		}

		unset($api);
		return $ret;
  }
  /*
     Sets value for current variable - when using *.dat files
  */
  function setdatvalue($variable,$value,$datfile,$dattype)
  {
    
	  if (@!$_SESSION['datdata'][$datfile]){
		 $_SESSION['datdata'][$datfile]["data"] = parsedatfile($datfile,$dattype);
	   $_SESSION['datdata'][$datfile]["type"] = $dattype;
		}

		$_SESSION['datdata'][$datfile]["data"][$variable] = $value;
	return true;
  }
  /*
  	saves datfile data to datfile
	*/
  function savedatfiles()
  {
    
    global $rawdata,$rawindex,$formvalue;
    	
		if ($_SESSION['datdata'])
		foreach ($_SESSION['datdata'] as $key => $val){
		  if ($key=="domainkey.dat"){
		    $filename = $_SESSION["CONFIGPATH"].$formvalue."/".$key;
		  } else {
		  		if(strpos($key,'config/')!==false){
						$filename = str_replace('config/',$_SESSION['CONFIGPATH'],$key);
					}else{
          	$filename = $_SESSION["INSTALLPATH"].$key;
      		}
			}
      
      if ($val['type']=='spam' || $val['type']=='spam2')
        $filename = $_SESSION['SPAMPATH'].$key;

      if ($val['type']=='syncml' || $val['type']=='calendar' || $val['type']=='caldav')
        $filename = $_SESSION['CALENDARPATH'].$key;
      
      if ($val['type']=='proxy' || $val['type']=='smsusers')
      	$filename = $_SESSION['CONFIGPATH'].$key;
			$ret ='';

			switch (strtolower($val["type"])){
			 	case 'domainkey':
				case "path":
				 if($val["data"])
					foreach($val["data"] as $v)
						$ret.=trim($v).CRLF;
				break;
				case "tags":
					$v = $val["data"];
					$ret.=$v["TextHeader"].';'.$v["HTMLHeader"].CRLF;
					$ret.=$v["TextFooter"].';'.$v["HTMLFooter"].CRLF.CRLF.CRLF;
					$Bits = $v["L2L"]*1 + $v["R2L"]*4 + $v["L2R"]*2 + $v["R2R"]*8;
					$ret.=$Bits;
				break;
				case "accdefaults":
				  if($val["data"])
				  foreach($val["data"] as $k => $v)
						if (@$_REQUEST["use_settings_".$k]) $ret.=$k.'='.trim($v).CRLF;
        break;
				case "defaultrights":
					$ret.='RIGHTS=';
					if($val["data"])
					foreach ($val["data"] as $k => $v)
						if ($v) $ret.=$k;
					$ret.=CRLF;
					if ($rawdata)
					foreach($rawdata as $line)
  			    $ret.=trim($line).CRLF;
				break;
				case "spam": 
				//Replace lines with new values from editform

				if ($rawdata)
  		  foreach ($rawdata as $lindex => $line){
  		      $return = '';
            if (isset($rawindex[$lindex])){
              if ($val["data"][strtolower($rawindex[$lindex])]) $value = $val["data"][strtolower($rawindex[$lindex])];
              else $value = 0;

              $return = $rawindex[$lindex]." ".((!$value)?0:$value);
             } else
              $return = $rawdata[$lindex];
              $ret.=trim($return).CRLF;
        }
        

        else{
    		  foreach ($val["data"]as $lindex => $line){
           // if ($index=='bayes_auto_learn' && !$line)
          //    $line = 0;      
            if ($lindex) $ret.=$lindex.' '.$line.CRLF;          
          }
        } 
				break;
				case "logopath":
				  if($val["data"]){
    				 // if (!$logopath = securepath($v)) return false;
    					foreach($val["data"] as $k => $v)
    						$ret.=$k.'='.trim(securepath($v)).CRLF;
          }
        break;
        case 'spam2':

        if($val["data"])
					foreach($val["data"] as $k => $v){
 						if (!$v) $val = 0;
						else $val = $v;
						if(($k!='BlockKeywords' || $k!='BypassKeywords') && !$v) $val = '';
            $ret.=$k.'='.trim($val).CRLF;
					}

			break;
			case 'domainad':
        foreach($val["data"] as $var => $val){
          if($var=='ACTIVE' || $var=='HOSTDOMAINACTIVE')
            $domain[$var][0]["VALUE"] = $val?1:0; 
          else /*if($var!='DOMAIN')*/
            $domain[$var][0]["VALUE"] = $val; 
        }
        
			  $xmlparse = new ParseXML;
			 
  			if(file_exists($filename)){
          $xml = $xmlparse->GetXMLTree($filename);
  
          $updated = false;
          
          foreach($xml["DOMAINS"][0]["DOMAIN"] as $kd => $dom){
            if($_REQUEST['domain_name'] && $dom["DOMAIN"][0]["VALUE"]==$_REQUEST['domain_name']){
              $xml["DOMAINS"][0]["DOMAIN"][$kd] = $domain;
              $updated = true;
            }  
          } 
          
          if(!$updated){   
            $domain["DOMAIN"][0]["VALUE"] = $_REQUEST['domain_name'];  
            $xml["DOMAINS"][0]["DOMAIN"][] = $domain;
            
          }
                  
        }else{
            $domain["DOMAIN"][0]["VALUE"] = $_REQUEST['domain_name'];
            
            
            if($domain)
              $xml["DOMAINS"][0]["DOMAIN"][] = $domain;
  
        }
  
        if($xml){
          $ret = $xmlparse->Array2XML($xml);
        } 
      break;
      case 'syncml':
      case 'caldav':
        if (file_exists($filename))
          @$xml = simplexml_load_file($filename);
        else
          @$xml = simplexml_load_string('<Config></Config>');
        
   		  foreach($val["data"] as $var => $val)
   		   if (strtolower($var)!='config') $xml->$var = trim(strval($val));
        
        
        
        if ($xml)
          $ret = $xml->asXML();

        //file_put_contents($filename,$ret);
      break;
      case 'webmail':
        if (file_exists($filename))
          @$xml = simplexml_load_file($filename);
        else
          @$xml = simplexml_load_string('<global_settings><item></item></global_settings>');
        

     		foreach($val["data"] as $var => $val){
     				switch($var){
							case 'disabled':
							case 'logging_type':
							case 'logs':
								$xml->item->$var = intval($val);
							break;
							default:
								$xml->item->$var = trim(strval($val));
							break; 
						}
     		  	
     		}

        if ($xml)
          $ret = $xml->asXML();
          
        //file_put_contents($filename,$ret);
      break;
      case 'smsusers':
				$ret = $val["data"]["users"];
			break;
			case "default":
				default:
				if($val["data"])
					foreach($val["data"] as $k => $v)
						$ret.=$k.'='.trim($v).CRLF;
			break;
			}
			if($filename){
			if (strlen(trim($ret))==0) 
      { 
  //      @fclose($fp2);
        @unlink($filename);

      } else{
	      $fp2 = @fopen($filename,'w+');
			  $bytes = @fwrite($fp2,$ret,strlen($ret));
			  @fclose($fp2);
		  }
		  }
      unset($_SESSION["datdata"]);
		//	if ($bytes==0) return false;
	}
	 return true;
  }

  function getformvalue($name,$function, $variable, $datfile, $source, $dattype,$inverse,$request,$option)
  {
    global $formapi, $formtype, $defaultvalue, $gObj;
    $value = false;

  	if ($datfile && $source!='API') {
			if (@!$_SESSION['datdata'][$datfile]){
        $_SESSION['datdata'][$datfile]["data"] = parsedatfile($datfile,$dattype);
				$_SESSION['datdata'][$datfile]["type"] = $dattype;
			}
			@$value = $_SESSION['datdata'][$datfile]["data"][$variable];
			
    }

    if ($variable && ($variable!="s_weekdays") && (!$datfile||$source=="API") && (!$gObj->Multigrid)) $value = $formapi->GetProperty($variable);

    if ($function) {
      formfunctionvalues($function, $value, true,$name,$message,$option);
    }

		if ($gObj->Multigrid && !$value)	$value = $gObj->getGridItemData($variable);
		if ($inverse) {
		  if (!$value || $value==0) $value = 1; else $value = 0;
		}

		if ($formtype == 'add' && isset($defaultvalue)){ 
      
      //if($value===''){
      if($option['ATTRIBUTES']['TYPE']=='checkbox'
        || $option['ATTRIBUTES']['TYPE']=='slider')
        $value = $defaultvalue;
        
      if($option['ATTRIBUTES']['TYPE']=='edit')
          $value = $defaultvalue;

      //}
		}
		//Remove phone number from aliases
		$pos = false;
		
		
    if ($variable=="u_alias")
    { 
      $aAliases = explode(";",$value);
      $value = '';
      $val = $formapi->GetProperty("u_phonealias");
      if ($aAliases[0]) 
          foreach($aAliases as $alias){
              if ($alias && $alias!=$val) $value.=((($i++)!=0)?';':'').$alias;
          }
    }

    if($variable=='d_description' || $variable=='u_name' || $variable=='g_description')
      $value = slashes_input($value);

	  return $value;
  }

  function setformvalue($item, $value, $use, $datfile, $dattype,&$message,&$error = false)
  {
  global $formapi, $formtype,$formobject,$formvalue, $gObj,$alang;

  //Initialiazation
  @$function = $item["FUNCTION"];
  @$name = $item["NAME"];
  @$variable = $item["VARIABLE"];
  @$type = $item["TYPE"];
  @$inverse = $item["INVERSE"];
  @$source = $item["SOURCE"];
  @$property = $item["PROPERTY"]; 
  $result = true;
  $option["ATTRIBUTES"] = $item;

	//Checkbox and between(schedule)
  if ($type=="checkbox" || $type=="between") if ($value) $value = true;
  if ($type=="account_select") return true;

  //File upload

  if ($type=="upload" && $_FILES[$name]['tmp_name']) {  

     if ($_REQUEST['restore_password'])
	     $param = array($_FILES[$name]['tmp_name'],$_REQUEST['restore_password']);
     else 
	     $param = array($_FILES[$name]['tmp_name']);

	  switch(strtolower($item["FILEID"])){
      case 'restoregwconfig':
        $filename = $param[0];

        $gwapi = new MerakGWAPI();
        $gwapi->user = $formapi->GetProperty("C_GW_SuperUser");
        $gwapi->pass = $formapi->GetProperty("C_GW_SuperPass");
        $gwapi->Login();
      
        $result = $gwapi->FunctionCall("ImportData",$gwapi->sessid,file_get_contents($filename));
        $rmsg = ($result?$alang["TStrings_crestoreok"]:$alang["TStrings_crestoreerror"]);
      break;
      case 'migration_migratemessagesaccounts':
        $filename = $param[0];

        $user = $_REQUEST['TMigrateForm_UL'];
        $pass = $_REQUEST['TMigrateForm_PL'];
        $domain = $_REQUEST['TMigrateForm_DL'];

        $result = $formapi->Migration_MigrateMessages(0,$user,$pass,$domain,file_get_contents($filename));
        $rmsg = ($result?$alang["TStrings_cmigrationsent"]:$alang["TStrings_cmigrationerror"]);

      break;
      default:

        $result = call_user_method_array($item["FILEID"],$formapi,$param);
        $rmsg = ($result?$alang["TStrings_crestoreok"]:$alang["TStrings_crestoreerror"]);

      break;
    }
	
    $message.= '<div id="infomessage">'.$rmsg.'</div>';
  }

  //Inverse checkbox
	if ($inverse==1){
   if (!$value) $value = 1; else $value = 0;
  }
  
	//For days of week
	if ($type=="daysofweek") {
		for($i = 0; $i<7; $i++)
      if ($_REQUEST[$name.$i]!="on") $binary[$i] = 1;
			else						   $binary[$i] = 0;
		  $value = binary2decimal($binary);
	}
	
	//Datagrid items
	if ($gObj->Multigrid && !$function) {
		$result = $gObj->setGridItemData($variable,$value);
	}
	
	//Normal variablea
	else
	{
		if ($variable){
		  $save = true;
		  //Property box - whether to use default value
	    if ($property) if (!$use) $save = false; 
			if ($datfile && $source!='API') { $result = setdatvalue($variable,$value,$datfile,$dattype,$save);
			}else   if ($save) {
			  //Check for alias existence
        if ($variable=="u_alias") {
            $oldvalue = $value;
            $aliases = explode(";",$value);
            if (!$aliases[0] || !$value) return false;
            else $value = $aliases[0];
            if ($_REQUEST['account_domain']) $_COOKIE['domainv'] = $_REQUEST['account_domain'];
            //Set list files for Mailig list, List server and Group
            if ($formobject=="group" || $formobject=="list" || $formobject=="listserver" ){

               if ($formobject=="list" && $formapi->GetProperty("m_listfile")=="")
                    $result = $formapi->SetProperty("m_listfile", $_REQUEST['account_domain'].'/'.$value.'.txt');
               if ($formobject=="listserver" && $formapi->GetProperty("l_listfile")=="")
                    $result = $formapi->SetProperty("m_listfile", $_REQUEST['account_domain'].'/'.$value.'.txt');              
               
               if ($formobject=="group" && $formapi->GetProperty("g_listfile")=="") 
                    $result = $result && $formapi->SetProperty("g_listfile", $_REQUEST['account_domain'].'/'.$value.'.txt');
                    
            }
            $value = $oldvalue;
        }
        if ($value=="" && osversion=="LINUX" && ($variable=='u_respondbetweenfrom' || $variable=='u_respondbetweento'))
          $variable = time();
        $result = $formapi->setProperty($variable, $value);

        }
        
			if (!$result && $value=='') $result = true;
		}else
		if ($function) $result = formfunctionvalues($function, $value, false,$name, $message, $item, $error);
    }

    // Problem setting
    if (!$result) {

      if(!$function && !$error){
        if($item["ERROR"]) $error = $alang[$item["ERROR"]];
        else $error = $alang['TStrings_weberror'].':'.$item['NAME'];
      }
      return false;
    }    
    return $result;
  }

  function getobjecttitle($object, $label = false, $value = false)
  {
    global $alang;

    $result = "";
    switch ($object)
    {
      case "domain": $result = $alang["TFrameAccounts_DomainSheet"];
        break;
      case "user": $result = $alang["TDomainAdminForm_User"];
        break;
      case "group": $result = $alang["TDomainAdminForm_Group"];
        break;
      case "exec": $result = $alang["TDomainAdminForm_Exec"];
        break;
      case "notify": $result = $alang["TDomainAdminForm_Notify"];
        break;
      case "list": $result = $alang["TDomainAdminForm_List"];
        break;
      case "listserv": $result = $alang["TDomainAdminForm_ListServ"];
        break;
      case "route": $result = $alang["TDomainAdminForm_Static"];
        break;
      case "catalog": $result = $alang["TDomainAdminForm_Catalog"];
        break;
      case "remote": $result = $alang["TDomainAdminForm_Remote"];
        break;
      default:	$result = $object;
        break;
    }
    $result .= ($label?" " . $label:" " . $value);
    return $result;
  }

  function prepareglobalvariables($type, $object, $value, $submit = false)
  {
    global $api,$formtype, $formobject, $formvalue, $formapi, $skindata,$remote,$editform, $alang;

    //If we are adding a new group member from membersgrid
    if ($value=='group_member')
    {
          //Get arguments (groupname@domain)
          $args = explode('@',$_REQUEST['args']);
          $domain = $args[1];
          $name = $args[0];
          
          //Get path and create it
          $path = $_SESSION['CONFIGPATH'].$domain;
          mkdirtree($path);
          
          $path.='\/'.$name.".txt";
          
          $fp = @fopen($path,'r+');
          @fclose($fp);
          
          
    }
    
    $formtype = $type;
    if (!$formtype) $formtype = '#FORM_TYPE_DEFAULT#';
    $formobject = $object;
    $formvalue = $value;

    if (!$api) $api = createobject("api");
    // Domain admin
    if ($_SESSION["ACCOUNT"] == 'DOMAINADMIN' && $value) if (!checkdomainaccess($value)){
                                                    popuperror($alang["ACCESS_ERROR"]);
                                                    return;
                                               }
  	checkaccountright($object, true);

  	//Do some actions depending on object
    switch ($object)
    {
      case "domain":
        
        $formapi = createobject("domain");
        if ($type == "add") {
          if(!$_REQUEST['editform']) unset($_SESSION['datdata']);
          $val = getstrvalue($api->UTF8ToIDN($_REQUEST["domain_name"]));
          if (!USEAPIEXT) $formapi->New($val); else $formapi->New_($val);
          $formapi->ApplyTemplate();
        }

	     if ($type == "edit") $formapi->Open($api->UTF8ToIDN($value));
      break;
      /*case "group":
      case "list":
        $formapi = createobject("account"); 
        if ($type == "add")
        {

          if (!$_REQUEST["account_domain"]) $rdomain = $value;
          else $rdomain = $_REQUEST["account_domain"];

          $raccount = $_REQUEST["account_name"];
          if (!isset($_REQUEST["account_name"])) $raccount = $_REQUEST["group_name"];
          if (!$raccount) $raccount = "";
                 
          $val = $raccount . "@" . $rdomain;
            // For mailing list and group
            $formapi->Open($val);
                
            if (!($formapi===false)) {
                $formapi->SetProperty("u_type", getobjectaccounttype($object));
                $formapi->ApplyTemplate();
                break;
            }          
          if (in_array($val,$_SESSION['TMP_ACCOUNTS'])){ 
            $formapi->Open($val);
          }
          else {
            if (!USEAPIEXT) $formapi->New($val); else $formapi->New_($val);
      
            $_SESSION['TMP_ACCOUNTS'][$val] = $val;
          }
          // Set account type
          $formapi->SetProperty("u_type", getobjectaccounttype($object));
          $formapi->ApplyTemplate();        
        }
        if ($type == "edit")  $formapi->Open($value);
      break;*/
      case "odbc_mlist": 
      	$formapi = createobject("account"); 
      	$formapi->Open($_REQUEST['cfileid']);
			break;
      case "group":
      case "list":
      case "listserv":
      case "route":
      case "user":
      case "exec":
      case "notify":
      case "catalog":
        $formapi = createobject("account"); 
        if ($type == "add")
        {

          if (!$_REQUEST["account_domain"]) $rdomain = $value;
          else $rdomain = $_REQUEST["account_domain"];

          $raccount = $_REQUEST["account_name"];
          if (!isset($_REQUEST["account_name"])) $raccount = $_REQUEST["group_name"];
          if (!$raccount) $raccount = "";
                 
          $val = $raccount . "@" . $rdomain;

          if (!USEAPIEXT) $formapi->New($val); else $formapi->New_($val);
          
          // Set account type
          $formapi->SetProperty("u_type", getobjectaccounttype($object));     
	        $formapi->ApplyTemplate();
        }
        if ($type == "edit")  $formapi->Open($value);
        
		break;
      case "remote":
          
          $formapi = createobject("remoteaccount"); 
          if ($submit) if ($type == "add") {
          if (!USEAPIEXT) $formapi->New(); else $formapi->New_();
          if (!$_REQUEST["remote_domain"]) $_REQUEST["remote_domain"] = $value;
          $formapi->SetProperty("RA_DomainString", $_REQUEST["remote_domain"]);
          $formapi->SetProperty("RA_LeaveMessageFile", $_REQUEST["remote_name"] . "/remote." . $_REQUEST["remote_domain"] . "." . rand(0, 0xFFFF) . ".dat");
          $schedule = $formapi->GetSchedule('ra_schedule');
          $schedule->Count = 1;
          $schedule->SetProperty("s_weekdays_su", true);
          $schedule->SetProperty("s_weekdays_mo", true);
          $schedule->SetProperty("s_weekdays_tu", true);
          $schedule->SetProperty("s_weekdays_we", true);
          $schedule->SetProperty("s_weekdays_th", true);
          $schedule->SetProperty("s_weekdays_fr", true);
          $schedule->SetProperty("s_weekdays_sa", true);
          $schedule->SetProperty("s_scheduletype", 0);
          $schedule->SetProperty("s_every", 1200);
          $schedule->SetProperty("s_wholeday", true);
          $formapi->SetSchedule("ra_schedule", $schedule);
          $formapi->ApplyTemplate();
        } else {
            $value = intval($value);
        }
	   if ($type == "edit"){
			$formapi->Open(intval($_REQUEST['value']));
    }
	   break;
	   case "schedule":
	      if ($api) $formapi = $api;
        else $formapi = createobject("api"); 
        
	    if ($_REQUEST['cfileid']=="ra_schedule"){
        $remote = createobject("remoteaccount"); 
        $remote->Open($_REQUEST['fileid']);
      }
	   break;
	   case "accessmode2":
	   case "accessmode":
			if ($api) $formapi = $api;
      else $formapi = createobject("api"); 	  
      global $access_mode_prefix;
      $access_mode_prefix = $_REQUEST['cfileid'];
     break;
     case 'headerfiles':
   //  case 'message':
			$formapi = createobject("account");
      $formapi->Open($_REQUEST['fileid']);
	   break;
     default:

			if ($api) $formapi = $api;
      else $formapi = createobject("api"); 
	   break;
     }

     global $accountids;

/*if (in_array($object,$accountids)){
	     $formapi->ApplyTemplate();
	     }*/
  }

  function intsetbit($int, $bitmask, $set)
  {
    $val = intval($int) & !$bitmask;
    if ($set) $val = $val | $bitmask;
    return $val;
  }

  define('date19800101', 29221);
  define('dayunit', 60*60*24);

  function convertdelphidatetotime($time)
  {
    $fdate = mktime(0,0,0,1,1,1980);
    $ftime = $time - date19800101;
    return $fdate + (dayunit * $ftime);
  }

  function converttimetodelphi($time)
  {
    $fdate = ($time - mktime(0,0,0,1,1,1980)) / dayunit;
    return date19800101 + $fdate;
  }

   function addnull($num)
   {
   	return ($num>=10)?($num):('0'.$num);
   }

   function timetostr($sec)
  {
	 $s =  $sec%60;
	 $m =  (($sec-$s)/60)<60?($sec-$s)/60:(($sec-$s)/60)%60;
	 $h =  (($sec-$s-$m*60)/3600)<24?($sec-$s-$m*60)/3600:(($sec-$s-$m*60)/3600)%24;
	 $d =  (($sec-$s-$m*60-$h*3600)/dayunit)<30?($sec-$s-$m*60-$h*3600)/dayunit:(($sec-$s-$m*60-$h*3600)/dayunit)%dayunit;
	 $ret = addnull($d).':'.addnull($h).':'.addnull($m).':'.addnull($s);
  	 return $ret;
  }

  function strtodate($str)
  {
    if (!$str) return 0;
    ereg("([0-9]{4}/([0-9]{1,2})/([0-9]{1,2}))", $str, $regs);
    $year = $regs[1];
    $month = $regs[2];
    $day = $regs[3];
    $time = mktime(0,0,0,$month,$day,$year);
    return intval(round(converttimetodelphi($time)));
  }

  function datetostr($date,$format = "Y/m/d")
  {
    if ($date<=0) return "";
    $time = convertdelphidatetotime($date);
    $value = date($format, $time);
    return $value;
  }

  define('mhsOff', 0);
  define('mhsOn', 1);
  define('mhsBoth', 2);

  define('mhvFrom', 0);
  define('mhvReplyTo', 1);

  function getmaillistheaders($user, &$fromaction, &$fromvalue, &$toaction, &$tovalue)
  {
    $fromaction = 0;
    $toaction = 0;
    $fromvalue = "";
    $tovalue = "";

    $setvalue = $user->GetProperty("m_setvalue");
    $valuemode = $user->GetProperty("m_valuemode");
    $setsender = $user->GetProperty("m_setsender");
    $headervalue = $user->GetProperty("m_headervalue");

    switch ($setvalue) {
      case mhsOn:
        if ($valuemode == mhvFrom) {
          $fromvalue = $headervalue;
          $fromaction = 2;
        } else {
          $tovalue = $headervalue;
          $toaction = 2;
        }
        break;

      case mhsBoth:
        $fromaction = 2;
        $toaction = 2;

        $fromvalue = substr($headervalue, 0, strpos($headervalue, "|"));
        $tovalue = substr($headervalue, strpos($headervalue, "|")+1, strlen($headervalue));
        break;
    }

    switch ($setsender) {
      case mhsOn:
        if ($valuemode == mhvFrom) $toaction = 1; else $fromaction = 1;
        break;

      case mhsBoth:
        $fromaction = 1;
        $toaction = 1;
        break;
    }
  }

  function setmaillistheaders($user, $fromaction, $fromvalue, $toaction, $tovalue)
  {
    $setvalue = msOff;
    $setsender = mhsOff;
    $valuemode = mhvFrom;
    $headervalue = "";

    switch ($fromaction) {
      case 0:
        break;
      case 1:
        $setsender = mhsOn;
        $valuemode = mhvReplyTo;
        break;
      case 2:
        $setvalue = mhsOn;
        $headervalue = $fromvalue;
        break;
    }
    switch ($toaction) {
      case 0:
        break;
      case 1:
        if ($setsender == mhsOn) $setsender = mhsBoth; else $setsender = mhsOn;
        break;
      case 2:
        if ($setvalue == mhsOn) {
          $setvalue = mhsBoth;
          $fs = $headervalue . "|";
        } else {
          $setvalue = mhsOn;
          $fs = "";
        }
        $valuemode = mhvReplyTo;
        $headervalue = $fs . $tovalue;
        break;
    }
    $user->SetProperty("m_setvalue", $setvalue);
    $user->SetProperty("m_valuemode", $valuemode);
    $user->SetProperty("m_setsender", $setsender);
    $user->SetProperty("m_headervalue", $headervalue);
  }
?>
