// clone objects and arrays
function clone (obj, deep){
  var objectClone = new obj.constructor();
  for (var property in obj)
    if (!deep)
      objectClone[property] = obj[property];
    else if (typeof this[property] == 'object'){
      objectClone[property] = clone(obj[property],deep);
    }
    else
      objectClone[property] = obj[property];
  return objectClone;

};
//  MSIE EventCapture emulation for mozilla
function emulateEventHandlers(eventNames) {
   for (var i = 0; i < eventNames.length; i++) {
      document.addEventListener(eventNames[i], function (e) {
         window.event = e;
      }, true);
   }
}
typeof(window.event)=="object" ? "" : emulateEventHandlers(["mousemove","mousedown","mouseover"]);
// END

// actiontype & actionfolder SELECT from main page
function setvar(var1){

 fread.document.main[var1.name].value = var1.value;
 if (var1.name=="actiontype"){
    document.maintool1.xOK_x.disabled = (var1.value==""?1:0);
//    document.maintool1.actionfolder.disabled = (var1.value=="Proceed_x" || var1.value=="Copy_x"?0:1);
 }

}
// END

function appendscript(scripts)
{
   if(typeof scripts!= "object") return;
   var head = document.getElementsByTagName("head")[0];

   if(typeof head=="object") {
     for (var HAi = 0; HAi < scripts.length; ++HAi) {
          var script = document.createElement("script");
          script.src = scripts[HAi];
          head.appendChild(script);
     }
   }

   return true;
}

// Sets size for JS window
 function winsize(x,y)
 {
        if (self.innerWidth)
        {
                frameWidth = self.innerWidth;
                frameHeight = self.innerHeight;
        }
        else if (document.documentElement && document.documentElement.clientWidth)
        {
                frameWidth = document.documentElement.clientWidth;
                frameHeight = document.documentElement.clientHeight;
        }
        else if (document.body)
        {
                frameWidth = document.body.clientWidth;
                frameHeight = document.body.clientHeight;
        }
        else return;

        tmp1 = parent.outerWidth - parent.innerWidth;
        tmp2 = parent.outerHeight - parent.innerHeight;
        if(tmp1 && tmp2){ x -= tmp1; y += tmp2/2;}
        parent.window.resizeTo(x,y);
        parent.window.moveTo(self.screen.width/4,self.screen.height/4);
 }

//+++++++++++ CATEGORY ++++++++++
 function add2categorylist(elm)
 {
    var MyArray = new Array();
    var elms=document.category.cstring;

    MyArray=  elms.value.split(/[;,]/);

    var i,isin=-1;
    for (i=0; i < MyArray.length; i++)
    {
      MyArray[i] = MyArray[i].replace(/(([ ]+)$)|(^([ ]+))/,"");
      if (MyArray[i] === elm.value) isin=i;
    }

    if(elm.checked && isin==-1)
    {
      MyArray.push(elm.value);
      isin=-2;
    }
    else if(!elm.checked && isin!=-1)
    {
      MyArray.splice(isin,1);
      isin=-2;
    }
    if(isin==-2)  elms.value= MyArray.join(";").replace(/(^;)|(;$)/,"");
 }

 function formvalue(val,elmpath)
 {
   if(typeof(opener)!="object") return;
   var obj = eval("opener.document."+elmpath);

   if(typeof(obj)!="object") return;

   if(val)
   {
      obj.value=document.category.cstring.value;
      window.close();
   }
   else
   {
      document.category.cstring.value=obj.value;

      // check selected
      var elmArr = new Array();
      for (var i=0;i<document.category.elements.length;i++)
      {
        var e=document.category.elements[i];
        if (e.type=="checkbox"){elmArr[e.value]=i;}
      }

      var MyArray = new Array();
      MyArray=  obj.value.split(/[;,]/);

      for (i=0; i < MyArray.length; i++)
      {
        MyArray[i] = MyArray[i].replace(/(([ ]+)$)|(^([ ]+))/,"");

        if (MyArray[i] && elmArr[MyArray[i]]!="")
        {
           var iselm = document.category.elements[elmArr[MyArray[i]]];
           if(iselm) iselm.checked=1;
        }
      }
   }
 }

//+++++++++++ FOLDER TREE ++++++++++

///////////////////////////////////
//opens and closes WHOLE foldertree
///////////////////////////////////
treeisfull=0; //important for IE sync bug fix
function showall(elm,x,y)
{
  if(!elm) return
  var elm = document.getElementById(elm);
  if(!elm) return;

  for (var i=0;i<elm.getElementsByTagName("ul").length;i++)
  {
     var e=elm.getElementsByTagName("ul")[i];

     if(e)
     {
       if(e.getElementsByTagName("li").length)
       {
         e.className = x;
         if(e.parentNode) e.parentNode.getElementsByTagName("span")[0].className= y;
       }
     }
  }
  treeisfull=1;
}

//////////////////////////////////////
//opens and closes levels in foldertree
//////////////////////////////////////
function show(n)
{
  var pelm = n.parentNode;
  if(!pelm) return;

  if(pelm.getElementsByTagName("ul").length)
  {
    var ulko = pelm.getElementsByTagName("ul")[0];
    if(ulko.className == "show_ul")
    {
      ulko.className = "hide_ul";
      pelm.getElementsByTagName("span")[0].className = "spanplus";
      showall(pelm.id,"hide_ul","spanplus");
    }
    else
    {
      ulko.className = "show_ul";
      pelm.getElementsByTagName("span")[0].className = "img";
    }
  }
}

////////////////////////////////////
//opens path to folder in foldertree
////////////////////////////////////
function folder_location(elm)
{
   //prevention
   if(!elm) return;
   var masterelm = document.getElementById(elm);
   if(!masterelm) return;

   if(masterelm.getElementsByTagName("a").length) masterelm.getElementsByTagName("a")[0].className="folderlinkactive";

   //opens 1. child level
   if(masterelm.getElementsByTagName("UL").length)
   {
     masterelm.getElementsByTagName("UL")[0].className="show_ul";
     masterelm.getElementsByTagName("span")[0].className="img";
   }

   //open parents levels
   if(masterelm.getElementsByTagName("img")!=null)
      masterelm.getElementsByTagName("img")[0].src = masterelm.getElementsByTagName("img")[0].src.replace(".gif","2.gif");

   var n = masterelm.parentNode;
   if(n)
   {
     while(1==1)
     {
       if(n.className && n.className=="foldertree") break;
       if(n.tagName=="UL")
       {
         n.className = "show_ul";
         n.parentNode.getElementsByTagName("span")[0].className="img";
       }
       n = n.parentNode;
     }
   }
}

//////////////////////////////////////////////////////
// [All skins] View mail
// add: str_replace('<a ','<a onclick="openerfix(this);return false" ',$body);
// opens links in JS win without REFERER string!
// Doesnt work on Mozilla Browsers!
function openerfix(elm)
{
  var win = window.open("blank.html");
  win.location.href = elm.href;
  win.focus();
}

//////////////////////////////////////////////////////
function PREinitCmenu1(cfolder,mainf) {

   var folder1 = cfolder.substr(cfolder.indexOf("^")+1);
   var folder2 = folder1.indexOf("\\")?folder1.substr(folder1.lastIndexOf("\\")+1):folder1;
   var folder3 = cfolder.substr(0,cfolder.indexOf("^"));

   var addf= '<form action="folders.html" target="ffolders" onsubmit="PREinitCmenu1s(this,\'2\');return false;">'+
         '<input type="hidden" name="xfolderoldx" value="'+folder1+'">'+
         WMlang["MSG_ADDSUBFOLDER"]+' :<br/><input type="text" name="folder" value="" class="inormal">'+
         '&nbsp;<input type="submit" name="Save_x" value="'+WMlang["MSG_ADDBUTTON"]+'" class="button">'+
         '<input type="hidden" name="id" value="'+userid+'">'+
         '</form>';
   if(mainf)
      parent.CMenuData.folder_cmenu = [
      [WMlang["MSG_FOLDER"]+' "'+folder2+'"',"menu-header"],
      ["",addf,"","cmform",4]];
   else {
      var renf= '<form action="folders.html" target="ffolders" onsubmit="PREinitCmenu1s(this,\'1\');return false;">'+
            '<input type="hidden" name="xfolderoldx" value="'+folder1+'">'+
            WMlang["MSG_MODIFYBUTTON"]+' :<br/><input type="text" name="folder" value="'+folder2+'" class="inormal">'+
            '&nbsp;<input type="submit" name="Modify_x" value="'+WMlang["MSG_MODIFYBUTTON"]+'" class="button">'+
            '<input type="hidden" name="folderold" value="'+folder3+'">'+
            '<input type="hidden" name="id" value="'+userid+'">'+
            '</form>';

      parent.CMenuData.folder_cmenu = [
      [WMlang["MSG_FOLDER"]+' "'+folder2+'"',"menu-header"],
      ["",renf,"","cmform",4],
      ["",addf,"","cmform",4],
      ["-"],
      ["javascript: sendMe('folders.html?id="+userid+"&Delete_x=1&item[]="+escape(escape(folder3.replace(/\'/g, "\\\'")).replace(/\+/g,"%2B"))+"','ffolders','folder_cmenu');",WMlang["MSG_DELETEFOLDER"],"","cm_delete"]];
   }
}
function sendMe(surl,sframe,cM){
   if(confirm(WMlang["MSG_AREYOUSURE"])){
     if(sframe)
       parent[sframe].document.location.href=surl;
     else
       document.location.href=surl;
   }
   if(cM) setTimeout(function(){WM_ContentMenu1[cM].popupMenuClose();},50);
}

     function PREinitCmenu1s(elm,type){
       var oldone = elm.elements[0].value;
       var newone = elm.elements[1].value;
       if(!newone && newone=="") return false;

       if(type==1) {
         if(oldone.indexOf("\\")>-1) elm.elements[1].value= oldone.substr(0,oldone.lastIndexOf("\\")+1)+elm.elements[1].value;
         if(elm.elements[1].value==oldone) return false;
       }
       else
         elm.elements[1].value= oldone+"\\"+newone;

       elm.submit();
       setTimeout(function(){WM_ContentMenu1['folder_cmenu'].popupMenuClose();},50);
       return false;
     }
//////////////////////////////////////////////////////
// IceWarp JS Menu object
// CHANGE this.ieselhack.src = "empty.html";!!!!
// folders (rClick); view (attachments)
var WM_ContentMenu1=[];var CMenuData ={};
function WM_ContentMenu(myname,mycss){ this.ev;this.CMdata;this.myname=myname;this.noclose2;this.startelm;this.nlevel_style;this.mydiv;this.mycss = mycss;this.startFIX;this.topmargin;this.doc = parent.document;this.inframe;this.ieselhack;this.is_ie= navigator.appName=="Microsoft Internet Explorer" ? 1 : 0;
};WM_ContentMenu.prototype.popupMenuClose = function(myname,incme) { var ev = parent.window.event;var curent=[];if(myname) { var keypos;for(var key in WM_ContentMenu1){ if(key==this.myname){ keypos=1;if(incme) curent[key]=1;}else if(keypos) curent[key] =1;};if(!keypos) return;}else
for(var key in parent.WM_ContentMenu1) curent[key] =1;for (var key in curent){ if(!WM_ContentMenu1[key]) continue;if (WM_ContentMenu1[key].startelm) WM_removeClass(WM_ContentMenu1[key].startelm,"hovered");if(WM_ContentMenu1[key].startFIX) document.body.removeChild(WM_ContentMenu1[key].startFIX);
if(WM_ContentMenu1[key].mydiv) document.body.removeChild(WM_ContentMenu1[key].mydiv);if(WM_ContentMenu1[key].ieselhack) document.body.removeChild(WM_ContentMenu1[key].ieselhack);WM_ContentMenu1[key]=null;};if(!myname){ if(document.getElementById("WMCM_hidden_div")) document.getElementById("WMCM_hidden_div").style.display="none";
window.onscroll=null;WM_ContentMenu1=null;WM_ContentMenu1=[];}};WM_ContentMenu.prototype.fillMenu = function(divlink) { if(typeof this.CMdata!="object") return;var CMdata = this.CMdata;var this2=this;if(CMdata[0][0]){ var rheader = this.doc.createElement("div");rheader.innerHTML = CMdata[0][0];
rheader.className = CMdata[0][1];if (this.is_ie) rheader.unselectable = "on";divlink.appendChild(rheader);};if(this.is_ie){ var rheader = this.doc.createElement("form");with(rheader){innerHTML ="<button/>";style.height="1px";style.width="1px";style.overflow="hidden";style.margin="0px";};
divlink.appendChild(rheader);};for (var rowid=1;rowid<this.CMdata.length;rowid++) { if(CMdata[rowid][0]=="-"){ var rlink = this.doc.createElement("div");rlink.innerHTML ="&nbsp;";CMdata[rowid][3]="hline";}else{ if(!CMdata[rowid][0] || CMdata[rowid][4]){ var rlink = this.doc.createElement(CMdata[rowid][4]==4?"span":"a");
if(CMdata[rowid][4]==2 || CMdata[rowid][4]==3){ if(CMdata[rowid][4]==3) rlink.className = "inactive";else eval("rlink.onmouseover = function(){if(WM_ContentMenu1['"+ CMdata[rowid][0]+"'] && WM_ContentMenu1['"+CMdata[rowid][0]+ "'].startelm==this) return false;this2.popupMenuClose(this2.myname);initCmenu('"+
CMdata[rowid][0]+"',this,"+(this.nlevel_style?3:4)+");};");CMdata[rowid][1]="<span>"+CMdata[rowid][1]+"</span>";}else rlink.className = "inactive";if(CMdata[rowid][4]!=4) rlink.href="javascript: void(0);";}else{ var rlink = this.doc.createElement("a");rlink.href = CMdata[rowid][0];if(CMdata[rowid][2]){
rlink.target = CMdata[rowid][2];rlink.onmousedown= function(){if(window.event && window.event.button==2) return true;setTimeout(function(){this2.popupMenuClose();},150);return true;}};if(CMdata[rowid][5]){rlink.oncontextmenu= function(){ var what2do = this.parentNode.oncontextmenu;this.parentNode.oncontextmenu = function(){var this2x=this;setTimeout(function(){this2x.oncontextmenu = what2do;},100);return true;}};
}};rlink.innerHTML = CMdata[rowid][1];};if(CMdata[rowid][3]) WM_addClass(rlink,CMdata[rowid][3]);if(!rlink.onmouseover) rlink.onmouseover=function(){ this2.popupMenuClose(this2.myname);if(this2.nlevel_style && this2.nlevel_style<4 && !this2.noclose2){ WM_ContentMenu.prototype.noclose2=1;
}};divlink.appendChild(rlink);}};WM_ContentMenu.prototype.popupMenu = function() { var ev = this.ev,thisko=this;var target = this.is_ie ? ev.srcElement : ev.target;if(this.nlevel_style && this.nlevel_style!=4) WM_ContentMenu.prototype.noclose2=1;if(this.startelm) WM_addClass(this.startelm,"hovered");
function getPos(el){ var r ={x: el.offsetLeft, y: el.offsetTop};if (el.offsetParent){ var tmp = getPos(el.offsetParent);r.x += tmp.x;r.y += tmp.y;};return r;};var POPdoc=this.doc;if(!this.nlevel_style || this.nlevel_style<3){ var hdiv =document.getElementById("WMCM_hidden_div");
if(!hdiv){ var hdiv = POPdoc.createElement("div");hdiv.innerHTML="&nbsp;";hdiv.id ="WMCM_hidden_div";POPdoc.body.appendChild(hdiv);}else hdiv.style.display="";hdiv.oncontextmenu = function(){return false;};hdiv.style.top=document.body.scrollTop;window.onscroll=function(){if(hdiv) hdiv.style.top=document.body.scrollTop;};
setTimeout(function(){ hdiv.onmousedown = function(){thisko.noclose2=0;thisko.popupMenuClose();};hdiv.oncontextmenu = function(){thisko.noclose2=0;thisko.popupMenuClose();}},150);if(this.nlevel_style && this.nlevel_style<4){ hdiv.onmousemove = function(){ if(thisko.noclose2){ WM_ContentMenu.prototype.noclose2=0;
setTimeout(function(){ if(thisko.noclose2==0){ thisko.popupMenuClose();}},50);}};}else hdiv.onmousemove = function(){return false;}};var div = POPdoc.createElement("div");this.mydiv = div;if(this.is_ie){ this.ieselhack = POPdoc.createElement("iframe");this.ieselhack.className="WMCM_selectFIX_frm";
this.ieselhack.src = "empty.html";};if(this.mycss) div.className = this.mycss;else if(this.CMdata[0][2]) div.className = this.CMdata[0][2];else div.className ='context-menu';div.oncontextmenu = function(){return false;};if (this.is_ie) div.unselectable = "on";if(this.nlevel_style && this.nlevel_style<4){
div.onmousemove = function(){ if(!thisko.noclose2){WM_ContentMenu.prototype.noclose2=1;}};};this.fillMenu(div);POPdoc.body.appendChild(div);if(this.is_ie) POPdoc.body.appendChild(this.ieselhack);var dx,dy,x=0,y=0;if(this.inframe){ var ifpos2 = getPos(document.getElementById(this.inframe));
x+=ifpos2.x+1;y+=ifpos2.y+1;};if(this.startelm){ var ifpos = getPos(this.startelm);x+= ifpos.x;y+= ifpos.y;if(this.nlevel_style && this.nlevel_style<3){ this.startFIX = POPdoc.createElement("div");with(this.startFIX){ innerHTML ="&nbsp;";className ="WMCM_startFIX_div";style.left= x;
style.top = y;style.width = this.startelm.offsetWidth;style.height= this.startelm.offsetHeight;};POPdoc.body.appendChild(this.startFIX);this.startFIX.onmouseover=function(){ thisko.popupMenuClose(thisko.myname);if(!thisko.noclose2) WM_ContentMenu.prototype.noclose2 = 1;};this.startFIX.onmouseout=function(){
if(thisko.noclose2){ WM_ContentMenu.prototype.noclose2 = 0;setTimeout(function(){if(!thisko.noclose2) thisko.popupMenuClose();},50);}};};if(this.inframe){ y-=parent.window[this.inframe].document.body.scrollTop;x-=parent.window[this.inframe].document.body.scrollLeft;};if(this.nlevel_style==1) y+= this.startelm.offsetHeight;else x+= this.startelm.offsetWidth;
dx = x + div.offsetWidth - this.doc.body.clientWidth + 4;if(dx > 0){ if(this.nlevel_style!=1) x -= (this.startelm.offsetWidth+div.offsetWidth-2);else x -= dx;}}else{ x += ev.clientX;y += ev.clientY;if(parent && window.name){ var Myframe = parent.document.getElementById(window.name);
var ifpos = getPos(Myframe);x+=ifpos.x;y+=ifpos.y;};if(this.nlevel_style!=1){ dx = x + div.offsetWidth - this.doc.body.clientWidth + 4;dy = y + div.offsetHeight - this.doc.body.clientHeight + 4;if (dx > 0) x -= dx;}};dy = y + div.offsetHeight - (this.doc.body.clientHeight + this.doc.body.scrollTop);
if(this.nlevel_style!=1) if (dy > 0) y -= dy;if(this.is_ie){ with(this.ieselhack.style){ left= x>-1?x:0 + "px";top = y>-1?y:0 + "px";width = div.offsetWidth;height= div.offsetHeight;}};div.style.left = x>-1?x:0 + "px";div.style.top = y>-1?y:0 + "px";};var WM_ContentMenu1 = [];
function initCmenu(CMdata,startelm,levelstyle,mycss,inframe,evn) { if(!evn) var evn = window.event;if(!startelm && (evn.button==0 || evn.button==1)) return true;if(top.length != self.length) parent.initCmenu(CMdata,startelm,levelstyle,mycss,window.name,evn);else { if(!WM_ContentMenu1[CMdata]){
if(!levelstyle || levelstyle<3){ WM_ContentMenu1[CMdata] = new WM_ContentMenu(CMdata);WM_ContentMenu1[CMdata].popupMenuClose();};WM_ContentMenu1[CMdata] = new WM_ContentMenu(CMdata,mycss);}else{ if(startelm && WM_ContentMenu1[CMdata].startelm==startelm){WM_ContentMenu.prototype.noclose2 = 1;return;}else{
if(!levelstyle || levelstyle<3) WM_ContentMenu1[CMdata].popupMenuClose();else WM_ContentMenu1[CMdata].popupMenuClose(CMdata,1);WM_ContentMenu1[CMdata] = new WM_ContentMenu(CMdata,mycss);}};WM_ContentMenu1[CMdata].inframe = inframe;WM_ContentMenu1[CMdata].ev = evn;WM_ContentMenu1[CMdata].startelm=startelm;
 WM_ContentMenu1[CMdata].nlevel_style=levelstyle;WM_ContentMenu1[CMdata].CMdata = parent.CMenuData[CMdata];WM_ContentMenu1[CMdata].popupMenu();}};

//Item CSS Class objects
WM_removeClass = function(el, className) {
        if (!(el && el.className)) {
                return;
        }
        var cls = el.className.split(" ");
        var ar = new Array();
        for (var i = cls.length; i > 0;) {
                if (cls[--i] != className) {
                        ar[ar.length] = cls[i];
                }
        }
        el.className = ar.join(" ");
};

WM_addClass = function(el, className) {
        WM_removeClass(el, className);
        if(el.className=="") el.className = className; else el.className += " " + className;
};

WM_hasClass = function(el, className) {
        if (!(el && el.className)) {
                return false;
        }
        var cls = el.className.split(" ");
        for (var i = cls.length; i > 0;) {
                if (cls[--i] == className) {
                        return true;
                }
        }
        return false;
};
/**
 * Attachment management
 */
function uploadme(elm){
   elm.form.submit();

   //get filename
   var pos  = Math.max(elm.value.lastIndexOf('/'),elm.value.lastIndexOf('\\'))+1;
   var file = elm.value.substr(pos,elm.value.lastIndexOf('.')-pos);
   var ext  = elm.value.substr(elm.value.lastIndexOf('.'));
   if(file.length>32) file = file.substr(0,32)+'..';

   //clear upload form
   elm.value = "";
   elm.disabled = true;

   //show "ending in progres"
   document.getElementById('sendingatt').style.display='block';
   document.getElementById('sendingatt_info').innerHTML = (file+ext);
}

function closeupload(){
   try{
       window.frames['uploadframe'].location.href = "uploadatt.html";
       document.getElementById('sendingatt').style.display='none';
       document.forms['sendattach'].newatt.disabled = false;
   }
   catch(e){}
}