<?php
class Backup
{
	var $_counter;
	var $_backup_sync;
	var $_backup_name;
	
	function Backup()
	{
		$this->_counter=1;
	}
	
	function set_backup_sync($name)
	{
		if (isset($name))
		{
			$this->_backup_sync=true;
			$this->_backup_name=$name;
		}
	}
	
	function item_encode($item,$format)
	{
		if (!$format)
		  return $item;
		  
		$file=new xml_tree_node('File',NULL);
    $file->new_child_data('name',NULL,($this->_backup_name?($this->_backup_name.'_'):'').date('Ymd\THi_',time()).$this->_counter++);
	  $file->new_child_data('contenttype',NULL,$format);
		$file->new_child_data('body',array('enc'=>'base64'),base64_encode($item));
		$file->new_child_data('size',NULL,strlen($item));

		return $file->print_node(0,false);
	}
	
	function item_decode($item,$format)
	{
		if (!$item)
		  return;

		if ($format || $this->_backup_sync)
		{
			$file=text_to_xml($item);

			if ($forced_format=$file->get_data('contenttype'))
			{
				$item=base64_decode($file->get_data('body'));
		  	
		  	if ($format)
          $forced_format='';
		  }
		  else
		    $item='';
		}

		return array('item'=>$item,'format'=>$forced_format);
	}
}
?>
