_me = frm_backup.prototype;
function frm_backup(){};

_me.__constructor = function() {
	var me = this;

	this._size(700,'',true);
	this._title('MAIN_MENU::IMPORT_EXPORT');
    this._resizable = false;

	this._draw('frm_backup','main');

	this._activeFolder = this._activeFolder2 = Mapping.getDefaultFolderForGWType('C');

    this.__changeFolder(sPrimaryAccount,this._activeFolder);
    this.__changeFolder2(sPrimaryAccount,this._activeFolder2);

	storage.library('wm_import');

	this.maintab.csv.folders._onclick = function(){
		gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::SELECT_FOLDER',sPrimaryAccount,me._activeFolder2,[me,'__changeFolder2'],true,true,'C','',true);
	};
	this.maintab.csv['export']._onclick = function(){
		downloadItem('sid='+dataSet.get('main',['sid'])+'&class=exportcsv&fullpath='+ sPrimaryAccount+ '/' + me._activeFolder2 +'/'+ this._parent.separator._value());
	};
	
	
	
    this.maintab.gw.export_gw._onclick = function(){
		downloadItem('sid='+dataSet.get('main',['sid'])+'&class=groupware&fullpath='+ sPrimaryAccount);
	};

    this.maintab.gw.import_gw._onchange = function(arg){
		if (arg.folder && arg.id){
			var oImport = new wm_import();
			if (oImport.import_data({'action':'groupware','account':sPrimaryAccount,'path':(arg.folder +'/'+ arg.id)}))
				alert(getLang('BACKUP::IMPORT_SUCCESSFUL'));
			else
				alert(getLang('BACKUP::IMPORT_UNSUCCESSFUL'));
		}
	};

    this.maintab.contact.step1._onchange = function(){
        var sFolderType = dataSet.get("folders",[sPrimaryAccount,me._activeFolder,'TYPE']);

		if (this._value() == 'vcalendar' && (sFolderType!='E' && sFolderType!='T' && sFolderType!='J'))
			me._activeFolder = Mapping.getDefaultFolderForGWType('E');
		else
		if (sFolderType == 'E')
			me._activeFolder = Mapping.getDefaultFolderForGWType('C');
			
		me.maintab.contact.folders._title(me._activeFolder);
	};
	
	this.maintab.contact.step3._onchange = function(arg){

		if (arg.folder && arg.id){

			var action = this._parent.step1._value();
			if (action == 'auto'){
				switch(arg.name.substr(arg.name.lastIndexOf('.')+1).toLowerCase()){
				case 'csv':
				    action = 'csv';
				    break;
				case 'ldif':
				    action = 'ldif';
				    break;
				case 'vcf':
				    action = 'vcard';
				    break;
				case 'vcs':
				case 'ics':
				    action = 'vcalendar';
				    break;

				default:
					alert(getLang('BACKUP::UNKNOWN_EXT'));
					return;
				}
			}

			me.__value = arg;
			me.__value.action = action;

			var oImport = new wm_import()

			var result = oImport.import_data({'action':action,'folder':me._activeFolder,'lines':(action=='csv'?5:0),'account':sPrimaryAccount,'path':(arg.folder +'/'+ arg.id)});
			
			if (action=='csv' && Is.Array(result)){

				var elm = document.getElementById(this._parent._pathName+'csv');
				removecss(elm,'hidden');
				
				this._parent.step4._fill(result);
				this._parent.step5._disabled(false);
			}
			else{
				me.__value = null;
				if (result)
					alert(getLang('BACKUP::IMPORT_SUCCESSFUL'));
				else
					alert(getLang('BACKUP::IMPORT_UNSUCCESSFUL'));
			}
		}
		return true;
	};

	//IMPORT BUTTON
	this.maintab.contact.step5._onclick = function(){
		if (me.__value.folder && me.__value.id){

			var aData = this._parent.step4._value();

			if (!count(aData)){
				alert(getLang('BACKUP::SELECT_COL'));
				return;
			}
			else
			if(!aData.LOCATIONS){
				alert(getLang('BACKUP::SELECT_EMAIL'));
				return;
			}

			var oImport = new wm_import();
			var result = oImport.import_data({'action':'csv',values:aData,'folder':me._activeFolder,'account':sPrimaryAccount,'skipfirst':this._parent.step4x._value()?true:false,'path':(me.__value.folder +'/'+ me.__value.id)});

			if (result){
				this._parent.step4._fill();
				me.__value = null;

				var elm = document.getElementById(this._parent._pathName+'csv');
				addcss(elm,'hidden');
				
				alert(getLang('BACKUP::IMPORT_SUCCESSFUL'));
			}
			else
				alert(getLang('BACKUP::IMPORT_UNSUCCESSFUL'));
		}
	};
	
	this.maintab.contact.folders._onclick = function(){
		var sFolderType = dataSet.get("folders",[sPrimaryAccount,me._activeFolder,'TYPE']);

		if (sFolderType != 'C')
			sFolderType = ['E','T','J'];
		
		gui._create('frm_select_folder','frm_select_folder','','','POPUP_FOLDERS::SELECT_FOLDER',sPrimaryAccount,me._activeFolder,[me,'__changeFolder'],true,true,sFolderType,'',true);
	};
};

_me.__changeFolder = function(sAccount,sFolder){
	this._activeFolder = sFolder;
	this.maintab.contact.folders._title(Path.basename(dataSet.get('folders',[sAccount,sFolder,'NAME']) || sFolder));
};
_me.__changeFolder2 = function(sAccount,sFolder){
	this._activeFolder2 = sFolder;
	this.maintab.csv.folders._title(Path.basename(dataSet.get('folders',[sAccount,sFolder,'NAME']) || sFolder));
};