_me = frm_gw.prototype;
function frm_gw(){};

_me.__constructor = function(sAccountID, sFolderID, sItemID, aValues, aReccurenceValues) {
	var me = this;
	
	if (!Is.Defined(sAccountID) || !Is.Defined(sFolderID)) return;
	this._sAccountID = sAccountID;
	this._sFolderID = sFolderID;
	this._sItemID = Is.Defined(sItemID) ? sItemID : false;
	this._aReccurenceValues = aReccurenceValues;

	if (Is.Object(aValues))
		this._aValues = aValues;
	else if (this._sItemID)
		this._aValues = WMItems.list({"aid": this._sAccountID, "fid": this._sFolderID, "iid": this._sItemID})[this._sAccountID][this._sFolderID][this._sItemID];
	else
		this._aValues = {};

	this._id = [sAccountID, sFolderID];
	if (this._sItemID) this._id.push(sItemID);
	
	this._repeating = Is.Object(aReccurenceValues) && Item.hasReccurence([sAccountID,sFolderID,sItemID], this._aValues['EVNRCR_ID']);
	this._defaultSize();
};

_me.__initForm = function(sTitle) {
	this._title(sTitle);
	this.__loadItems();
	this.__createFooter();
};

// Virtual function
_me.__saveItems = function(aValues) {};

// Virtual function
_me.__loadItems = function(aValues) {};

_me.__createFooter = function() {
	var me = this;

	if (this._sItemID && !(WMFolders.getAccess({'aid':this._sAccountID,'fid':this._sFolderID},'modify')))
		this.x_btn_ok._disabled(1);
	else
		// This function is triggered when 'OK' button is pressed
		this.x_btn_ok._onclick = function() {

			//dblclick fix
			if (this._disabled())
				return false;
			this._disabled(true);


			var aValues = {'values':[]};

			storeDataFromForm(me, aValues['values']);
			
			me.__saveItems(aValues);

			if (!Is.Empty(aValues)) {
				if (me._repeating) {
					me._newValues = aValues;

					//dblclick fix
				    this._disabled(false);

					gui._create('frm_confirm_repeating', 'frm_confirm_repeating', '', '', [me,'__editRepeating'],'REPEATING_CONFIRM::TITLE_EDIT', 'REPEATING_CONFIRM::TEXT_EDIT');
				}
				else
				if (!WMItems.add(me._id, aValues, 'dummy', '','',[me,'_listFolder']))
					this._disabled(false);
			}
			else
				me._destruct();
		};
};

_me._listFolder = function (){
	var aItems = dataSet.get('items');
	for(var sAccId in aItems)
	  for(var sFolId in aItems[sAccId]);
	  
	if (sAccId == this._sAccountID && sFolId == this._sFolderID) {

		var aView = dataSet.get('datagrid_views',[sAccId,sFolId]);
		switch(aView.view){
			case 'list_view':
				gui.frm_main.main.list._serverSort({aid:sAccId,fid:sFolId},aView['sort']['column'],aView['sort']['type']);
			break;

			case 'day_view':
			case 'week_view':
			case 'month_view':
				gui.frm_main.main._serverSort();
		}
	}
	this._destruct();
};

_me.__editRepeating = function (nType) {

	var me = this;
	var aValues = this._newValues;

	switch (nType) {
		case 0: // only this
			// check whether the time has been changed, if not, keep the actual date for
			// edited reccurence
			if (this._aValues['EVNSTARTDATE'] == aValues['values']['EVNSTARTDATE'] && this._aValues['EVNENDDATE'] == aValues['values']['EVNENDDATE'])
			{
			    aValues['values']['EVNSTARTDATE'] = this._aReccurenceValues['EVNSTARTDATE'];

				//All day
				if (this._aValues['EVNSTARTTIME']<0 && this._aValues['EVNENDTIME']<0)
					aValues['values']['EVNENDDATE'] = this._aReccurenceValues['EVNENDDATE']+1;
				else
					aValues['values']['EVNENDDATE'] = this._aReccurenceValues['EVNENDDATE'];
			}
			aValues['values']['EXPDATE'] = this._aReccurenceValues['EVNSTARTDATE'];
			break;
		case 1: // all
			// do nothing, continue further
			break;
		case 2: // all from now
			if (this._aValues['EVNSTARTDATE'] == aValues['values']['EVNSTARTDATE'] && this._aValues['EVNENDDATE'] == aValues['values']['EVNENDDATE'])
			{
				aValues['values']['EVNSTARTDATE'] = this._aReccurenceValues['EVNSTARTDATE'];

				//All day
				if (this._aValues['EVNSTARTTIME']<0 && this._aValues['EVNENDTIME']<0)
					aValues['values']['EVNENDDATE'] = this._aReccurenceValues['EVNENDDATE']+1;
				else
					aValues['values']['EVNENDDATE'] = this._aReccurenceValues['EVNENDDATE'];
			}
			aValues['values']['EXPDATE'] = this._aReccurenceValues['EVNSTARTDATE'];
			aValues['values']['EXPFOLLOWING'] = 'true';
			break;
		default:
			this._destruct();
			return;
	};

	WMItems.add(this._id, aValues, 'dummy', '','',[this,'_listFolder']);
};