_me = frm_mail.prototype;
function frm_mail(){};

_me.__constructor = function(sDataSet,sDataPath) {

	this._defaultSize();
	
	var me = this;

	this._title('COMMON::LOADING');
	
	this._create('view','obj_mailview','main');
    this._create('menu','obj_hmenu','header','obj_pupup_menu');
    this.menu._onclick = function(e, elm, id, sAction){
		if (typeof sAction == 'object')
			executeCallbackFunction(sAction);
		else
		switch(sAction){
		case 'print':
			me.view._print();
		    break;
		case 'delete':
            Item.remove([me.__id[0],me.__id[1],[me.__id[2]]]);
			me._destruct();
			break;
		case 'reply_to_sender':
			OldMessage.reply(me.__id, false);
			break;
		case 'reply_to_all':
			OldMessage.reply(me.__id, true);
			break;
		case 'forward':
			OldMessage.forward(me.__id);
			break;
		}
	};

	this._listen(sDataSet,sDataPath);
	this._add_destructor('__destruct');
};

_me.__update = function(sDataSet,sDataPath){

	var aData = dataSet.get(sDataSet,this._listenerPath);
	if (aData){
		for(var aid in aData)
			for(var fid in aData[aid]){
				delete aData[aid][fid]['#'];
				delete aData[aid][fid]['/'];
				delete aData[aid][fid]['$'];
				for(var iid in aData[aid][fid]);
			}
			
		if (!aData[aid][fid][iid].aid) return;
		
		this.__sFolderID = aid+'/'+fid;
		this.__sFolderType = dataSet.get("folders",[aid,fid,'TYPE']) || 'M';
		this.__id = [aid,fid,iid];
		
		this._fill(aData[aid][fid][iid]);
	}
};

_me.__destruct = function(){
	dataSet.remove(this._listener,this._listenerPath,true);
	return true;
};

_me._fill = function(aData){

	/*** Fill menu ***/
	var folders = GWOthers.get('DEFAULT_FOLDERS','storage')['VALUES'];

	var aMenu = [];

	if (this.__sFolderType == 'M'){
		if (this.__sFolderID != folders['drafts'] && this.__sFolderID != folders['sent']) {
			aMenu.push({"title": 'MAIN_MENU::REPLY_TO_SENDER', 'arg': 'reply_to_sender'});
			aMenu.push({"title": 'MAIN_MENU::REPLY_TO_ALL', 'arg': 'reply_to_all'});
		}
		aMenu.push({"title": 'MAIN_MENU::FORWARD', 'arg': 'forward'});
	}

	aMenu.push({"title": 'POPUP_ITEMS::SAVE_AS', 'arg': [Item.downloadSource, [this.__id,'text']],
     "nodes":[
		{"title": 'POPUP_ITEMS::TEXT', 'arg': [Item.downloadSource, [this.__id,'text']]},
		{"title": 'POPUP_ITEMS::HTML', 'arg': [Item.downloadSource, [this.__id,'html']]},
		{"title": 'POPUP_ITEMS::EML', 'arg': [Item.downloadSource, [this.__id]]}
	 ]
	});

	aMenu.push({"title": '-'});
	aMenu.push({"title": 'MAIN_MENU::DELETE', 'arg': 'delete',disabled:this.__id[2].indexOf('|')<0?false:true});
    aMenu.push({"title": '-'});
	aMenu.push({"title": 'MAIN_MENU::PRINT', 'arg': 'print'});

    this.menu._fill(aMenu);

	/*** Fill Title ***/
	if (aData.SUBJECT){
		if (aData.SUBJECT.length>32)
			this._title(aData.SUBJECT.substr(0,32)+'...',true);
		else
			this._title(aData.SUBJECT,true);
	}
	else
		this._title('MAIL_VIEW::NOSUBJECT');

	/*** Fill Body ***/
	this.view._listen(this._listener,this._listenerPath);
};