_me = frm_mail_settings.prototype;
function frm_mail_settings(){};

_me.__constructor = function(aInitValues, bHideHtml, aCallback) {

	var me = this;
	this._title('SETTINGS::MAIL_SETTINGS');
	this._size(550,'',true);
	
	this._draw('frm_mail_settings_default','main',{msgsettings:true});

	//fill spellchecker lang
	storage.library('gw_others');
	var aLang = GWOthers.get('SPELLCHECKER_LANGUAGES','storage','',true);
	var aData = {};
	for (var lang in aLang['VALUES'])
		aData[lang] = aLang['VALUES'][lang];
	this.spellchecker._fill(aData);
	this.spellchecker._value(aInitValues['VALUES']['spellchecker'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','spellchecker'))

	//fill priority
	this.priority._fillLang({
		'1':"EMAIL_PRIORITY::HIGHEST",
		'2':"EMAIL_PRIORITY::HIGH",
		'3':"EMAIL_PRIORITY::NORMAL",
		'4':"EMAIL_PRIORITY::LOW",
		'5':"EMAIL_PRIORITY::LOWEST"
	});
	this.priority._value(aInitValues['VALUES']['priority'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','priority'));

	//alias
	var sAdr = getPrimaryAccountFromAddress();
	var aData = {};
	    aData[sAdr] = sAdr;
	    
	var aPers = dataSet.get('storage',['PERSONALITIES','ITEMS']);
	for(var i in aPers)
		aData[aPers[i].VALUES.PERSON.VALUE] = aPers[i].VALUES.PERSON.VALUE;

	this.from._fill(aData);
	this.from._value(aInitValues['from'] || sAdr);

	//sent
	this.sent._value(aInitValues['VALUES']['sent'] || GWOthers.getItem('DEFAULT_FOLDERS','sent'));
	
	//fill charset
	this.charset._value(aInitValues['VALUES']['charset'] || GWOthers.getItem('MAIL_SETTINGS_DEFAULT','charset'));
	
	if (Is.Object(aInitValues))
		loadDataIntoFormOnAccess(this, aInitValues);

	this.x_btn_ok._onclick = function() {
		if (Is.Defined(aCallback)) {
			// Save non-well known resources
			var aValues = {};
			storeDataFromForm(me, aValues);
			executeCallbackFunction(aCallback, aValues);
		}
		me._destruct();
	};
};