_me = obj_attach_edit_single.prototype;
function obj_attach_edit_single() {};

_me.__constructor = function() {};

_me._add = function(aArg, bInit) {
	if (this.__idtable.length) {
		if (this.__bOnServer)
			this.__removedID = this.__idtable[0]['id'];
			
		this._remove(0);
		this.__bOnServer = false;
	}
	
	if (this.__eIN && this.__eIN.disabled == true){
		this.__eIN.disabled = false;
		if (this._onuploadend) this._onuploadend(aArg);
	}

	this._addGuiElement(aArg, 0);

	this.__idtable[0] = aArg;
	
	if (!bInit)
		this.__bChanged = true;
};

_me._onclick = function() {
	var id = this.__idtable[0]['id'];
	var sClass = (this.__idtable[0]['class']) ? this.__idtable[0]['class'] : 'file';
	
	switch (sClass) {
		case 'file': var sFullPath = this._form['folder'].value+'/'+id; break;
		case 'attachment': var sFullPath = this._gwPath+'/'+id; break;
	}
	
	if (sFullPath) {
		var aUrl = {'sid': dataSet.get('main', ['sid']), 'class': sClass, 'fullpath': sFullPath};
        downloadItem(buildURL(aUrl));
	}
};

_me.__addItem = function(aItem) {
	    if (!this.__idtable || !this.__idtable[0] || this.__idtable[0].id != aItem['id']) {
	    	this._add({
				'name': aItem['title'],
				'id': aItem['id'],
				'size': aItem['size'],
				'type': aItem['embedded'] ? 'item' : 'itemlink',
				'fullpath': aItem['fullpath']
			});
			
			if (aItem['fullpath'])
				this._form['folder'].value = aItem['fullpath'].substr(0,aItem['fullpath'].lastIndexOf('/'));
		}
};

_me._getName = function() {
	if (this.__idtable[0])
		return this.__idtable[0]['name'];
};

_me._getSize = function() {
	if (this.__idtable[0])
		return this.__idtable[0]['size'];
};

_me._value = function(v) {
	if (Is.Defined(v)) {
		this._gwPath = v['path'];
		var aValues = v['values'];
		
		for (var i in aValues) {
			this._add({'name': aValues[i]['values']['ATTDESC'], 'class': aValues[i]['values']['ATTTYPE'], 'id': i, 'size': aValues[i]['values']['ATTSIZE']}, true);
			break;
		}
		
		this.__bOnServer = true;
	}
	else {
		var aResult = [];

		if (this.__removedID)
			aResult.push({'uid': this.__removedID});

		if (this.__bChanged)
			aResult.push({'values': {'class': this.__idtable[0]['type'] || 'file' , 'description': this.__idtable[0]['name'], 'fullpath': this._form['folder'].value+'/'+this.__idtable[0]['id']}});
		else
		if (!this.__removedID && this.__bPassed)
			aResult.push({'values': {'class': 'attachment' , 'description': this.__idtable[0]['name'], 'fullpath': this._gwPath}});
		
		return aResult;
	}
};