_me = obj_calendar.prototype;
function obj_calendar(){};

_me.__constructor = function(){
	var me = this;
	this.__eMain  = this._getAnchor('main');
	this.__timeout;
	
	//Get offset
	var aDays = {'monday':0,'tuesday':6,'wednesday':5,'thursday':4,'friday':3,'saturday':2,'sunday':1};
	storage.library('gw_others');
	try{
		this.__offset = aDays[GWOthers.get('CALENDAR_SETTINGS','storage')['VALUES']['week_begins']];
	}
	catch(er) {
		this.__offset = 1;
	}

	this.__eMain.onclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (elm.tagName!='A') return;
		
		var id		= me.__getId(elm.id);
		var dDate	= me.__getDate(id);
		
		me._value(dDate); 	// pozor dela refresh

		if (me._onclick) me._onclick(e,elm);
		me.__exeEvent('onclick',e,{"owner":me,"elm":elm,"date":dDate});
	};
	
	this.month._onchange = function(){
		me._setDate('',this._value());
		return true;
	};

	this.year._onchange = function(){
		me._setDate(this._value());
		return true;
	};

	this.year._onkeydown = function(e){
    	if((e.keyCode>95 && e.keyCode<106) || e.keyCode==37 || e.keyCode==39 || e.keyCode==8 || e.keyCode==46){

			if (e.keyCode!=37 && e.keyCode!=39){
				if (me.__timeout) window.clearTimeout(me.__timeout);
			    me.__timeout = window.setTimeout('try{ '+me._pathName +'.__setYear(); }catch(er){}',300);
		    }

			return true;
		}
		else
			return false;
	};

	var eLeft1 = this._getAnchor('left1');
		eLeft1.onclick = function(){
			me._setDate('',me._dDate.getMonth());
		};
		eLeft1 = null;
	var eRight1 = this._getAnchor('right1');
		eRight1.onclick = function(){
			me._setDate('',me._dDate.getMonth()+2);
		};
		eRight1 = null;
	var eLeft2 = this._getAnchor('left2');
		eLeft2.onclick = function(){
			if (parseInt(me.year._value()) != NaN)
				me._setDate(me._dDate.getFullYear()-1);
		};
		eLeft2 = null;
	var eRight2 = this._getAnchor('right2');
		eRight2.onclick = function(){
			if (parseInt(me.year._value()) != NaN)
				me._setDate(me._dDate.getFullYear()+1);
		};
		eRight2 = null;


	this.today._onclick = function(e){
		var dDate = new Date();
		me._value(dDate);
	};

	this._value(new Date(),true);
};

/**
 * This method is called in timeslip by this.year selectbox
 **/
_me.__setYear = function(){
	try{
	var year = parseInt(this.year._value());
	if (year != NaN && year > 0 && year < 3000)
		this._setDate(year);
	}
	catch(er){}
};

_me._setDate = function(year,month){
	var year  = year?year:this._dDate.getFullYear();
	var month = typeof month == 'undefined'?this._dDate.getMonth():month-1;

	this._dDate.setFullYear(year,month,1);
	this.__draw();
};

_me._value = function(aData,bNoUpdate){

	if (aData){
		if (aData.constructor == 'Date')
			this._dDate = aData;
		else
		if (Is.Number(aData)){
			var aDate = parseJulianDate(aData);
			this._dDate  = new Date(aDate.year, aDate.month-1, aDate.day);
		}
		else
		if (Is.String(aData) && !isNaN(parseInt(aData))) {
			var aDate = parseJulianDate(parseInt(aData));
			this._dDate  = new Date(aDate.year, aDate.month-1, aDate.day);
		}
		else
			this._dDate  = new Date(aData);

		// selected date
		this._active = new Date();
		this._active.setTime(this._dDate.getTime());

		// clear days
		this._setDate();
		
		if (!bNoUpdate){
			if (this._onchange) this._onchange(this._dDate);
			this.__exeEvent('onchange',null,{"owner":this,"date":this._dDate});
		}
	}
	else
		return this._active;
};

_me.__update = function(sDataSet){
	/* update calendar data */
	if (this._listener_data == sDataSet)
		this.__draw();

	/* update calendar view */
	if (this._listener == sDataSet)
		this._value(dataSet.get(this._listener,this._listenerPath));
};

_me._listen_data = function(sDataSet,aDataPath){
	this._listener_data = sDataSet;
	if (typeof aDataPath == 'object') this._listenerPath_data = aDataPath;
	dataSet.obey(this,'_listener_data',sDataSet);
};

/**
 * @brief: Dataset Parser function
 **/
_me._fill = function(aData) {
	/*
	  PARSER BODY
	*/
	return aData;
};

function dabudtime(){
	var time = new Date();
	return time.getTime();
}

_me.__draw = function(){

	var dToday = new Date();
	if(!this._dDate) this._dDate = new Date();
	
	// Data from dataset
	var aCalendar;
	if (this._listener_data)
		aCalendar = this._fill(dataSet.get(this._listener_data,this._listenerPath_data));

	// Month select
	this.month._value (this._dDate.getMonth()+1,true);

	// Year select
	var fyear = this._dDate.getFullYear();
	this.year._value(fyear,true);

	var MStart = this._dDate.getDay()+ this.__offset;
	if (!MStart) MStart = 7;
	
	var iToday = this._dDate.getFullYear() == dToday.getFullYear() && this._dDate.getMonth() == dToday.getMonth()?dToday.getDate():0;
	var iSelected = (this._active?(this._dDate.getFullYear() == this._active.getFullYear() && this._dDate.getMonth() == this._active.getMonth()?this._active.getDate():0):0);


	// months with February calculation
	var dim    = [31,0,31,30,31,30,31,31,30,31,30,31];
		dim[1] = (this._dDate.getFullYear()%100 != 0 && this._dDate.getFullYear()%4 == 0) || this._dDate.getFullYear()%400 == 0?29:28;
	var MEnd   = dim[this._dDate.getMonth()];

	var aData = {
				"_ins" :this._pathName,
				"weeks":[],
				"days" :['SHORT_DAYS::MONDAY','SHORT_DAYS::TUESDAY','SHORT_DAYS::WEDNESDAY','SHORT_DAYS::THURSDAY','SHORT_DAYS::FRIDAY','SHORT_DAYS::SATURDAY','SHORT_DAYS::SUNDAY']
				};

	if (this.__offset)
    	aData.days 	= aData.days.slice(7-this.__offset).concat(aData.days.slice(0,7-this.__offset));

	var tmp = [],unix,css = '';
	for (var i = 1,j = 1;i <= 42;i++){
		if (i<MStart || j>MEnd)
			tmp.push('');
		else{
			if (aCalendar){
				unix = this.__getDate(j).getUNIX;
				if (aCalendar[unix])
					css = 'busy';
				else
					css = '';
			}

			tmp.push({"class":(j==iToday?'today ':'')+(j==iSelected?'active ':'')+(css?css:''),"value":j++});
		}

		if (!(i%7)) {
			aData.weeks.push(tmp);
			tmp = [];
			if (j>MEnd) break;
		}
	}

	this.__eMain.innerHTML = template.tmp('obj_calendar_main',aData);
};

_me.__getId = function(eid){
	return eid.substr(this._pathName.length);
};

_me.__getDate = function(id){
	return new Date(this._dDate.getFullYear(),this._dDate.getMonth(),id);
};
