/*****************************************************
 * Extension script: CheckBox form object with inverted value!
 *
 *****************************************************/
 
_me = obj_checkbox_inverse.prototype;
function obj_checkbox_inverse(){};

	
	/**
	 * @brief : control element's "checked" html method
	 * @param : b - boolean value
	 * @return: bool;
	 * @date  : 20.4.2006 17:42:24
	 **/
	_me._value = function(b){
		if (Is.Defined(b)) {
			// set the option first (let the parent function do whatever it wants)
			// then check the value that has been set and set inverse one
			this._checked(b);
			if (this._checked())
				this._checked(0);
			else
				this._checked(1);
		} 
		else {
			if (this._checked())
				return 0;
			else
				return 1;
		}
	};
	
