// dodelat aby se takovy obj chlasily jako type = form

/**
 * Extension for container objects
 * (means objects which can contain another objects as child)
 *
 * Supported objects: divwin
 *                    tabs, tab
 **/

_me = obj_container_generic.prototype;
function obj_container_generic(){}

/**
 * @brief: saveall method goes through all child objects and
 *         tries to call their _saveme(true) method
 * @date : 5.5.2006 10:52:12
 * @param: b - PRIVATE recursive
 **/
_me._saveall = function (b){

	var dset = {};
    for (var i in this){
        if (i.indexOf('_')==0) continue;

		if (typeof this[i]._saveme !== 'undefined')
		    dset[this[i]._saveme(true)] = 1;

        if (typeof obj[i]._saveall !== 'undefined')
            dset = objConcat(dset,this[i]._saveall(true));
    }
    
    // update all
	if (!b && count(dset)){
        for (var i in dset) dataSet.update(i);
        return {};
    }
    return dset;
};