_me = obj_input_calendar.prototype;
function obj_input_calendar(){};

_me.__constructor = function(empty,bNoEmpty){

	if (empty) {
		this.__value = '';
		this.__empty = true;
	}
	else {
		this.__bNoEmpty = bNoEmpty;
		this.__value = new Date();
		this.__empty = false;
		this._value(this.__value);
	}

	var me = this;

	this.button._onclick = function(e){
		if (me.cal && me.cal._main.style.display == 'block')
			me.__hideCal();
		else
			me.__showCal();
	};

	this.input._onkeydown = function(e){
		return false;
	};

	this.input._onfocus = function(e){
		me.__showCal();
		return true;
	};
};

_me.__showCal = function(){

	var me = this;

	var pos = getSize(this._main);

	if(!this.cal){
		this.cal = gui._create('fcalendar','obj_calendar');
		addcss(this.cal._main,'obj_calendarfloat');

		//NASTAVENI HODNOTY
		this.cal._value(this._value());
		
		if (!this.__bNoEmpty){
			this.cal._create('empty','obj_button','empty');
			this.cal.empty._value ('CALENDAR::EMPTY');
			this.cal.empty._onclick = function(){
				me._value('empty');
				me.__hideCal();

				if (me._ondateselect) me._ondateselect();
				me.__exeEvent('_ondateselect',null,{"owner":me});
			};
		}
		
		//this.cal._skipsaving = true;
		this.cal._onchange = function(e){

				var dDate = this._value();

				me.__empty = false;
				// save DATE
				me.__value = dDate;

				// show DATE
				var m = dDate.getMonth()+1,d =dDate.getDate();
				me.input._value(me._parseDate(dDate.getFullYear(),m,d));

				me.__hideCal();

				if (me._ondateselect) me._ondateselect(dDate);
				me.__exeEvent('_ondateselect',null,{"date":dDate,"owner":me});
		};

		function mousedown(e){
			var elm = e.target || e.srcElement;

			if (!me.cal || !elm || searchParent(elm, me._main) || searchParent(elm, me.cal._main)) return true;
			if (me.cal.month && me.cal.month.__eOptions && searchParent(elm, me.cal.month.__eOptions)) return true;

			//return original event handler
			gui._disobeyEvent('mousedown',[mousedown]);

			// destruct menu after click anywhere around
			me.__hideCal();

			return true;
		};
		gui._obeyEvent('mousedown',[mousedown]);
	}

	gui.fcalendar._main.style.left	= pos.x;

	//HEIGHT
	var h = 0;
	if (window.innerHeight)
		h = window.innerHeight;
	else
	if (window.document.body)
		h = window.document.body.clientHeight;

	var posh = this.cal._main.offsetHeight;
	if(posh<220) posh = 231; //MSIE!?

	if (h < (pos.y+posh))
		gui.fcalendar._main.style.top = (pos.y-posh) + 'px';
	else
		gui.fcalendar._main.style.top = (pos.y+pos.h) + 'px';
};

_me.__hideCal = function(){
	if (!this.cal) return;
	this.cal._destruct();
	this.cal = null;
	delete this.cal;
};

_me._value = function (aData){

	if (aData){
		this.__empty = false;
		
		if (aData.constructor == 'Date')
			this.__value = aData;
		else
		if (Is.Number(aData) || Is.String(aData) && !isNaN(parseInt(aData))){
			aData = parseInt(aData);
			if (aData == 0) {
				this.__value  = '';
				this.__empty = true;	
			}
			else {
				var aDate = parseJulianDate(aData);
				this.__value  = new Date(aDate.year, aDate.month-1, aDate.day);
			}
		}
		else
		if (aData == 'empty'){
			this.__value  = '';
			this.__empty = true;
		}
		else{
			this.__value  = new Date(aData);
			this.__value.setHours(0);
			this.__value.setMinutes(0);
			this.__value.setSeconds(0);
			this.__value.setMilliseconds(0);
		}

		// set new date to calendar
		if (this.cal) {
			if (this.__empty) {
				var oDate = new Date();
					oDate.setHours(0);
					oDate.setMinutes(0);
					oDate.setSeconds(0);
					oDate.setMilliseconds(0);

				this.cal._value(oDate,true);
			}
			else
				this.cal._value(this.__value);
		}

		// set the proper value into the visible input box
		if (this.__empty || this.__value.getTime() == 0)
			this.input._value(' ');
		else
			this.input._value(this._parseDate(this.__value.getFullYear(),this.__value.getMonth()+1,this.__value.getDate()));
	}
	else {
		if (this.__empty) return '';
		return this.__value?getJulianDate(this.__value.getDate(), this.__value.getMonth()+1, this.__value.getFullYear()):'';
	}
};

_me._getObjectDate = function() {
	if (this.__empty) return '';
	return this.__value;
};

/**
 * @brief: User definable date input parse function
 **/
_me._parseDate = function(y,m,d){
	var tmpDate = new Date(y, m-1, d, 00, 00, 00);
	return tmpDate.toWMString(true);
};

_me._disabled = function(b) {
	if (typeof b == 'undefined')
	    return this.input._disabled();
	else{
		this.input._disabled(b);
		this.button._disabled(b);
	}
};
