_me = obj_progress.prototype;
function obj_progress(){};

_me.__constructor = function(){
	this.__range = 100;
    this.__value = 0;
    
	this.__eBar = mkElement('div');
	this.__eBar.className = 'bar';
	this._main.appendChild(this.__eBar);
	
	this.__eText = mkElement('div');
	this.__eText.className = 'text';
	this._main.appendChild(this.__eText);
};

_me._range = function(i){
	if (!i) return this.__range;
	
	i = parseInt(i);
	if (i == NaN) i = 1;
	this.__range = i;
};

_me._value = function(i){
	if (!i) return this.__value;
	
	i = parseInt(i);
	if (i == NaN) i = 0;
	this.__value = i;

    var no = 0;
	if (i>0){
		no = Math.ceil(i/(this.__range/100));
		no = no>100?100:no;
	}

	if (!no)
		this.__eBar.style.visibility = 'hidden';
	else{
		this.__eBar.style.visibility = 'visible';
		this.__eBar.style.width = no+'%';
		
		if (no<33)
			this.__eBar.className = 'bar bar0';
		else
		if (no>33 && no<66)
			this.__eBar.className = 'bar bar1';
		else
			this.__eBar.className = 'bar bar2';
	}
};

_me._title = function(s){
	this.__eText.innerHTML = s;
};