<?php

require_once('inc/variable.php');

/**
  @class Post
  @brief Class for getting input variables from _POST array.
 */
class Post extends Variable {
	/** Instance of the class. */
	private static $instance = null;

	/**
	  @brief Get instance of the class.
	  @return The instance.
	 */
	public static function instance()
	{
		if (!isset(self::$instance)) {
			$class = __CLASS__;
			self::$instance = new $class($_POST);
		}

		return self::$instance;
	}
}

/**
  @brief Get the instance of class Post.
  @return The instance.
 */
function Post()
{
	return Post::instance();
}

?>
