<?php

class WMAccount{

	public function check($sAction)
	{
		switch($sAction){
			case 'sync':
				if(!($this->oUser = &$_SESSION['user'])){
					throw new Exc('Unauthorized');
				}
				if(!$this->oUser->aAccounts){
					throw new Exc('No Accounts');
				}
			break;
		}
	}
	
	public function sync()
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		//foreach($this->oUser->aAccounts as $oAccount){
			$oAccount = $this->oUser->getAccount($_SESSION['EMAIL']);
			$oAccount->sync();
			$oAccount->aSyncedFolders = array();
			// Refresh info about messages in all Mail folders
			foreach($oAccount->folders["main"] as $oFolder){
				if ($oFolder->sync){
					$oFolder->sync($this);
				}
			}
		//}
		
		/*if(!$oWMUserInterface->getView())
			$oWMUserInterface->setView('mail_list');*/
		try{
			if($oFolder = $oAccount->getFolder($oWMRequest->get('folder'))){
				switch($oFolder->type){
					case 'C':
						$oWMRequest->set('view','contact_list',$oWMRequest->get('rid'));
						break;
					case 'M':
						$oWMRequest->set('view','mail_list',$oWMRequest->get('rid'));
						break;
					
				}
			}
		}catch(Exc $e){
			if(!$oWMUserInterface->getView()){
				$oWMUserInterface->setView('mail_list');
				$oWMRequest->set('view','mail_list',$oWMRequest->get('rid'));
			}
		}

		$oWMData->store('general','sid',$oWMRequest->get('sid'));
	}

}

?>