<?php

class WMItem
{
	public function check($sAction)
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		@$oUser = $_SESSION['user'];
		@$oAccount = $oUser->getAccount($_SESSION['EMAIL']);
		$sFolder = $oWMRequest->get('folder');
		if(!$this->oFolder = $oAccount->getFolder($sFolder)){
			throw new Exc('folder_invalid_id',$sFolder);
		}
		switch($sAction){
			case 'delete':
			case 'mark_read':
			case 'mark_unread':

			break;
			case 'whitelist':
			case 'blacklist':
				$sQuarantineFolder = ucfirst(strtolower($sAction));
				
				try{
					$this->oQuarantineFolder = $oAccount->getFolder('SPAM_QUEUE/'.$sQuarantineFolder);
				}catch(Exc $e){
					
				}
			break;
		}
	}
	
	public function mark_read()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$aItems = $oWMRequest->get('items');
		if($aItems){
			foreach($aItems as $sID){
				$oItem = $this->oFolder->getItem($sID);
				$oItem->markAsRead();
			}
		}
	}
	
	public function mark_unread()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$aItems = $oWMRequest->get('items');

		if($aItems){
			foreach($aItems as $sID){
				$oItem = $this->oFolder->getItem($sID);
				$oItem->markAsUnread();
			}
		}
	}
	
	public function delete()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$aItems = $oWMRequest->get('items');
		if($aItems){
			foreach($aItems as $sID){
				$this->oFolder->deleteItem($sID);
			}
		}
	}
	public function whitelist()
	{
		$oWMRequest = &Singleton::instance('WMRequest');
		$aItems = $oWMRequest->get('items');
		if($aItems){
			foreach($aItems as $sID){
				$oItem = $this->oFolder->getItem($sID);
				$aFrom = Mailparse::parseAddresses($oItem->from);
				$sFrom = $aFrom[0]['address'];
				$this->oQuarantineFolder->createItem(array('email'=>$sFrom));
			}
		}
	}
	public function blacklist()
	{
		//Only difference is in folder ,which is automatically created in check()
		$this->whitelist();
	}
	public function reply()
	{
	}
	
	public function reply_all()
	{
	}
	public function forward()
	{
	}
	
}

?>