<?php
class obj_folder_list extends UIGraphic
{
	public function create($aConstruct)
	{
		parent::create($aConstruct);
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		/*cenda:*/
		$data = $oWMData->get('folder','list');

		$output = '';
		$delimiterString = '\/';
		if (isset($data['num'])) {
			$aFolders = array();
			foreach ($data['num'] as $folderNumber=>$folderDescription) {
				$aFolder = array();
				$splitNameArray = preg_split('/'.$delimiterString.'/',$folderDescription['name']);
				$splitLocalizedNameArray = preg_split('/'.$delimiterString.'/',$folderDescription['localizedName']);
				$depth = count($splitNameArray);
				//$output .= $folderNumber.'=>'.$folderDescription['localizedName'].':'.$depth.'<br/>';
				$break = '';
				$deep = 1;
				for(; $deep<$depth; $deep++) {
					$break .= '&nbsp;&nbsp;';
				}
	// co tim myslim: session je kontejner pro handlovani requestu, do ktereho se jednotlive requesty pridavaji, problem mechanismu, ktery umozni posilat vsechna data v jednom parametru (usera, jeho request, misto, kde zrovna je,... - coz je optimalni reseni) je slozitejsi, ma-li byt zachovana moznost vratit se navigacne tam, kde user skoncil v okamziku, kdy mu expirovala session (napr vlivem potizi na siti nebo v pripade sdilenych accountu vice lidmi, kteri si akorat predaji link)
	// to, ze se konstruovani anchoru handluje rovnou v php je jen zacatek, az si to schvalime, presunu to do templejt
				//$backRequest = 'requestId=nejakeRequestIdKtereJeResenoNaUrovniSession&amp;neco='.$folderDescription['id'];
				//$backRequest = 'rqstId=nejakeRequestId&amp;data=akceSParametryVDalsichGETech';
				//$output .= $break.'<a href="'.Tools::getServerURL().'?sid='.$oWMRequest->sSID.'&amp;folder='.$folderDescription['id'].'&amp;view='.$folderDescription['view'].'"><span class="folder">'.$splitLocalizedNameArray[($deep-1)].'</span></a>';
				$aFolder['break'] = $break;
				$aFolder['src'] = Tools::getServerURL().'?sid='.$oWMRequest->sSID.'&amp;folder='.$folderDescription['id'].'&amp;view='.$folderDescription['view'];
				$aFolder['name'] = $splitLocalizedNameArray[($deep-1)];
				$aFolders['num'][] = $aFolder;
			}
		}
//print_r($oWMData->get('folder','list'));
		/*cenda:*/
		$this->setTemplateData('folders',$aFolders);
		/*pavel:*
		$this->setTemplateData('folders',$oWMData->get('folder','list'));
		/*pavel*/
		$this->setTemplateData('sid',$oWMRequest->sSID);
	}
}
?>
