<?php
class obj_html extends UIGraphic
{
	
	public function create($aConstruct)
	{
		parent::create($aConstruct);
		$oXML = $this->getProperty('xml');
		$this->setTemplateData('title',WMUserInterface::getLanguageLabel(strval($oXML["title"])));
	}
	
	public function getBody(&$oXML)
	{
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		$sBody = parent::getBody($oXML);

		//Have to be called after getBody
		$aJavascript['num'] = $oWMUserInterface->getJavascript();
		$aStylesheet['num'] = $oWMUserInterface->getStylesheet();
		//Retrieve body
		$sTemplateFile = $this->getFile('template',$this->objID);
		$aTplData = $this->getProperty('aTemplate');

		$aTplData['javascript']=$aJavascript;
		$aTplData['stylesheet']=$aStylesheet;

		$sBody = template($sTemplateFile,$aTplData);
		return $sBody;
	}
}
?>