<?

class obj_mail_compose extends UIObject
{
	public function create($aConstruct)
	{
		parent::create($aConstruct);
		$oWMLanguage = &Singleton::instance('WMLanguage');
		$oWMData = &Singleton::instance('WMData');
		$oWMRequest = &Singleton::instance('WMRequest');
		$this->setProperty('isForm',true);
		//Data
		if($sMailTo = $oWMData->get('mail','to')){
			$this->setTemplateData('mail_to',$sMailTo);
		}
		if($sMailSubject = $oWMData->get('mail','subject')){
			$this->setTemplateData('mail_subject',$sMailSubject);
		}
		if($sMailBody = $oWMData->get('mail','body')){
			$this->setTemplateData('mail_body',$sMailBody);
		}
		if($sMailCC = $oWMData->get('mail','cc')){
			$this->setTemplateData('mail_cc',$sMailCC);
		}
		if($sMailBCC = $oWMData->get('mail','bcc')){
			$this->setTemplateData('mail_bcc',$sMailBCC);
		}
		if($sMailID = $oWMData->get('mail','id')){
			$this->setTemplateData('item',$sMailID);
		}
		$this->setTemplateData('sid',$oWMData->get('general','sid'));
		$this->setTemplateData('folder',$oWMData->get('general','folder'));
		//Groupware enabled ?
		$user = $_SESSION['user'];
		$account = $user->getAccount($_SESSION['EMAIL']);
		$this->setTemplateData('gw_enabled',true);
		try{
			if(!$account->gwAccount->gwAPI->isConnected()){
				throw new Exc('gw_disabled');
			}
		}catch(Exc $e){
			$this->setTemplateData('gw_enabled',false);
		}
	}
	//TODO :  move to UIGraphic!!!!!
	public function getBody(&$oXML)
	{
		//$t = time();
		//$m = microtime();
		$this->objCounter[] = array();

		$sResult = $sBody = '';
		$aBody = array();
		if($oXML) foreach($oXML as $sObjClass => $oObjXML){
			//Count objects for id
			
			if(!isset($this->objCounter[$sObjClass])){
				$this->objCounter[$sObjClass] = 1;
			}else{
				$this->objCounter[$sObjClass]++;
			}
			switch($sObjClass){
				case 'config':
				break;
				default:
					//Constructor data
					$aConstruct['objID'] = strval($sObjClass);
					$aConstruct['xml'] = $oObjXML;
					$aConstruct['parent'] = &$this;
					if(!$aConstruct['xml']['id']){
						$id = $sObjClass.$this->objCounter[$sObjClass];
						$aConstruct['xml']['id'] = $id;
					}else{
						$id = strval($aConstruct['xml']['id']);
					}
					//Load class
					$oObjClass = &WMUserInterface::safeInstance($aConstruct);
					if(is_object($oObjClass)){
						$oObjClass->create($aConstruct);
						$this->pData->aTemplate['obj'][$sObjClass][$id] = $oObjClass->getBody($oObjXML);
					}
				break;
			}
		}
		$sBody = template($this->sTemplateFile,$this->getProperty('aTemplate'));

		return $sBody;
	}
}

?>