<?php
//require_once('interface/inc/data/folder.php');

class obj_menu extends UIObject
{
	public function create($aConstruct)
	{
		parent::create($aConstruct);
		
		$oWMData = &Singleton::instance('WMData');
		$oWMUserInterface = &Singleton::instance('WMUserInterface');
		try{
			$this->setProperty('bAddForm',!$aConstruct['parent']->getProperty('isForm'));
		}catch(Exception $e){
			$this->setProperty('bAddForm',true);
		}
		$sDraftFolder = FolderExtension::getMappedFolder('drafts')->name;
		$this->setTemplateData('draftfolder',$sDraftFolder);
		
		$this->setTemplateData('sid',$oWMData->get('general','sid'));
		$this->setTemplateData('folder',$oWMData->get('general','folder'));
		$this->setTemplateData('view',$oWMUserInterface->getView());
	}

		
	public function getBody(&$oXML)
	{
		if($this->sTemplateFile){
			$aTemplate = $this->getProperty('aTemplate');
			$sMenu = template($this->sTemplateFile,$aTemplate);
			if($this->getProperty('bAddForm')){
				$aTemplate['menu'] = $sMenu;
				$sResult = template($this->getPath('template').'menu.tpl',$aTemplate);
			}else{
				$sResult = $sMenu;
			}
			return $sResult;
		}else{
			return '';
		}
	}
}

?>